package nccloud.web.hrbm.bmfile.action;

import java.util.Map;
import java.util.Set;


import nc.itf.bm.bmfile.IBmfileManageService;
import nc.itf.bm.bmfile.IBmfileQueryService;
import nc.vo.bm.data.BmDataVO;
import nc.vo.bm.pub.BmLoginContext;
import nc.vo.pub.lang.UFLiteralDate;
import nccloud.commons.lang.ArrayUtils;
import nccloud.commons.lang.StringUtils;
import nccloud.framework.service.ServiceLocator;
import nccloud.framework.web.container.IRequest;
import nccloud.web.hr.pub.HRCommonAction;
import nccloud.web.hrbm.helper.BmLoginContextUtils;
import nccloud.web.uapbd.commons.web.ParamUtils;

/**
 * н籣
 */
public class BatchSaveAction extends HRCommonAction {
	@Override
	public <T> Object execute(IRequest request, T para) throws Exception {
		ParamUtils param = new ParamUtils(request);
		BmLoginContext context = BmLoginContextUtils.getBmLoginContext(param);
		String pkBmClass = param.getString("pk_bmclass", null);
		String[] pkbms = pkBmClass.split(",");

		Map<String, String> pk_psnjob_map = param.getMap("pk_psnjob_map", null);
		
		Map<String, String> accountno_map = param.getMap("accountno_map", null);
		Set<String> set = pk_psnjob_map.keySet();//pk_psnjob_array
		BmDataVO[] bmDataVOs = ServiceLocator.find(IBmfileQueryService.class).queryPsnForAddNCC(context,
				set);
       
		// HashMap<String, Object> mm = bmDataVOs[0].appValueHashMap;
		if (bmDataVOs != null && bmDataVOs.length > 0) {
			for (int i = 0; i < bmDataVOs.length; i++) {
				// ȡ
				String pk_bm_data_array = pk_psnjob_map.get(bmDataVOs[i].getPk_psnjob());
				String[] split = pk_bm_data_array.split(",");
				if (!ArrayUtils.isEmpty(split)) {
					for (String pk_bm_data : split) {
						Object attributeValue = bmDataVOs[i].getAttributeValue(pk_bm_data);
						if (null == attributeValue) {
							bmDataVOs[i].setAttributeValue(pk_bm_data, "Y");
						}
					}
				}
				if (null != accountno_map) {
					String bmaccountno = accountno_map.get(bmDataVOs[i].getPk_psnjob());
					bmDataVOs[i].setBmaccountno(bmaccountno);
				}
				bmDataVOs[i].setCyear(context.getCyear());
				bmDataVOs[i].setCperiod(context.getCperiod());
				bmDataVOs[i].setPaylocation(null);
			}
		}

		BmDataVO[] classInfo = new BmDataVO[pkbms.length];
		for (int i = 0; i < classInfo.length; i++) {
			Map map = param.getMap(pkbms[i], null);
			classInfo[i] = new BmDataVO();
			classInfo[i].setPk_bm_class(pkbms[i]);
			if (StringUtils.isNotEmpty(map.get("newPaylocation").toString())) {
				classInfo[i].setPaylocation(map.get("newPaylocation").toString());
			}
			if (StringUtils.isNotEmpty(map.get("newDbegindate").toString())) {
				classInfo[i].setDbegindate(new UFLiteralDate(map.get("newDbegindate").toString()));
			}
		}
		ServiceLocator.find(IBmfileManageService.class).batchAddPsn(bmDataVOs, classInfo, context);
		return true;
	}

}
