package nccloud.web.hrbm.bmfile.action;

import com.alibaba.fastjson.JSONObject;
import nc.bs.logging.Logger;
import nc.hr.utils.MultiLangHelper;
import nc.hr.utils.StringPiecer;
import nc.itf.bm.bmfile.IBmfileQueryService;
import nc.itf.hr.bm.IBmClassQueryService;
import nc.itf.hr.frame.IPersistenceRetrieve;
import nc.md.model.type.IType;
import nc.vo.bm.bmclass.BmClassConstant;
import nc.vo.bm.bmclass.BmClassItemVO;
import nc.vo.bm.data.BmDataVO;
import nc.vo.bm.item.BmFromEnumVO;
import nc.vo.bm.pub.BmLoginContext;
import nc.vo.hr.combinesort.SortVO;
import nc.vo.hr.combinesort.SortconVO;
import nc.vo.hr.itemsource.TypeEnumVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.SuperVO;
import nc.vo.uif2.LoginContext;
import nccloud.base.exception.ExceptionUtils;
import nccloud.commons.collections.CollectionUtils;
import nccloud.commons.lang.ArrayUtils;
import nccloud.commons.lang.StringUtils;
import nccloud.framework.service.ServiceLocator;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.ui.config.Area;
import nccloud.framework.web.ui.config.Item;
import nccloud.framework.web.ui.config.PageTemplet;
import nccloud.framework.web.ui.meta.ComponentType;
import nccloud.framework.web.ui.model.row.Cell;
import nccloud.framework.web.ui.model.row.Row;
import nccloud.web.hr.excel.action.AbstractExcelExportAction;
import nccloud.web.hr.pub.HRNccQueryHelper;
import nccloud.web.hr.pub.HRNccTemplateUtils;
import nccloud.web.hrbm.helper.BmLoginContextUtils;

import java.util.List;
import java.util.Map;

/**
 * 籣/ģ
 */
public class BmfileExportAction extends AbstractExcelExportAction {
    // Ҫĵ
    private BmDataVO[] dataVOs = null;
    // excel 
    private Area exportExcelArea = null;
    @Override
    protected void extendFieldProcess(Map<String, Row[]> rowsMap, Map<String, List<CircularlyAccessibleValueObject>> vosMap, Map<String, List<Item>> listBillItemsMap) {
        List<Item> items = listBillItemsMap.get("excel-template");
        if(items!=null && items.size()>0){
            items.removeIf(e->"paylocation".equals(e.getCode()));
        }
        Row [] rows = rowsMap.get("excel-template");
        List<CircularlyAccessibleValueObject> vos = vosMap.get("excel-template");
        if (ArrayUtils.isEmpty(rows) || CollectionUtils.isEmpty(vos)) {
            return;
        }
        for (int i = 0; i < rows.length; i++) {
            Row row = rows[i];
            BmDataVO vo = (BmDataVO) vos.get(i);
            //ȡĿ޸Ŀȡ20201204
            //List<Item> listBillItems = listBillItemsMap.get("listBillItemsMap");
            if (exportExcelArea == null || CollectionUtils.isEmpty(exportExcelArea.getItemList())) {
                return;
            }
            List<Item> listBillItems = exportExcelArea.getItemList();
            for (Item item : listBillItems) {
                String key = item.getCode();
                Cell cell = row.getCell(key);
                if (cell != null) {
                    continue;
                }
                cell = new Cell();
                Object cellVal = vo.getAttributeValue(key);
                /*if(key.startsWith("f_")||key.startsWith("c_")||key.startsWith("d_")){

                }*/
                cell.setValue(cellVal);
                row.addCell(key, cell);
            }
        }
        listBillItemsMap.put("excel-template",exportExcelArea.getItemList());
    }

    /**
     *
     * @param param
     * @return
     */
    @Override
    protected String getAppCode(Map<String,String> param) {
        return "60150501";
    }

    /**
     *
     * @param param
     * @return
     */
    @Override
    protected String getPageCode(Map<String,String> param) {
        return "60150501";
    }

    /**
     *
     * @param param
     * @return
     */
    @Override
    protected String getAreaCode(Map<String,String> param) {
        return "excel-template";
    }

    /**
     *
     * @param context
     * @param paramMap
     * @return
     */
    @Override
    protected SuperVO[] getData(LoginContext context, Map<String, String> paramMap) {
        try {
            BmLoginContext bmLoginContext = BmLoginContextUtils.getBmLoginContextForRef(paramMap);
            IBmfileQueryService service = ServiceLocator.find(IBmfileQueryService.class);
            HRNccQueryHelper queryHelper = new HRNccQueryHelper(JSONObject.toJSONString(paramMap), true);
            String lastWhereSql = null;
            if (StringUtils.isNotEmpty(queryHelper.getWhereSql())) {
                lastWhereSql = queryHelper.getWhereSql();// ѯģwhere
            }
            // ǰ̨ݵ
            String modelStr = paramMap.get("modelStr");
            String orderSQL = getOrderSql(bmLoginContext, modelStr);
            String[] pks = service.queryPKSByCondition(bmLoginContext, lastWhereSql, orderSQL);
            int datasize = ArrayUtils.isEmpty(pks) ? 0 : pks.length;
            dataVOs = new BmDataVO[datasize];
            dataVOs = service.queryBmDataByPks(pks,bmLoginContext,orderSQL);
        } catch (Exception e) {
            Logger.error(e.getMessage());
            ExceptionUtils.wrapBusinessException(e.getMessage());
        }
        return dataVOs;
    }

    /**
     *
     * @param loginContext
     * @param modelStr
     * @return
     * @throws BusinessException
     */
    private String getOrderSql(LoginContext loginContext, String modelStr) throws BusinessException {
        String orderSQL = "";
        SortconVO[] sortconVOs = (modelStr == null || "".equals(modelStr) || "{}".equals(modelStr)) ? null
                : HRNccTemplateUtils.getVOFromGrid(SortconVO.class, modelStr);
        if (sortconVOs != null && sortconVOs.length > 0) {
            orderSQL = getOrderSql(sortconVOs);
        } else {
            // ========Ӻ̨ѯsql
            String strCondition = " func_code='60150bmfile'" + " and group_code='TableCode' and ((pk_corp='"
                    + loginContext.getPk_group() + "' and pk_user='" + loginContext.getPk_loginUser()
                    + "') or pk_corp ='@@@@') order by pk_corp";
            SortVO sortVOs[] = (SortVO[]) ServiceLocator.find(IPersistenceRetrieve.class).retrieveByClause(null,
                    SortVO.class, strCondition);
            if (sortVOs != null && sortVOs.length != 0) {
                // ѡĿ
                strCondition = "pk_hr_sort='" + sortVOs[0].getPrimaryKey() + "' order by field_seq ";
                sortconVOs = (SortconVO[]) ServiceLocator.find(IPersistenceRetrieve.class).retrieveByClause(null,
                        SortconVO.class, strCondition);
                orderSQL = getOrderSql(sortconVOs);
            }
        }
        return orderSQL;
    }

    /**
     *
     * @param sortconVOs
     * @return
     */
    private String getOrderSql(SortconVO[] sortconVOs) {
        String orderSQL = null;
        // asc, desc
        String isRaise = "";
        if (sortconVOs.length > 0) {
            orderSQL = "";
        } else {
            return orderSQL;
        }
        for (int i = 0; i < sortconVOs.length - 1; i++) {
            isRaise = "Y".equals(sortconVOs[i].getAscend_flag().toString()) ? " asc " : " desc ";
            orderSQL += sortconVOs[i].getField_code() + isRaise + ",";
        }
        isRaise = "Y".equals(sortconVOs[sortconVOs.length - 1].getAscend_flag().toString()) ? " asc " : " desc ";
        orderSQL += sortconVOs[sortconVOs.length - 1].getField_code() + isRaise;
        return orderSQL;
    }

    /**
     *
     * @param param
     * @return
     */
    @Override
    protected String getFileName(Map<String,String> param) {
        return "bmfile_excel";
    }

    /**
     *
     * @return
     */
    @Override
    protected String importValidatorFactory() {
        return "nccloud.impl.hrbm.bmfile.BmfileImportDataProcessServiceImpl";
    }

    /**
     *
     * @return
     */
    @Override
    protected String getCurrentModule() {
        return "hrbm";
    }

    /**
     *
     * @param request
     * @param param
     * @return
     */
    @Override
    protected LoginContext getContext(IRequest request,Map<String,String> param) {
        BmLoginContext bmLoginContext = null;
        try {
            bmLoginContext = BmLoginContextUtils.getBmLoginContextForRef(param);
        } catch (BusinessException e) {
            Logger.error(e.getMessage());
        }
        return bmLoginContext;
    }

    /**
     * ΪҪexcelģԶĵĿ
     * @param pageTemplet
     * @param context
     * @param param
     */
    @Override
    protected void templateProcess(PageTemplet pageTemplet, LoginContext context,Map<String, String> param) {
        try {
            BmLoginContext bmLoginContext = null;
            if (context instanceof BmLoginContext) {
                bmLoginContext = (BmLoginContext) context;
            }
            if (bmLoginContext == null) {
                Logger.error("ڼǷȷ");
                ExceptionUtils.wrapBusinessException("ڼǷȷ");
            }
            // û籣ҪexcelĿ
            String[] pkBmClasses = getPkBmClasses(context, param);
            if (ArrayUtils.isEmpty(pkBmClasses)) {
                return;
            }
            // excelģ
            Area area = pageTemplet.getArea("excel-template");
            // ȡĿ
            String condition = " category_id = '" + BmClassConstant.DOC_CATEGORY_ID + "'";
            BmClassItemVO[] classItemVOS = ServiceLocator.find(IBmClassQueryService.class).queryFileClassItem(bmLoginContext.getCyear(), bmLoginContext.getCperiod(), pkBmClasses);
           // BmItemVO[] bmItemVOS = ServiceLocator.find(IBmItemQueryService.class).queryByCondition(context, condition);
            if (ArrayUtils.isEmpty(classItemVOS)) {
                exportExcelArea = area;
                return;
            }
            //excelģ׷Զ(Ŀ)
            for (BmClassItemVO itemVO : classItemVOS) {
                boolean flag = itemVO.getIfromflag().intValue() == BmFromEnumVO.USER_INPUT.toIntValue();
                Item item = area.getItemByCode(itemVO.getItemkey());
                if (item == null) {
                    item = getDefaultItem();
                    area.addItem(item);
                }
                item.setDisabled(!flag);
                item.setLabel(MultiLangHelper.getName(itemVO));
                item.setVisible(true);
                item.setFieldValued("refpk");
                item.setFieldDisplayed("refcode");
                item.setCode(itemVO.getItemkey());
                int type = itemVO.getIitemtype().intValue();
                if (type == TypeEnumVO.FLOATTYPE.toIntValue()) {
                    item.setItemtype(ComponentType.Number);
                    item.setDatatype(IType.TYPE_UFDouble);
                    item.setDataval(itemVO.getIflddecimal() + ",-100000000000000000000,100000000000000000000");
                    item.setMaxlength(31);
                } else if (type == TypeEnumVO.DATETYPE.toIntValue()) {
                    item.setItemtype(ComponentType.Datetimepicker);
                    item.setDatatype(34);
                    item.setMaxlength(31);
                } else if (type == TypeEnumVO.CHARTYPE.toIntValue()) {
                    item.setItemtype(ComponentType.Input);
                    item.setDatatype(1);
                    item.setMaxlength(31);
                }
            }
            exportExcelArea = (Area)area.clone();
            List<Item> itemList = exportExcelArea.getItemList();
            itemList.removeIf(e->e.getCode().equals("paylocation"));
        } catch (BusinessException | CloneNotSupportedException e) {
            Logger.error(e.getMessage());
            ExceptionUtils.wrapBusinessException(e.getMessage());
        }
    }

    /**
     * ȡ
     * @return
     */
    private String[] getPkBmClasses(LoginContext context,Map<String, String> param){
        Object[] vos = getData(context, param);
        if (vos instanceof BmDataVO[]) {
            dataVOs = (BmDataVO[]) vos;
        }
        return StringPiecer.getStrArrayDistinct(dataVOs,"pk_bm_class");
    }

//    @Override
//    protected Map<String, String> getKeyInfo(Map<String, String> paramMap) throws BusinessException {
//      /*  BmLoginContext bmLoginContext = BmLoginContextUtils.getBmLoginContextForRef(paramMap);
//        Map<String,String> param=new HashMap<>();
//        param.put("cyear",bmLoginContext.getCyear());
//        param.put("cpriod",bmLoginContext.getCperiod());
//        return param;*/
//        return null;
//    }
}
