package nccloud.web.hrbm.bmfile.action;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import nc.bs.dao.BaseDAO;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.hr.utils.InSQLCreator;
import nc.itf.bm.bmfile.IBmfileManageService;
import nc.itf.bm.bmfile.IBmfileQueryService;
import nc.itf.bm.bmfile.IHRBmfileConstant;
import nc.jdbc.framework.processor.BeanListProcessor;
import nc.vo.bm.data.BmDataVO;
import nc.vo.bm.pub.BmLoginContext;
import nc.vo.hi.psndoc.PsnJobVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFBoolean;
import nccloud.commons.collections.CollectionUtils;
import nccloud.framework.core.json.IJson;
import nccloud.framework.service.ServiceLocator;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.json.JsonFactory;
import nccloud.web.hr.pub.HRCommonAction;
import nccloud.web.hr.pub.HRNccTemplateUtils;
import nccloud.web.hrbm.helper.BmLoginContextUtils;
import nccloud.web.uapbd.commons.web.ParamUtils;

/**
 * 䶯Ա
 * 
 * @author 
 *
 */
public class OLTP_AddAction extends HRCommonAction {
	@Override
	public <T> Object execute(IRequest request, T para) throws Exception {
        //Աż
		List<String> pkPsnjobList = new ArrayList<>();
		ParamUtils param = new ParamUtils(request);
		BmLoginContext context = BmLoginContextUtils.getBmLoginContext(param);
		BmDataVO[] bmDataVOs = HRNccTemplateUtils.getVOFromGrid(BmDataVO.class, getModelStr(param, "model"));
		BmDataVO[] bmDataVO = ServiceLocator.find(IBmfileQueryService.class).getPkFinanceOrg(bmDataVOs);
		List<BmDataVO> list = new ArrayList<BmDataVO>();
		if (bmDataVO != null && bmDataVO.length > 0) {
			for (int i = 0; i < bmDataVO.length; i++) {
				bmDataVO[i].setCyear(context.getCyear());
				bmDataVO[i].setCperiod(context.getCperiod());
				bmDataVO[i].setPk_org(context.getPk_org());
				bmDataVO[i].setCaculateflag(UFBoolean.FALSE);
				bmDataVO[i].setCheckflag(UFBoolean.FALSE);
				bmDataVO[i].setAccountstate(0);
				bmDataVO[i].setAccounttype(1);
				pkPsnjobList.add(bmDataVO[i].getPk_psnjob());
			}
		}
        //Աźpk_psnjobӳϵ
        Map<String, PsnJobVO> jobMap = getPsnjobMap(pkPsnjobList);
		String pkBmClass = param.getString("pk_bmclass", null);
		String[] pkbms = pkBmClass.split(",");
		String s = getModelStr(param, "model");
		JSONObject object = JSON.parseObject(s);
		JSONObject jsobject = (JSONObject) JSONObject.toJSON(object.get("model"));
		JSONArray bodys = jsobject.getJSONArray("rows");
		if (null != bodys && !bodys.isEmpty()) {
			for (int i = 0; i < bodys.size(); i++) {
				JSONObject obj = bodys.getJSONObject(i).getJSONObject("values");
				for (int j = 0; j < pkbms.length; j++) {
					if ("true".equals(obj.getJSONObject(pkbms[j]).get("value").toString())) {
						bmDataVO[i].setPk_bm_class(pkbms[j]);
		                PsnJobVO jobVO = jobMap.get(bmDataVO[i].getPk_psnjob());
		                ensureBmData(bmDataVO[i], jobVO);
						list.add((BmDataVO) bmDataVO[i].clone());
					}
				}
			}
		}
		BmDataVO[] bmDataVO2 = list.toArray(new BmDataVO[0]);
		ServiceLocator.find(IBmfileManageService.class).insertBmDataVOs(bmDataVO2, context);
		return true;
	}

	public static String getModelStr(ParamUtils param, String fieldName) {
		if (fieldName == null) {
			fieldName = "model";
		}
		IJson json = JsonFactory.create();
		HashMap m = new HashMap();
		m.put("model", param.get(fieldName));
		return json.toJson(m);
	}
	
    private void ensureBmData(BmDataVO vo, PsnJobVO jobVO) {
        vo.setPk_group(InvocationInfoProxy.getInstance().getGroupId());
        vo.setPk_psnjob(jobVO.getPk_psnjob());//Աpk_psnjob
        vo.setPk_psndoc(jobVO.getPk_psndoc());//Աpk_psndoc
        vo.setWorkorg(jobVO.getPk_org()); //ְ֯
        vo.setWorkdept(jobVO.getPk_dept()); //ְ
        vo.setWorkorgvid(jobVO.getPk_org_v()); //ְ֯
        vo.setWorkdeptvid(jobVO.getPk_dept_v()); //ְ
        vo.setPk_psnorg(jobVO.getPk_psnorg());
        vo.setPk_group(jobVO.getPk_group());
        vo.setCaculateflag(UFBoolean.FALSE);
        vo.setCheckflag(UFBoolean.FALSE);
        vo.setAccountstate(IHRBmfileConstant.ACCOUNTSTATE_NORMAL);
        vo.setAccounttype(IHRBmfileConstant.ACCOUNTTYPE_NEW);
        vo.setGlbdef1((String)jobVO.getAttributeValue("jobglbdef6"));
        vo.setGlbdef2((String)jobVO.getAttributeValue("jobglbdef5"));
    }
    
	/**
     * Աźpk_psnjobӳϵ
     * @return
     */
    @SuppressWarnings("ncc-java:AccessToDBInWeb")
    private Map<String, PsnJobVO> getPsnjobMap(List<String> pkPsnjobList) {
        Map<String, PsnJobVO> jobMap = null;
        BaseDAO dao = new BaseDAO();
        List<PsnJobVO> jobVOList = null;
        try {
            //ѯְ
            StringBuffer sqlBuffer = new StringBuffer();
            sqlBuffer.append("select hi_psnjob.pk_psnjob, "); // 1
            sqlBuffer.append("       hi_psnjob.pk_psnorg, "); // 2
            sqlBuffer.append("       hi_psnjob.assgid, "); // 3
            sqlBuffer.append("       hi_psnjob.pk_psndoc, "); // 4
            sqlBuffer.append("       hi_psnjob.clerkcode, "); // 5
            sqlBuffer.append("       hi_psnjob.jobglbdef6, "); // ERP֯
            sqlBuffer.append("       hi_psnjob.jobglbdef5, "); // ERP
            sqlBuffer.append("       org_orgs.PK_GROUP, ");
            sqlBuffer.append("       org_orgs.pk_org, ");
            sqlBuffer.append("       org_orgs.pk_vid as pk_org_v, ");
            sqlBuffer.append("       org_dept.pk_dept, ");
            sqlBuffer.append("       org_dept.pk_vid as pk_dept_v ");
            sqlBuffer.append("  from hi_psnjob ");
            sqlBuffer.append(" inner join bd_psndoc on bd_psndoc.pk_psndoc = hi_psnjob.pk_psndoc ");
            sqlBuffer.append(" inner join hi_psnorg on hi_psnorg.pk_psnorg = hi_psnjob.pk_psnorg ");
            sqlBuffer.append("  left outer join org_dept on org_dept.pk_dept = hi_psnjob.pk_dept ");
            sqlBuffer.append("  left outer join org_orgs on org_orgs.pk_org = hi_psnjob.pk_org ");
            sqlBuffer.append(" where hi_psnjob.pk_psnjob  in (" + new InSQLCreator().getInSQL(pkPsnjobList.toArray(new String[0])) + ")");
            jobVOList = (List<PsnJobVO>) dao.executeQuery(sqlBuffer.toString(), new BeanListProcessor(PsnJobVO.class));
            if (CollectionUtils.isEmpty(jobVOList)) {
                return null;
            } else {
                jobMap = new HashMap<>();
            }
        } catch (BusinessException e) {
            e.printStackTrace();
        }
        if (!CollectionUtils.isEmpty(jobVOList)) {
        	for (PsnJobVO jobVO : jobVOList) {
                jobMap.put(jobVO.getPk_psnjob(), jobVO);
            }
        }
        
        return jobMap;
    }

}
