package nc.impl.bm.bmdata;

import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.common.NCLocator;
import nc.hr.bm.log.BmBusilogUtil;
import nc.hr.frame.persistence.IValidatorFactory;
import nc.hr.frame.persistence.SimpleDocServiceTemplate;
import nc.hr.utils.CommonUtils;
import nc.hr.utils.InSQLCreator;
import nc.hr.utils.PubEnv;
import nc.hr.utils.ResHelper;
import nc.hr.utils.SQLHelper;
import nc.impl.bm.bmclass.BmClassDao;
import nc.itf.bm.bmdata.IBmdataManageService;
import nc.itf.bm.bmdata.IBmdataQueryService;
import nc.itf.hi.IPersonRecordService;
import nc.itf.hr.bm.BmdataDspUtil;
import nc.itf.hr.bm.IBmAmoQueryService;
import nc.itf.hr.bm.IBmClassQueryService;
import nc.itf.hr.bm.IBmPub;
import nc.itf.hr.bm.IHRBMActionCode;
import nc.jdbc.framework.processor.MapListProcessor;
import nc.pubitf.rbac.IDataPermissionPubService;
import nc.vo.bd.util.StringUtil;
import nc.vo.bm.bmclass.BmClassConstant;
import nc.vo.bm.bmclass.BmClassItemVO;
import nc.vo.bm.bmclass.BmClassVO;
import nc.vo.bm.bmclass.BmFiorgVO;
import nc.vo.bm.data.BmDataVO;
import nc.vo.bm.data.BmdataDspVO;
import nc.vo.bm.data.BmdataShowInfVO;
import nc.vo.bm.data.IBmCommonAlterName;
import nc.vo.bm.end.BmClassEndVO;
import nc.vo.bm.locationrule.LocationRule;
import nc.vo.bm.period.BmPeriodVO;
import nc.vo.bm.period.BmPeriodstateVO;
import nc.vo.bm.pub.BmLoginContext;
import nc.vo.bm.pub.BmLoginVO;
import nc.vo.bm.pub.BmMetaDataConstant;
import nc.vo.bm.pub.BmPowerSqlHelper;
import nc.vo.bm.pub.IHRBMDataResCode;
import nc.vo.bm.pub.WherePartBmUtil;
import nc.vo.hi.psndoc.BminfoVO;
import nc.vo.hi.pub.HICommonValue;
import nc.vo.hr.append.AppendableVO;
import nc.vo.hr.caculate.CaculateTypeVO;
import nc.vo.hrp.budgetmgt.BudgetWarnMessageVo;
import nc.vo.hrp.func.WherePartUtil;
import nc.vo.pub.BusinessException;
import nc.vo.pub.SuperVO;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDouble;
import nc.vo.util.BDPKLockUtil;
import nc.vo.util.BDVersionValidationUtil;
import nccloud.commons.lang.ArrayUtils;
import nccloud.commons.lang.StringUtils;

import javax.naming.NamingException;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author xuanlt
 */
public class BmdataManageServiceImpl  implements IBmdataManageService, IBmdataQueryService
{
	private BmdataQueryDAO bmdataQueryDAO;

	private BmdataBudgetAlarmDao bmdataBudgetAlarmDao;

	private final String DOC_NAME = "Bmdata";

	private SimpleDocServiceTemplate serviceTemplate;

	public void setValidatorFactory(IValidatorFactory docValidatorFactory)
	{
		getServiceTemplate().setValidatorFactory(docValidatorFactory);
	}
	public BmdataQueryDAO getBmdataQueryDAO() {
		if(bmdataQueryDAO==null){
			bmdataQueryDAO = new BmdataQueryDAO();
		}
		return bmdataQueryDAO;
	}


	/***************************************************************************
	 * <br>Created on 2012-8-8 1:20:59<br>
	 * @return
	 * @author daicy
	 ***************************************************************************/
	public BmdataBudgetAlarmDao getBmdataBudgetAlarmDao() {
		if(bmdataBudgetAlarmDao==null){
			bmdataBudgetAlarmDao = new BmdataBudgetAlarmDao();
		}
		return bmdataBudgetAlarmDao;
	}

	private SimpleDocServiceTemplate getServiceTemplate()
	{
		if(serviceTemplate==null)
		{
			serviceTemplate = new SimpleDocServiceTemplate(DOC_NAME);
			serviceTemplate.setLocker(new BmDataLocker());
		}

		return serviceTemplate;
	}

	@Override
	public BmDataVO[] queryByCondition(BmLoginContext context ,String condition,String orderby) throws BusinessException
	{
		//		SqlWhereUtil squ = new SqlWhereUtil();
		//		squ.s("pk_org='"+IOrgConst.GLOBEORGTYPE+"'" ).or("pk_org='"+context.getPk_org()+"'").enclose();
		//
		//		if(!StringUtil.isEmptyWithTrim(condition)){
		//			squ.and().l().s(condition).r();
		//		}




		/*		//ͨڼѯ
		if(StringUtils.isEmpty(condition)){
			condition = context.getPk_bm_class()==null?"  bm_data.pk_org = '" + context.getPk_org():"  bm_data.pk_bm_class = '" + context.getPk_bm_class() +  "' and bm_data.cyear = '"+ context.getCyear() +"' and bm_data.cperiod = '"+ context.getCperiod()+"'";

		}else{
			condition += context.getPk_bm_class()==null?" and  bm_data.pk_org = '" + context.getPk_org():" and  bm_data.pk_bm_class = '" + context.getPk_bm_class() +  "' and bm_data.cyear = '"+ context.getCyear() +"' and bm_data.cperiod = '"+ context.getCperiod()+"'";

		}*/
		return getBmdataQueryDAO().queryByCondition(context,  condition,orderby);
	}



	@Override
	public BmDataVO queryByPk(String pk) throws BusinessException
	{
		return getServiceTemplate().queryByPk(BmDataVO.class, pk);
	}





	@Override
	public void delete(BmDataVO vo) throws BusinessException
	{
		getServiceTemplate().delete(vo);
	}

	@Override
	public BmDataVO insert(BmDataVO vo) throws BusinessException
	{
		return getServiceTemplate().insert(vo);
	}

	@Override
	public BmDataVO update(BmDataVO vo) throws BusinessException
	{

		return getServiceTemplate().update(vo, true);
	}

	@Override
	public BmDataVO disable(BmDataVO vo) throws BusinessException
	{
		return getServiceTemplate().sealObject(vo, true);
	}

	@Override
	public BmDataVO enable(BmDataVO vo) throws BusinessException
	{
		return getServiceTemplate().unSealObject(vo, true);
	}

	/***************************************************************************
	 * <br>Created on 2012-8-6 2:22:30<br>
	 * @param BminfoVO
	 * @return
	 * @throws BusinessException
	 * @author daicy
	 ***************************************************************************/
	public  BminfoVO bmDataVOToBminfoVO(BmDataVO bmDataVO,BmClassVO  bmClassVO,LocationRule locationRule) throws BusinessException{

		BminfoVO bminfoVO = new BminfoVO();
		bminfoVO.setPk_org(bmDataVO.getPk_org());
		if(null != bmClassVO) {
			bminfoVO.setBmclass(bmClassVO.getName());
			bminfoVO.setBmclass2(bmClassVO.getName2());
			bminfoVO.setBmclass3(bmClassVO.getName3());
			bminfoVO.setBmclass4(bmClassVO.getName4());
			bminfoVO.setBmclass5(bmClassVO.getName5());
			bminfoVO.setBmclass6(bmClassVO.getName6());
		}
		bminfoVO.setBmaccount(bmDataVO.getBmaccountno());
		//bminfoVO.setPaylocation(bmDataVO.getPostname());
		if(null != locationRule) {
			bminfoVO.setPaylocation(locationRule.getPostalname());
		}
		bminfoVO.setAccountdate(bmDataVO.getDbegindate());
		bminfoVO.setAccountstate(bmDataVO.getAccountstate());
		bminfoVO.setPeriod(bmDataVO.getCyear()+""+bmDataVO.getCperiod());
		bminfoVO.setYearbalance(bmDataVO.getAttributeValue("f_14") == null ? null:(UFDouble)bmDataVO.getAttributeValue("f_14"));
		bminfoVO.setPeriodbalance(bmDataVO.getAttributeValue("f_15") == null ? null:(UFDouble)bmDataVO.getAttributeValue("f_15"));
		bminfoVO.setTotalcorpus(bmDataVO.getAttributeValue("f_16") == null ? null:(UFDouble)bmDataVO.getAttributeValue("f_16"));
		bminfoVO.setPk_group(bmDataVO.getPk_group());
		//    	bminfoVO.setCreator(bmDataVO.getc)
		//    	bminfoVO.setCreationtime(bmDataVO.getc)
		//    	bminfoVO.setModifier(bmDataVO.getm)
		//    	bminfoVO.setModifiedtime(bmDataVO.)
		bminfoVO.setPk_psndoc(bmDataVO.getPk_psndoc());
		bminfoVO.setPk_insurance(bmDataVO.getPk_bm_class());
		//    	bminfoVO.setRecordnum(bmDataVO.getr)
		//bminfoVO.setTs(bmDataVO.getTs());
		//    	bminfoVO.setLastflag(bmDataVO.getl)
		SimpleDocServiceTemplate.setAuditInfoAndTs(bminfoVO, true);


		return bminfoVO;
	}


	/***************************************************************************
	 * <br>Created on 2012-9-5 10:12:14<br>
	 * @return
	 * @author daicy
	 ***************************************************************************/
	private IPersonRecordService getIPersonRecordService()
	{
		return NCLocator.getInstance().lookup(IPersonRecordService.class);
	}

	/***************************************************************************
	 * <br>Created on 2012-9-5 11:00:12<br>
	 * @param bmDatas
	 * @throws BusinessException
	 * @author daicy
	 ***************************************************************************/
	private  void bmDataSaveToBminfoVO(BmDataVO[] bmDatas) throws BusinessException{
		//ͬhiݡ

		if( null != bmDatas){
			//			 Map<String, BminfoVO[]> bminfos = new HashMap<String, BminfoVO[]> ();
			//             BminfoVO[] bminfoVOs = new BminfoVO[bmDatas.length];
			//             for( int i = 0 ; i < bmDatas.length ; i++) {
			//            	 bminfoVOs[i] = BmDataVOToBminfoVO(bmDatas[i]);
			//            	 bminfos.put(bmDatas[i].getPk_psndoc(),bminfoVOs);
			//             }
			//             getIPersonRecordService().syncPsnBmInfo(bminfos);
			Map<String,BmClassVO> map = new HashMap<String,BmClassVO> ();
			BmClassVO  bmClassVo = null;
			ArrayList<String> list4Class = new ArrayList<String>();
			for (int i = 0; i < bmDatas.length; i++) {
				list4Class.add(bmDatas[i].getPk_bm_class());
			}
			String[] classPKs = list4Class.toArray(new String[0]);
			InSQLCreator isc = new InSQLCreator();
			String sql = "select * from bm_bmclass where pk_bm_class in ("+isc.getInSQL(classPKs)+")";
			BmClassVO[] classVOs ;
			try {
				classVOs = getBmdataQueryDAO().executeQueryVOs(sql, BmClassVO.class);
			} finally{
				isc.clear();
			}
			if (classVOs != null) {
				for (int i = 0; i < classVOs.length; i++) {
					map.put(classVOs[i].getPk_bm_class(), classVOs[i]);
				}
			}

			Map<String, LocationRule> locationRules = new HashMap<String, LocationRule> ();
			LocationRule locationRule = null ;

			Map<String, List<BminfoVO>> bminfoLists = new HashMap<String, List<BminfoVO>> ();
			
			
			
			for( int i = 0 ; i < bmDatas.length ; i++) {
				List<BminfoVO> bminfoList = bminfoLists.get(bmDatas[i].getPk_bm_class());
				if( null == bminfoList){
					bminfoList  = new ArrayList<BminfoVO>();
				}

				bmClassVo = map.get(bmDatas[i].getPk_bm_class());
//				if(null == bmClassVo){
//					bmClassVo = getBmdataQueryDAO().retrieveByPK(BmClassVO.class,bmDatas[i].getPk_bm_class());
////					bmClassVo = getServiceTemplate().queryByPk(BmClassVO.class,bmDatas[i].getPk_bm_class());
//					map.put(bmDatas[i].getPk_bm_class(), bmClassVo);
//				}

				locationRule = locationRules.get(bmDatas[i].getPk_bm_class());
				if(null == locationRule && null != bmDatas[i].getPaylocation() ){
					locationRule = getServiceTemplate().queryByPk(LocationRule.class,bmDatas[i].getPaylocation());
					locationRules.put(bmDatas[i].getPaylocation(), locationRule);
				}


				bminfoList.add(bmDataVOToBminfoVO(bmDatas[i],bmClassVo,locationRule));
				bminfoLists.put(bmDatas[i].getPk_bm_class(),bminfoList);
			}


			String[] bmPKs = bminfoLists.keySet().toArray(new String[0]);
			for (String pk : bmPKs){
				List<BminfoVO> list = bminfoLists.get(pk);
				Map<String, BminfoVO> bminfos = new HashMap<String, BminfoVO> ();
				for(BminfoVO bmVo : list){
					bminfos.put(bmVo.getPk_psndoc(),bmVo);
				}
				getIPersonRecordService().syncPsnBmInfo(bminfos,pk);

			}

		}

	}

	/***************************************************************************
	 * <br>Created on 2012-9-5 10:59:58<br>
	 * @param bmDatas
	 * @throws BusinessException
	 * @author daicy
	 ***************************************************************************/
	private  void bmDataDeleteToBminfoVO(BmDataVO[] bmDatas) throws BusinessException{
		//ͬhiݡ
		if( null != bmDatas){
			Map<String,BmClassVO> map = new HashMap<String,BmClassVO> ();
			BmClassVO  bmClassVo = null;
			ArrayList<String> list4Class = new ArrayList<String>();
			for (int i = 0; i < bmDatas.length; i++) {
				list4Class.add(bmDatas[i].getPk_bm_class());
			}
			String[] classPKs = list4Class.toArray(new String[0]);
			InSQLCreator isc = new InSQLCreator();
			String sql = "select * from bm_bmclass where pk_bm_class in ("+isc.getInSQL(classPKs)+")";
			BmClassVO[] classVOs ;
			try {
				classVOs = getBmdataQueryDAO().executeQueryVOs(sql, BmClassVO.class);
			} finally{
				isc.clear();
			}
			if (classVOs != null) {
				for (int i = 0; i < classVOs.length; i++) {
					map.put(classVOs[i].getPk_bm_class(), classVOs[i]);
				}
			}

			Map<String, LocationRule> locationRules = new HashMap<String, LocationRule> ();
			LocationRule locationRule = null ;

			Map<String, List<BminfoVO>> bminfoLists = new HashMap<String, List<BminfoVO>> ();
			for( int i = 0 ; i < bmDatas.length ; i++) {
				List<BminfoVO> bminfoList = bminfoLists.get(bmDatas[i].getPk_bm_class());
				if( null == bminfoList){
					bminfoList  = new ArrayList<BminfoVO>();
				}

				bmClassVo = map.get(bmDatas[i].getPk_bm_class());
//				if(null == bmClassVo){
//					bmClassVo = getBmdataQueryDAO().retrieveByPK(BmClassVO.class,bmDatas[i].getPk_bm_class());
////					bmClassVo = getServiceTemplate().queryByPk(BmClassVO.class,bmDatas[i].getPk_bm_class());
//					map.put(bmDatas[i].getPk_bm_class(), bmClassVo);
//				}


				locationRule = locationRules.get(bmDatas[i].getPk_bm_class());
				if(null == locationRule && null != bmDatas[i].getPaylocation() ){
					locationRule = getServiceTemplate().queryByPk(LocationRule.class,bmDatas[i].getPaylocation());
					locationRules.put(bmDatas[i].getPaylocation(), locationRule);
				}


				bminfoList.add(bmDataVOToBminfoVO(bmDatas[i],bmClassVo,locationRule));
				bminfoLists.put(bmDatas[i].getPk_bm_class(),bminfoList);
			}


			String[] bmPKs = bminfoLists.keySet().toArray(new String[0]);
			for (String pk : bmPKs){
				List<BminfoVO> list = bminfoLists.get(pk);
				Map<String, BminfoVO> bminfos = new HashMap<String, BminfoVO> ();
				for(BminfoVO bmVo : list){
					bminfos.put(bmVo.getPk_psndoc(),null);
				}
				getIPersonRecordService().syncPsnBmInfo(bminfos,pk);

			}

			//			 Map<String, BminfoVO[]> bminfos = new HashMap<String, BminfoVO[]> ();
			//             for( int i = 0 ; i < bmDatas.length ; i++) {
			//            	 bminfos.put(bmDatas[i].getPk_psndoc(),null);
			//             }
			//             getIPersonRecordService().syncPsnBmInfo(bminfos);
		}

	}



	/**
	 * 
	 *
	 * @author zhangg on 2009-12-2
	 * @see nc.itf.hr.wa.IPaydataManageService#onCheck(nc.vo.wa.pub.WaLoginVO,
	 *      String, Boolean)
	 */
	@Override
	public void onCheck(BmLoginContext bmLoginContext, String whereCondition, Boolean isRangeAll)
			throws BusinessException {
		BmLoginVO bmLoginVO = bmLoginContext.getBmLoginVO();
		BmClassVO[] bmclass=null;
		if(StringUtils.isNotEmpty(bmLoginVO.getPk_bm_class())){
			BDPKLockUtil.lockString(bmLoginVO.getPk_bm_class());
		}else{
//			BmClassVO[] bmclassVos = getBmdataQueryDAO().retrieveByClause(BmClassVO.class, "pk_org = '"+bmLoginVO.getPk_org()+"'");
			String sql = "select bm_periodstate.pk_bm_class from bm_periodstate" +
					" inner join bm_period on bm_periodstate.pk_bm_period = bm_period.pk_bm_period" +
					" where bm_periodstate.pk_org = '"+bmLoginContext.getPk_org()+"'" +
					" and bm_periodstate.enableflag = 'Y'" +
					" and bm_period.year = '"+bmLoginContext.getCyear()+"'" +
					" and bm_period.period = '"+bmLoginContext.getCperiod()+"'";
			
			BmClassVO[] bmclassVos = getBmdataQueryDAO().executeQueryVOs(sql, BmClassVO.class);
			bmclass = bmclassVos;
			if(null!=bmclassVos){
				for(int i=0;i<bmclassVos.length;i++){
					BDPKLockUtil.lockString(bmclassVos[i].getPk_bm_class());
				}
			}
		}
		StringBuffer sqlBuffer = new StringBuffer();
		sqlBuffer.append("   bm_data.checkflag = 'N' and bm_data.caculateflag='Y' ");
		sqlBuffer.append(WherePartBmUtil.formatAddtionalWhere(BmdataQueryDAO.getCommonWhereCondtion4Data(bmLoginContext.getBmLoginVO())));

		if (!isRangeAll) {
			sqlBuffer.append(WherePartBmUtil.formatAddtionalWhere(whereCondition));
		}

//		BmDataVO[] bmDatas= queryByCondition(bmLoginContext, sqlBuffer.toString(), null);

		// ˱׼
		getBmdataQueryDAO().onCheck(bmLoginContext.getBmLoginVO(), sqlBuffer.toString(), isRangeAll);

		//ͬhiݡ
		//guoqtΪֹڴִ
		//patch to v636 wangqim
		if(StringUtils.isNotEmpty(bmLoginVO.getPk_bm_class())){
			BmDataVO[] bmDatas= queryByCondition(bmLoginContext, sqlBuffer.toString(), null);
			bmDataSaveToBminfoVO(bmDatas);
		}else{
			for (int i = 0; i < bmclass.length; i++) {
				StringBuffer BmsqlBuffer=sqlBuffer;
				BmsqlBuffer.append(" and bm_data.pk_bm_class = '"+bmclass[i].getPk_bm_class()+"' ");
				BmDataVO[] bmDatas= queryByCondition(bmLoginContext, sqlBuffer.toString(), null);
				bmDataSaveToBminfoVO(bmDatas);
			}
		}
	}


	@Override
	public void onUnCheck(BmLoginContext bmLoginContext, String whereCondition,
			boolean isRangeAll) throws BusinessException {
		BmLoginVO bmLoginVO = bmLoginContext.getBmLoginVO();
		ArrayList<String> pkList = new ArrayList<String>();
		if(StringUtils.isNotEmpty(bmLoginVO.getPk_bm_class())){
			BDPKLockUtil.lockString(bmLoginVO.getPk_bm_class());
			pkList.add(bmLoginVO.getPk_bm_class());
		}else{
//			BmClassVO[] bmclassVos = getBmdataQueryDAO().retrieveByClause(BmClassVO.class, "pk_org = '"+bmLoginVO.getPk_org()+"'");
			// 2015-11-21 NCdp205546812 zhousze ޸ĳbm_bmclasspk_orgbm_bmclassȡΪ˴
			// Ϊڷʱڶbm_periodstateӦָpk_orgʱ´ݣڴΪ
			// ҲûӰ begin
			String sql = "select bm_periodstate.pk_bm_class from bm_periodstate" +
					" inner join bm_period on bm_periodstate.pk_bm_period = bm_period.pk_bm_period" +
					" inner join bm_bmclass on bm_bmclass.pk_bm_class = bm_periodstate.pk_bm_class" +
					" where bm_bmclass.pk_org = '"+bmLoginContext.getPk_org()+"'" +
					" and bm_periodstate.enableflag = 'Y'" +
					" and bm_period.year = '"+bmLoginContext.getCyear()+"'" +
					" and bm_period.period = '"+bmLoginContext.getCperiod()+"'";
			// end
			
			BmClassVO[] bmclassVos = getBmdataQueryDAO().executeQueryVOs(sql, BmClassVO.class);
			if(null!=bmclassVos){
				for(int i=0;i<bmclassVos.length;i++){
					BDPKLockUtil.lockString(bmclassVos[i].getPk_bm_class());
					pkList.add(bmclassVos[i].getPk_bm_class());
				}
			}
		}
		if(bmLoginContext.getBmLoginVO().getPk_bm_class()!=null){
			boolean isbill = NCLocator.getInstance().lookup(IBmAmoQueryService.class).isApportion(bmLoginContext.getBmLoginVO());
			if (isbill == true) {
				throw new BusinessException(ResHelper.getString("60150bmdata","060150bmdata0104")/*@res "ѾƵȡˣ"*/);
			}
		}
		if (pkList.size() > 0) {
			InSQLCreator inSQLCreator = new InSQLCreator();
			String[] pkArr = pkList.toArray(new String[0]);
			try
			{
				StringBuffer sbd = new StringBuffer();
				sbd.append(" select "+SQLHelper.getMultiLangNameColumn("bm_bmclass.name")+" classname from bm_periodstate ");
				sbd.append(" inner join bm_bmclass on bm_periodstate.pk_bm_class = bm_bmclass.pk_bm_class ");
				sbd.append(" inner join bm_period on bm_periodstate.pk_bm_period = bm_period.pk_bm_period ");
				sbd.append(" and bm_period.pk_periodscheme = bm_bmclass.pk_periodscheme ");
				sbd.append(" where bm_period.year = '"+bmLoginContext.getCyear()+"' ");
				sbd.append(" and bm_period.period = '"+bmLoginContext.getCperiod()+"' ");
				sbd.append(" and bm_bmclass.pk_bm_class in ("+inSQLCreator.getInSQL(pkArr)+")" );
				sbd.append(" and bm_periodstate.accountmark = 'Y' " );
				
				ArrayList<HashMap<String, String>> resultList = (ArrayList<HashMap<String, String>>)getBmdataQueryDAO().getBaseDao().executeQuery(sbd.toString(), new MapListProcessor());
				if (resultList != null && resultList.size() > 0) {
					StringBuffer classnamesbd = new StringBuffer();
					for (int i = 0; i < resultList.size(); i++) {
						classnamesbd.append("["+resultList.get(i).get("classname")+"]");
					}
					throw new BusinessException(classnamesbd.toString()+ResHelper.getString("60150bmdata","060150bmdata0130")/*@res "Ѿˣȡˣ"*/);
				}
			} catch (Exception e) {
				// TODO Auto-generated catch block
				throw new BusinessException(e.getMessage());
			} finally{
				inSQLCreator.clear();
			}
		}
		

		StringBuffer sqlBuffer  = new StringBuffer();
		StringBuffer sqlBuffer2 = new StringBuffer();
		sqlBuffer.append("    bm_data.checkflag = 'Y' "); // 6
		sqlBuffer.append(" and not exists(select 1 from bm_periodstate inner join bm_period on bm_periodstate.pk_bm_period= bm_period.pk_bm_period" +
				" where  bm_periodstate.pk_bm_class= bm_data.pk_bm_class and bm_period.year =bm_data.cyear and bm_period.period=bm_data.cperiod and accountmark='Y')");
		sqlBuffer.append(" and not exists(select 1 from bm_datapool " +
				" where  bm_datapool.pk_bm_class= bm_data.pk_bm_class and bm_datapool.cyear =bm_data.cyear and bm_datapool.cperiod=bm_data.cperiod )");
		if (!isRangeAll) {
			sqlBuffer.append(WherePartBmUtil.formatAddtionalWhere(whereCondition));
		}
		sqlBuffer2.append(sqlBuffer).append(
				WherePartBmUtil.formatAddtionalWhere(BmdataQueryDAO
						.getCommonWhereCondtion4Data(bmLoginContext.getBmLoginVO())));
		//ѯҪɾ籣
		//guoqtΪֹڴִ
		//patch to v636 qim
		if(StringUtils.isNotEmpty(bmLoginVO.getPk_bm_class())){
		BmDataVO[] bmDatas= queryByCondition(bmLoginContext, sqlBuffer.toString(), null);

		if (ArrayUtils.isEmpty(bmDatas)) {
			return;
		}

		//StringBuffer sqlBuffer2  = new StringBuffer();

		//		sqlBuffer2.append(" bm_data.pk_psndoc in (select distinct pk_psndoc from bm_data where ").append(sqlBuffer).append(")");
		//		sqlBuffer2.append(" and cyear || cperiod =(select max(cyear || cperiod) from bm_data where checkflag = 'Y' and (cyear || cperiod) < '");
		//		sqlBuffer2.append(bmLoginContext.getBmLoginVO().getPeriodVO().getYear()+bmLoginContext.getBmLoginVO().getPeriodVO().getPeriod());
		//		sqlBuffer2.append("' )");

		// ˱׼
		getBmdataQueryDAO().onUnCheck(bmLoginContext.getBmLoginVO(),
				sqlBuffer2.toString(), isRangeAll);

		//ѯҪ籣
		BmDataVO[] bmDatas2= queryByCondition2(bmLoginContext, bmDatas, null);



		//ͬhiݡ
		//ɾڼ
		bmDataDeleteToBminfoVO(bmDatas);
		//Ϊһڼ
		bmDataSaveToBminfoVO(bmDatas2);
		}else{
			String[] pkArr = pkList.toArray(new String[0]);
			String bmsqlBuffer  = "";
			String bmsqlBuffer2 = "";
			for (int i = 0; i < pkArr.length; i++) {
				bmsqlBuffer =sqlBuffer.toString() + " and bm_data.pk_bm_class = '"+pkArr[i]+"' ";
				bmsqlBuffer2 =sqlBuffer2.toString() + " and bm_data.pk_bm_class = '"+pkArr[i]+"' ";
				BmDataVO[] bmDatas= queryByCondition(bmLoginContext, bmsqlBuffer.toString(), null);

				if (!ArrayUtils.isEmpty(bmDatas)) {
					// ˱׼
					getBmdataQueryDAO().onUnCheck(bmLoginContext.getBmLoginVO(),
							bmsqlBuffer2.toString(), isRangeAll);

					//ѯҪ籣
					BmDataVO[] bmDatas2= queryByCondition2(bmLoginContext, bmDatas, null);

					//ͬhiݡ
					//ɾڼ
					bmDataDeleteToBminfoVO(bmDatas);
					//Ϊһڼ
					bmDataSaveToBminfoVO(bmDatas2);
				}
				
			}
			
		
		}


	}

	private BmDataVO[] queryByCondition2(BmLoginContext context, BmDataVO[] bmDatas, String orderCondtion)
			throws BusinessException {
		if(context.getBmLoginVO().getPeriodVO()==null){
			return null;
		}

		String tempTable = createTempTable(bmDatas);

		StringBuffer sqlBuffer = new StringBuffer();
		sqlBuffer.append("select  "+ SQLHelper.getMultiLangNameColumn("bd_psndoc.name")+ "  " + IBmCommonAlterName.PSNNAME + ", "); // 1
		sqlBuffer.append("       bd_psndoc.code " + IBmCommonAlterName.PSNCODE + ", "); // 2
		sqlBuffer.append("       hi_psnjob.clerkcode, "); // 3
		sqlBuffer.append("        "+ SQLHelper.getMultiLangNameColumn("org_dept.name")+ "  " + IBmCommonAlterName.DEPTNAME + ", "); // 4
		sqlBuffer.append("        "+ SQLHelper.getMultiLangNameColumn("org_orgs.name")+ "  " + IBmCommonAlterName.ORGNAME + ", "); // 3
		sqlBuffer.append("        "+ SQLHelper.getMultiLangNameColumn("bd_psncl.name")+ "  " + IBmCommonAlterName.PLSNAME + ", "); // 5
		sqlBuffer.append("       om_job.jobname, "); // 6
		sqlBuffer.append("       om_post.postname, "); // 6
		sqlBuffer.append("       bm_bmclass.code  " + IBmCommonAlterName.CLASSCODE + ", ");
		sqlBuffer.append("        "+ SQLHelper.getMultiLangNameColumn("bm_bmclass.name")+ "  " + IBmCommonAlterName.CLASSNAME + ", ");
		sqlBuffer.append("       bm_data.* "); // 7
		sqlBuffer.append("  from bm_data ");
		sqlBuffer.append(" inner join bd_psndoc on bm_data.pk_psndoc = bd_psndoc.pk_psndoc ");
		sqlBuffer.append(" inner join hi_psnjob on bm_data.pk_psnjob = hi_psnjob.pk_psnjob ");
		sqlBuffer.append(" inner join bm_bmclass on bm_data.pk_bm_class = bm_bmclass.pk_bm_class ");

		sqlBuffer.append(" inner join "+tempTable+" temp on bm_data.pk_bm_class = temp.pk_bm_class and  bm_data.pk_psndoc = temp.pk_psndoc " +
				"and bm_data.cyear||bm_data.cperiod = temp.cyearcperiod ");

		sqlBuffer.append(" left join org_orgs on hi_psnjob.pk_org = org_orgs.pk_org ");
		sqlBuffer.append(" left join org_dept on hi_psnjob.pk_dept = org_dept.pk_dept ");
		sqlBuffer.append("  left outer join om_job on hi_psnjob.pk_job = om_job.pk_job ");
		sqlBuffer.append("  left outer join om_post on hi_psnjob.pk_post = om_post.pk_post ");
		sqlBuffer.append("  left outer join bd_psncl on hi_psnjob.pk_psncl = bd_psncl.pk_psncl where ");


		if(context.getBmLoginVO().getPk_bm_class()!=null){
			sqlBuffer.append("  bm_data.pk_bm_class = '" + context.getBmLoginVO().getPk_bm_class() + "' "); // 1
		}else{
			sqlBuffer.append("  bm_data.pk_bm_class in (select pk_bm_class from bm_bmclass where ");
			sqlBuffer.append("  pk_org = '"+context.getBmLoginVO().getPk_org()+"')" );
			//guoqtΪֹڴ
			//patch to v636 wangqim
			sqlBuffer.append("  and bm_data.pk_bm_class = '"+bmDatas[0].getPk_bm_class() +"'");
			sqlBuffer.append("  and bm_data.cyear = '"+context.getCyear() +"'");
			sqlBuffer.append("  and bm_data.cperiod = '"+context.getCperiod()+"' "); // 1
		}
		sqlBuffer.append("   and bm_data.accountstate = 0 ");



		BmDataVO[] vos=  getBmdataQueryDAO().executeQueryAppendableVOs(sqlBuffer.toString(), BmDataVO.class);


		return vos;

	}

	/***************************************************************************
	 * ˵ʱ
	 * <br>Created on 2012-9-28 10:27:01<br>
	 * @return
	 * @author daicy
	 * @throws BusinessException
	 * @throws SQLException
	 * @throws NamingException
	 ***************************************************************************/
	private String createTempTable(SuperVO[] bmDatas) throws BusinessException  {

		//ʱ
		String tableName = BmClassConstant.BM_TEMP_DATAPSNCP;

		//		public static final String[] DATAPSN_COLUMN = { "pk_bm_class", "pk_psndoc",
		//			"cyear", "cperiod" };


		//ʱ
		String  columns= "  pk_bm_class char(20) ,pk_psndoc char(20) ,cyearcperiod char(6)  ";
		InSQLCreator inSQLCreator = new InSQLCreator();

		try
		{
			String pk_psndocs = "";
			//String pk_bm_classs = "";
			if(null!=bmDatas){
				pk_psndocs = " pk_psndoc in("+inSQLCreator.getInSQL(bmDatas, "pk_psndoc")+") ";
				//pk_bm_classs = " and PK_BM_CLASS in("+inSQLCreator.getInSQL(bmDatas, "PK_BM_CLASS")+") ";
			}

			String pkindex = "pk_psndoc";


			//˱ʱԶգ

			tableName = inSQLCreator.createTempTable(tableName, columns,
					pkindex);

			String  columns2= "  pk_bm_class,pk_psndoc  , cyearcperiod ";


			StringBuilder sbd = new StringBuilder(" insert into  "+tableName+"   ("+columns2+") " +
					"select PK_BM_CLASS,pk_psndoc, max(CYEAR||cperiod) cyearcperiod  from bm_data where " + pk_psndocs+
					"  and CHECKFLAG='Y'" +
					" group by pk_psndoc,PK_BM_CLASS ");

			new BaseDAO().executeUpdate(sbd.toString());

		} catch (Exception e) {
			// TODO Auto-generated catch block
			throw new BusinessException(e.getMessage());
		}finally{
			inSQLCreator.clear();
		}


		return tableName;
	}

	@Override
	public void update(Object vo, BmLoginVO bmLoginVO)
			throws BusinessException {

		if(StringUtils.isNotEmpty(bmLoginVO.getPk_bm_class())){
			BDPKLockUtil.lockString(bmLoginVO.getPk_bm_class());
		}else{
//			BmClassVO[] bmclassVos = getBmdataQueryDAO().retrieveByClause(BmClassVO.class, "pk_org = '"+bmLoginVO.getPk_org()+"'");
			String sql = "select bm_periodstate.pk_bm_class from bm_periodstate" +
					" inner join bm_period on bm_periodstate.pk_bm_period = bm_period.pk_bm_period" +
					" where bm_periodstate.pk_org = '"+bmLoginVO.getPk_org()+"'" +
					" and bm_periodstate.enableflag = 'Y'" +
					" and bm_period.year = '"+bmLoginVO.getCyear()+"'" +
					" and bm_period.period = '"+bmLoginVO.getCperiod()+"'";
			
			BmClassVO[] bmclassVos = getBmdataQueryDAO().executeQueryVOs(sql, BmClassVO.class);
			if(null!=bmclassVos){
				for(int i=0;i<bmclassVos.length;i++){
					BDPKLockUtil.lockString(bmclassVos[i].getPk_bm_class());
				}
			}
		}

		getBmdataQueryDAO().update(vo, bmLoginVO);

	}
	@Override
	public void onReplace(BmLoginVO bmLoginVO, String whereCondition,
			BmClassItemVO replaceItem, String formula,SuperVO... superVOs) throws BusinessException {
		if(StringUtils.isNotEmpty(bmLoginVO.getPk_bm_class())){
			BDPKLockUtil.lockString(bmLoginVO.getPk_bm_class());
		}else{
//			BmClassVO[] bmclassVos = getBmdataQueryDAO().retrieveByClause(BmClassVO.class, "pk_org = '"+bmLoginVO.getPk_org()+"'");
			String sql = "select bm_periodstate.pk_bm_class from bm_periodstate" +
					" inner join bm_period on bm_periodstate.pk_bm_period = bm_period.pk_bm_period" +
					" where bm_periodstate.pk_org = '"+bmLoginVO.getPk_org()+"'" +
					" and bm_periodstate.enableflag = 'Y'" +
					" and bm_period.year = '"+bmLoginVO.getCyear()+"'" +
					" and bm_period.period = '"+bmLoginVO.getCperiod()+"'";
			
			BmClassVO[] bmclassVos = getBmdataQueryDAO().executeQueryVOs(sql, BmClassVO.class);
			if(null!=bmclassVos){
				for(int i=0;i<bmclassVos.length;i++){
					BDPKLockUtil.lockString(bmclassVos[i].getPk_bm_class());
				}
			}
		}

		//άȨ
		String operateConditon = NCLocator.getInstance().lookup(IDataPermissionPubService.class)
				.getDataPermissionSQLWherePartByMetaDataOperation(PubEnv.getPk_user(),IHRBMDataResCode.BMDATA,
						IHRBMActionCode.EDIT, PubEnv.getPk_group());
		if(StringUtils.isBlank(whereCondition)){
			whereCondition = operateConditon;
		}else{
			whereCondition = whereCondition + WherePartUtil.formatAddtionalWhere(operateConditon);
		}
		//ʹȨ
		String userConditon = BmPowerSqlHelper.getRefPowerSql(PubEnv
				.getPk_group(), HICommonValue.RESOUCECODE_6007PSNJOB,
				IHRBMDataResCode.BMDEFAULT, "bm_data");
		if (StringUtils.isBlank(whereCondition)) {
			whereCondition = userConditon;
		} else {
			whereCondition = whereCondition + WherePartUtil.formatAddtionalWhere(userConditon);
		}

		if(null!=superVOs){
			// 汾У飨ʱУ飩
			BDVersionValidationUtil.validateSuperVO(superVOs);
		}

		getBmdataQueryDAO().onReplace(bmLoginVO, whereCondition, replaceItem, formula);

		replaceItem.setPk_classitem(BmMetaDataConstant.BM_DATA_ONREPLACE_ID);
		String msg = ResHelper.getString("60150bmdata","060150bmdata0030") + ":"+bmLoginVO.getMultilangName()+
				ResHelper.getString("60150bmdata","060150bmdata0082") + ":"+bmLoginVO.getPeriodVO().toString()+"  "+formula;

		BmBusilogUtil.writeBmdataBusiLog(replaceItem,msg,BmMetaDataConstant.ONREPLACE,BmMetaDataConstant.BM_DATA_ONREPLACE_ID);

	}



	@Override
	public void onCaculate(BmLoginContext loginContext, CaculateTypeVO caculateTypeVO, String condition,SuperVO... superVOs)
			throws BusinessException{

		
		String powerwheresql= " 1=1 ";
//		Ȩ
		String  powerSql =BmPowerSqlHelper.getRefPowerSql(loginContext.getPk_group(), IHRBMDataResCode.BMCLASS, IHRBMDataResCode.BMCLASS,
				"bm_bmclass");
//		//Ȩ
		if (!StringUtils.isBlank(powerSql)) {
			powerwheresql += " and " + powerSql;
		}

		if(null!=superVOs){
			// 汾У飨ʱУ飩
			BDVersionValidationUtil.validateSuperVO(superVOs);
		}

		if (!StringUtils.isEmpty(loginContext.getPk_bm_class())) {
			
			
			onCaculateSingle(loginContext, caculateTypeVO, condition);


		}else{

			//ҳcondition,caculateTypeVO\loginContext 
			if(caculateTypeVO != null){
				// 㷶Χ
				String where = condition;
				boolean all = caculateTypeVO.getRange().booleanValue();

				if (where == null || all) {
					where = null;
				}

				// 㷽ʽ
				boolean type = caculateTypeVO.getType().booleanValue();
				if (type) {
					String addWhere = "  bm_data.checkflag = 'N'  ";
					where = (where == null) ? addWhere : (where + " and   " + addWhere);
				} else {
					String addWhere = "  bm_data.checkflag = 'N' and bm_data.caculateflag = 'N'   ";
					where = (where == null)? addWhere : (where + " and   " + addWhere);
				}

//      20160105  xiejie3  	NCdp205568942  籣ɽѯȷȨޣ˻ûȨ޵ݶˣƲȷ			
//		Ȩ޿		
				if(!StringUtils.isBlank(powerwheresql)){
					where+= " and " + powerwheresql;
				}
//		end
				// loginContext,where 
				BmClassVO[] vos = NCLocator.getInstance().lookup(IBmClassQueryService.class).queryClassVOByCondition4Caculate(loginContext, where);
				BmLoginVO[] loginvos  = new BmLoginVO[vos.length];
				for (int i = 0; i < vos.length; i++) {
					loginvos[i] = new BmLoginVO();
					loginvos[i].setPk_bm_class(vos[i].getPk_bm_class());
					loginvos[i].setPk_group(vos[i].getPk_group());
					loginvos[i].setPk_org(vos[i].getPk_org());
					loginvos[i].setAllowadditem(vos[i].getAllowadditem());
					loginvos[i].setBusinessperiod(vos[i].getBusinessperiod());

					loginvos[i].setCode(vos[i].getCode());
					loginvos[i].setName(vos[i].getName());
					loginvos[i].setName2(vos[i].getName2());
					loginvos[i].setName3(vos[i].getName3());
					loginvos[i].setName4(vos[i].getName4());
					loginvos[i].setName5(vos[i].getName5());
					loginvos[i].setName6(vos[i].getName6());

					loginvos[i].setCreationtime(vos[i].getCreationtime());
					loginvos[i].setCreator(vos[i].getCreator());
					loginvos[i].setCurrid(vos[i].getCurrid());
					loginvos[i].setCyear(vos[i].getCyear());

					loginvos[i].setCperiod(vos[i].getCperiod());
					loginvos[i].setEnableorgbase(vos[i].getEnableorgbase());
					loginvos[i].setPk_financeorg(vos[i].getPk_financeorg());

					loginvos[i].setPk_periodscheme(vos[i].getPk_periodscheme());
					loginvos[i].setStartyear(vos[i].getStartyear());
					loginvos[i].setStartperiod(vos[i].getStartperiod());//
					loginvos[i].setStopflag(vos[i].getStopflag());

					//
					loginvos[i].setPeriodVO(loginContext.getBmLoginVO().getPeriodVO());
					BmLoginContext loginContextt  = new BmLoginContext();
					loginContextt.setCyear(loginContext.getCyear());
					loginContextt.setCperiod(loginContext.getCperiod());
					loginContextt.setPk_org(loginContext.getPk_org());
					loginvos[i] = ((IBmPub) NCLocator.getInstance().lookup(IBmPub.class.getName())).getBmclassVOWithState(loginvos[i]);
					loginContextt.setBmLoginVO(loginvos[i]);
					onCaculateSingle(loginContextt, caculateTypeVO, condition);

				}

			}
		}

	}

	public void onCaculateSingle(BmLoginContext loginContext, CaculateTypeVO caculateTypeVO, String condition)
			throws BusinessException{
		if(StringUtils.isNotEmpty(loginContext.getPk_bm_class())){
			BDPKLockUtil.lockString(loginContext.getPk_bm_class());
		}else{
//			BmClassVO[] bmclassVos = getBmdataQueryDAO().retrieveByClause(BmClassVO.class, "pk_org = '"+bmLoginVO.getPk_org()+"'");
			String sql = "select bm_periodstate.pk_bm_class from bm_periodstate" +
					" inner join bm_period on bm_periodstate.pk_bm_period = bm_period.pk_bm_period" +
					" where bm_periodstate.pk_org = '"+loginContext.getPk_org()+"'" +
					" and bm_periodstate.enableflag = 'Y'" +
					" and bm_period.year = '"+loginContext.getCyear()+"'" +
					" and bm_period.period = '"+loginContext.getCperiod()+"'";
			
			BmClassVO[] bmclassVos = getBmdataQueryDAO().executeQueryVOs(sql, BmClassVO.class);
			if(null!=bmclassVos){
				for(int i=0;i<bmclassVos.length;i++){
					BDPKLockUtil.lockString(bmclassVos[i].getPk_bm_class());
				}
			}
		}


		//Уӷİ汾һ
		// 汾У飨ʱУ飩
		BDVersionValidationUtil.validateSuperVO(loginContext.getBmLoginVO());

		// жϲ
		//		checkReData(loginContext.getBmLoginVO());

		BmDataCaculateService caculateService = new BmDataCaculateService(loginContext, caculateTypeVO, condition);
		caculateService.doCaculate();

	}
	@Override
	public BudgetWarnMessageVo budgetAlarmCheck(BmLoginContext context,
			String whereStr) throws BusinessException {
		// hrys6040ԤģǷãûãܶУ
		if(!PubEnv.isModuleStarted(context.getPk_group() + "", "6040")){
			return null;
		}else{
			return getBmdataBudgetAlarmDao().budgetAlarmCheck(context, whereStr);
		}
	}
	@Override
	public BmDataVO[] getHrssBmData(String pk_psndoc, String[] pk_bm_class,
			String beginDate, String endDate) throws BusinessException {
		return getBmdataQueryDAO().getHrssBmData(pk_psndoc, pk_bm_class, beginDate, endDate);
	}

	/**
	 * ѯָ֣ҵڼжٲ֯
	 * @param pk_bm_class
	 * @param cyear
	 * @param cperiod
	 * @return
	 * @throws BusinessException
	 */
	@Override
	public BmFiorgVO[] queryBmFiorg(String pk_bm_class, String cyear, String cperiod) throws BusinessException {

		return getBmdataQueryDAO().queryBmFiorg(pk_bm_class, cyear,cperiod);
	}

	@Override
	public BmPeriodVO queryDefaultPeriod(String pk_psndoc)
			throws BusinessException {
		String sql = "SELECT MAX(cstartdate) AS cstartdate ,MAX(cenddate) AS cenddate "
				+ "FROM bm_data,bm_bmclass,bm_period,bm_periodstate "
				+ "WHERE bm_data.pk_bm_class = bm_bmclass.pk_bm_class "
				+ "	AND bm_bmclass.pk_periodscheme = bm_period.pk_periodscheme "
				+ "	AND bm_periodstate.pk_bm_class = bm_bmclass.pk_bm_class "
				+ "	AND bm_periodstate.pk_bm_period = bm_period.pk_bm_period "
				+ "	AND bm_period.YEAR = bm_data.cyear "
				+ "	AND bm_period.period = bm_data.cperiod "
				+ "	AND bm_data.checkflag = 'Y' "
				+ "	AND bm_data.pk_psndoc = '" + pk_psndoc + "'";
		return getBmdataQueryDAO().executeQueryVO(sql, BmPeriodVO.class);
	}
	@Override
	public BmPeriodstateVO[] getAccountPeriods(String pk_bm_class) throws BusinessException {
		return getBmdataQueryDAO().getAccountPeriods(pk_bm_class);
	}
	@Override
	public void onReBufa(BmLoginVO bmLoginVo, BmPeriodstateVO[] periodvos,
			String baseperiod, String where) throws BusinessException {
		//ȡǰڼ벹ɵԱԼ׼ڼĵλɽ͸˽ɽ
		//µǵǰڼ䵥λɶ͸˲ɶ Ҫ
		if (StringUtil.isNotBlank(where) && where.contains("paylocation =")){
			where = where.replace("paylocation =", "bm_data.paylocation =");
		}/*ɲѯΪɽعʱָѯ*/
		String sql = "select bm_data.pk_bm_data,bm_data.cyear,bm_data.cperiod,bm_data.pk_psndoc,baseperiod.f_5 f_11,baseperiod.f_10 f_13 from bm_data ,bm_data baseperiod "
				+ "  where bm_data.pk_bm_class = '" + bmLoginVo.getPk_bm_class()
				+ "' and bm_data.cyear = '" + bmLoginVo.getCyear()
				+ "' and bm_data.cperiod = '" + bmLoginVo.getCperiod()
				+ "' and bm_data.pk_psndoc = baseperiod.pk_psndoc "
				+ "  and baseperiod.pk_bm_class = bm_data.pk_bm_class"
				+ "  and baseperiod.cyear = '" + baseperiod.substring(0, 4)
				+ "' and baseperiod.cperiod = '" + baseperiod.substring(4, 6)
				+ "'  and bm_data.accountstate = 0 and bm_data.accountstate = baseperiod.accountstate ";
//				+ " and exists(select 1 from bm_classitem where pk_bm_class = baseperiod.pk_bm_class and itemkey = 'f_5' and baseperiod.cyear =bm_classitem.cyear and baseperiod.cperiod =bm_classitem.cperiod) "
//				+ "  and exists(select 1 from bm_classitem where pk_bm_class = baseperiod.pk_bm_class and itemkey = 'f_10'and baseperiod.cyear =bm_classitem.cyear and baseperiod.cperiod =bm_classitem.cperiod) ";
		if(!StringUtils.isEmpty(where)){
			sql += " and bm_data.pk_psndoc in (select pk_psndoc from hi_psnjob where "+where+")";
		}
		BmDataVO[] basedataVOs = getBmdataQueryDAO().executeQueryVOs(sql, BmDataVO.class);

		//ȡڼԱĵλɽ͸˽ɽ
		String[] periodstrs = new String[periodvos.length];
		for(int i=0;i<periodvos.length;i++){
			periodstrs[i] = periodvos[i].getYear()+periodvos[i].getPeriod();
		}
		InSQLCreator inc = new InSQLCreator();
		if(ArrayUtils.isEmpty(basedataVOs)){
			return;
		}
		String sql2 = " select pk_bm_data,pk_psndoc,f_5,f_10 from bm_data where pk_psndoc in ( "+inc.getInSQL(basedataVOs, BmDataVO.PK_PSNDOC)+")"
				+ " and cyear||cperiod in( " +inc.getInSQL(periodstrs)+")"
				+ " and bm_data.accountstate = 0 "
				+ " and pk_bm_class = '" + bmLoginVo.getPk_bm_class()
				+ "'";
		BmDataVO[] comparedataVOs = getBmdataQueryDAO().executeQueryVOs(sql2, BmDataVO.class);
		if(ArrayUtils.isEmpty(comparedataVOs)){
			return;
		}
		HashMap<Object,BmDataVO[]> comparedataVOsMap =(HashMap<Object,BmDataVO[]>)CommonUtils.group2ArrayByField(BmDataVO.PK_PSNDOC, comparedataVOs);

		//Աһһɲ
		UFDouble sumf_11 = UFDouble.ZERO_DBL;
		UFDouble sumf_13 = UFDouble.ZERO_DBL;
		for(BmDataVO basedataVO:basedataVOs){
			sumf_11 = UFDouble.ZERO_DBL;
			sumf_13 = UFDouble.ZERO_DBL;

			BmDataVO[] tempdataVOs = comparedataVOsMap.get(basedataVO.getPk_psndoc());//˵дݣڼ䣩
			if(ArrayUtils.isEmpty(tempdataVOs)){
				basedataVO.setAttributeValue("f_11", sumf_11);
				basedataVO.setAttributeValue("f_13", sumf_13);
				continue;
			}
			for(BmDataVO comparedataVO:tempdataVOs){
				sumf_11 = sumf_11.add(((UFDouble)basedataVO.getAttributeValue("f_11")).sub((UFDouble)comparedataVO.getAttributeValue("f_5")));
				sumf_13 = sumf_13.add(((UFDouble)basedataVO.getAttributeValue("f_13")).sub((UFDouble)comparedataVO.getAttributeValue("f_10")));
			}
			basedataVO.setAttributeValue("f_11", sumf_11);
			basedataVO.setAttributeValue("f_13", sumf_13);
		}
		//ݿ
		getBmdataQueryDAO().onReBufa(basedataVOs,bmLoginVo);

	}

	@Override
	public void saveDisplayInfo(BmLoginContext context, String type,
			List<BmdataDspVO> leftList,
			List<BmdataDspVO> rightList) throws BusinessException {
		//֮ǰɾ
		deleteDisplayInfo(context, type);
		//ѡĿ
		if(rightList!=null&&rightList.size()>0){
			for(int i=0;i<rightList.size();i++){
				BmdataDspVO vo = rightList.get(i);
				vo.setPk_bm_class(context.getPk_bm_class());
				vo.setType(type);
				vo.setBshow(UFBoolean.TRUE);
				vo.setDisplayseq(i);
				//typeΪͨãpk_userǼ¼˭˼¼
				vo.setPk_user(context.getPk_loginUser());
				vo.setPk_group(context.getPk_group());
				vo.setPk_org(context.getPk_org());
				vo.setMaintainmode(context.getMaintainmode());
				vo.setCyear(context.getCyear());
				vo.setCperiod(context.getCperiod());
				rightList.set(i, vo);
			}
		}
		//ôѡĿ
		if(leftList!=null&&leftList.size()>0){
			for(int i=0;i<leftList.size();i++){
				BmdataDspVO vo = leftList.get(i);
				vo.setPk_bm_class(context.getPk_bm_class());
				vo.setType(type);
				vo.setBshow(UFBoolean.FALSE);
				vo.setDisplayseq(i);
				//typeΪͨãpk_userǼ¼˭˼¼
				vo.setPk_user(context.getPk_loginUser());
				vo.setPk_group(context.getPk_group());
				vo.setPk_org(context.getPk_org());
				vo.setMaintainmode(context.getMaintainmode());
				vo.setCyear(context.getCyear());
				vo.setCperiod(context.getCperiod());
				leftList.set(i, vo);
			}
		}
		//ѡʹѡĺϲͬһListб
		rightList.addAll(leftList);
		getBmdataQueryDAO().getBaseDao().insertVOList(rightList);
	}

	@Override
	public BmdataDspVO[] getBmdataDspVOs(BmLoginContext context, BmClassItemVO[] itemArray)
			throws BusinessException {
		BmdataDspUtil bmdataDspUtil = new BmdataDspUtil();
		bmdataDspUtil.setClassName(BmdataDspVO.class);
//		NCdp205541842   xiejie3   ԱʾĿظЧ. 
//		ʾõĿѯǹĿitemkey
//		ѯĽɽĿظitemArrayΪɶ飬ڲΪ˼СӰ죬ֻڴ˴ظˡ
		//20151208 shenliangc NCdp205555644 籣ɽµĿĬʾλûаµĽɽĿλʾ
		//ֻаԱչʾʱҪȥء
		if(context != null && context.getMaintainmode() != null && "1".equals(context.getMaintainmode())){
			itemArray=getSameItems(itemArray);
		}
//		end
		//Ҹʾ
		List<BmdataDspVO> dspList = this.queryBmdataPersonalDsp(context);
		if(dspList == null || dspList.isEmpty()){
			//ûøʾãôͨʾ
			dspList = this.queryBmdataCommonDsp(context);
		}
		if(dspList == null || dspList.isEmpty()){

			//ûиʾãҲûͨʾãͰĬʾ
			dspList =  bmdataDspUtil.queryDefaultDsp();

			//תнĿӵʾĿ
			List<BmdataDspVO> bmItemsDspList = bmdataDspUtil.convertBmItemVO(itemArray);
			dspList.addAll( bmItemsDspList);
		}else{
			//item_name
			bmdataDspUtil.setBmfileDisplayName(dspList);
			//setBmfileDisplayName(dspList);
			//ʾ˳֮󣬷¼ӵĿҪ
			bmdataDspUtil.addNewlyDsiplayItem(dspList, itemArray);
		}
//		20150923  xiejie3 Աʾʱ򣬲Թ̶нչʾbegin
		String Maintenance = context.getMaintainmode();
		if (Maintenance.equals(BmdataDspUtil.PSNDOCMODE)) {
			BmdataDspVO bmdatadspvo[] = BmdataDspUtil.queryFixedDsp().toArray(
					new BmdataDspVO[0]);
			BmdataDspVO dspList1[] = dspList.toArray(new BmdataDspVO[0]);
			List<BmdataDspVO> dspList2=null;
			for (int j = 0; j < dspList1.length; j++) {
				for (int i = 0; i < bmdatadspvo.length; i++) {
					if (dspList1[j].getItem_key().equals(
							bmdatadspvo[i].getItem_key())) {
						dspList.remove(dspList1[j]);
						break;
					}
				}
			}
		}
//		end
		return  dspList.toArray(new BmdataDspVO[0]);
	}
	
	
	
	private BmClassItemVO[] getSameItems(BmClassItemVO[] itemVOs){
		if(ArrayUtils.isEmpty(itemVOs)){
			return itemVOs;
		}
		HashMap<String,BmClassItemVO> bmItemVOs= new HashMap<String,BmClassItemVO>();
		for(BmClassItemVO itemVO:itemVOs){
			if(null!=itemVO){
				if(!bmItemVOs.containsKey(itemVO.getItemkey())){
					bmItemVOs.put(itemVO.getItemkey(), itemVO);
				}
			}
			
		}
		return bmItemVOs.values().toArray(new BmClassItemVO[0]);
	}
	
	
	

	/**
	 * ͨʾ
	 * @param context
	 * @return
	 * @throws DAOException
	 */
	@SuppressWarnings("unchecked")
	private List<BmdataDspVO> queryBmdataCommonDsp(BmLoginContext context) throws DAOException{
		StringBuffer whereStr = new StringBuffer();
		String maintainmode = context.getMaintainmode();
		if (maintainmode.equals(BmdataDspUtil.PSNDOCMODE)) {
			whereStr.append(" maintainmode='").append(context.getMaintainmode())
			.append("' and pk_org='").append(context.getPk_org())
			.append("' and cyear='").append(context.getCyear())
			.append("' and cperiod='").append(context.getCperiod())
			.append("' and type='").append(BmdataDspUtil.COMMONDSP)
			.append("'");
		}else if(maintainmode.equals(BmdataDspUtil.BMCLASSMODE)){
			whereStr.append(" pk_bm_class='").append(context.getPk_bm_class())
			.append("' and maintainmode='").append(context.getMaintainmode())
			.append("' and pk_org='").append(context.getPk_org())
			.append("' and cyear='").append(context.getCyear())
			.append("' and cperiod='").append(context.getCperiod())
			.append("' and type='").append(BmdataDspUtil.COMMONDSP)
			.append("'");
		}
		return  (List<BmdataDspVO>) getBmdataQueryDAO().getBaseDao().retrieveByClause(
				BmdataDspVO.class, whereStr.toString(),"displayseq");
	}


	/**
	 * ҷʾ
	 * @param context
	 * @return
	 * @throws DAOException
	 */
	@SuppressWarnings("unchecked")
	private List<BmdataDspVO> queryBmdataPersonalDsp(BmLoginContext context)
			throws DAOException {
		StringBuffer whereStr = new StringBuffer();
		String maintainmode = context.getMaintainmode();
		//by wangqim 
		//ѯãڼ֡ȫٴ
		//Ϊˣ֮ǰʾ˳򣬿쵽֮ڼ
		String orderCondition ="displayseq";
		List<BmdataDspVO> dspVOs = null;
		if (maintainmode.equals(BmdataDspUtil.PSNDOCMODE)) {
			whereStr.append(" pk_user = '").append(context.getPk_loginUser())
			.append("' and maintainmode='").append(context.getMaintainmode())
			.append("' and pk_org='").append(context.getPk_org())
				//.append("' and cyear='").append(context.getCyear())
				//.append("' and cperiod='").append(context.getCperiod())
			.append("' and type='").append(BmdataDspUtil.PERSONALDSP)
			.append("'");
			/*//ΪڼĸϢˡҲҪ䣬ڴ
			orderCondition ="CYEAR desc,CPERIOD desc,DISPLAYSEQ";
			List<BmdataDspVO> result = (List<BmdataDspVO>) getBmdataQueryDAO().getBaseDao().retrieveByClause(
						BmdataDspVO.class, whereStr.toString(),orderCondition);
			//Խд
			//жǷѡڼ
			dspVOs = new ArrayList<BmdataDspVO>();
			for(BmdataDspVO dspVO : result){
				if(dspVO.getCyear().equals(context.getCyear()) && dspVO.getCperiod().equals(context.getCperiod())){
					dspVOs.add(dspVO);
				}else if(dspVOs.size()>0){
					break;
				}
			}
			//dspVOsûݣresultݣʾûеڼ,ȥµڼ
			if(dspVOs.size()<=0 && result.size()>0){
				String lastCyear = result.get(0).getCyear();
				String lastCperiod = result.get(0).getCperiod(); //¼ڼ
				for(BmdataDspVO dspVO : result){
					dspVOs.add(dspVO);
					//ˣڼȡ
					if(!dspVO.getCperiod().equals(lastCperiod) || !dspVO.getCyear().equals(lastCyear)){
						break;
					}
				}
			}*/
		}else if(maintainmode.equals(BmdataDspUtil.BMCLASSMODE)){
			whereStr.append(" pk_user = '").append(context.getPk_loginUser())
			.append("' and pk_bm_class='").append(context.getPk_bm_class())
			.append("' and maintainmode='").append(context.getMaintainmode())
			.append("' and pk_org='").append(context.getPk_org())
//			.append("' and cyear='").append(context.getCyear())
//			.append("' and cperiod='").append(context.getCperiod())
			.append("' and type='").append(BmdataDspUtil.PERSONALDSP)
			.append("'");
//			dspVOs = (List<BmdataDspVO>) getBmdataQueryDAO().getBaseDao().retrieveByClause(
//					BmdataDspVO.class, whereStr.toString(),orderCondition);
		}
		//ΪڼĸϢˡҲҪ䣬ڴ
		orderCondition ="CYEAR desc,CPERIOD desc,DISPLAYSEQ";
		List<BmdataDspVO> result = (List<BmdataDspVO>) getBmdataQueryDAO().getBaseDao().retrieveByClause(
					BmdataDspVO.class, whereStr.toString(),orderCondition);
		//Խд
		//жǷѡڼ
		dspVOs = new ArrayList<BmdataDspVO>();
		for(BmdataDspVO dspVO : result){
			if(dspVO.getCyear().equals(context.getCyear()) && dspVO.getCperiod().equals(context.getCperiod())){
				dspVOs.add(dspVO);
			}else if(dspVOs.size()>0){
				break;
			}
		}
		//dspVOsûݣresultݣʾûеڼ,ȥµڼ
		if(dspVOs.size()<=0 && result.size()>0){
			String lastCyear = result.get(0).getCyear();
			String lastCperiod = result.get(0).getCperiod(); //¼ڼ
			for(BmdataDspVO dspVO : result){
				dspVOs.add(dspVO);
				//ˣڼȡ
				if(!dspVO.getCperiod().equals(lastCperiod) || !dspVO.getCyear().equals(lastCyear)){
					break;
				}
			}
		}
		return dspVOs;
	}

	@Override
	public BmdataShowInfVO<BmdataDspVO> getBmdataShowInfVO(BmLoginContext loginContext)
			throws BusinessException {
		BmClassItemVO[] items = getBmClassQueryService().getPayBmclassItem(loginContext);
		BmClassItemVO[] distinctItems = new BmClassDao().getBmItem(loginContext);
		BmdataDspVO[] dspVOs = getBmdataDspVOs(loginContext, distinctItems);

		BmdataShowInfVO<BmdataDspVO> info = new BmdataShowInfVO<BmdataDspVO> ();
		info.setBmdataDspVOs(dspVOs);
		info.setBmClassItemVOs(items);

		return info;
	}

	private IBmClassQueryService classqueryService;

	private IBmClassQueryService getBmClassQueryService(){
		if(classqueryService==null){
			classqueryService = NCLocator.getInstance().lookup(IBmClassQueryService.class);
		}
		return classqueryService;
	}

	@Override
	public void deleteDisplayInfo(BmLoginContext context, String type)
			throws BusinessException {
		StringBuffer whereStr = new StringBuffer();
		String maintainmode = context.getMaintainmode();
		if (maintainmode.equals(BmdataDspUtil.PSNDOCMODE)) {
			whereStr.append(" type='").append(type)
			.append("' and maintainmode='").append(context.getMaintainmode())
			.append("' and pk_org='").append(context.getPk_org())
			.append("' and cyear='").append(context.getCyear())
			.append("' and cperiod='").append(context.getCperiod())
			.append("'");
		}else if(maintainmode.equals(BmdataDspUtil.BMCLASSMODE)){
			whereStr.append(" pk_bm_class='").append(context.getPk_bm_class())
			.append("' and type='").append(type)
			.append("' and maintainmode='").append(context.getMaintainmode())
			.append("' and pk_org='").append(context.getPk_org())
			.append("' and cyear='").append(context.getCyear())
			.append("' and cperiod='").append(context.getCperiod())
			.append("'");
		}

		if(BmdataDspUtil.PERSONALDSP.equals(type)){
			whereStr.append(" and pk_user='").append(context.getPk_loginUser()).append("'");
		}
		getBmdataQueryDAO().getBaseDao().deleteByClause(BmdataDspVO.class, whereStr.toString());
	}

	@Override
	public void createNextBmdataDsp(BmClassEndVO bmClassEndVO, List<BmdataDspVO> list)
			throws BusinessException {
		String cyear = bmClassEndVO.getCyear();
		String cperiod = bmClassEndVO.getCperiod();
		for (int i = 0; i < list.size(); i++) {
			list.get(i).setCyear(cyear);
			list.get(i).setCperiod(cperiod);
		}
		getBmdataQueryDAO().getBaseDao().insertVOList(list);
	}

	@Override
	public void deleteBmdataDsp4Class(BmClassEndVO bmClassEndVO)
			throws BusinessException {
		StringBuffer whereStr = new StringBuffer();
		whereStr.append(" pk_bm_class='").append(bmClassEndVO.getPk_bm_class())
		.append("' and pk_org='").append(bmClassEndVO.getPk_org())
		.append("' and cyear='").append(bmClassEndVO.getCyear())
		.append("' and cperiod='").append(bmClassEndVO.getCperiod())
		.append("'");
		getBmdataQueryDAO().getBaseDao().deleteByClause(BmdataDspVO.class, whereStr.toString());
	}

	@Override
	public void deleteBmdataDsp4Psndoc(BmClassEndVO bmClassEndVO, BmLoginContext context)
			throws BusinessException {
		StringBuffer whereStr = new StringBuffer();
		whereStr.append(" pk_user = '").append(context.getPk_loginUser())
		.append("' and pk_org='").append(bmClassEndVO.getPk_org())
		.append("' and cyear='").append(bmClassEndVO.getCyear())
		.append("' and cperiod='").append(bmClassEndVO.getCperiod())
		.append("'");
		getBmdataQueryDAO().getBaseDao().deleteByClause(BmdataDspVO.class, whereStr.toString());
	}

	@Override
	@SuppressWarnings("unchecked")
	public List<BmdataDspVO> queryBmdataDsp4Class(BmClassEndVO bmClassEndVO)
			throws BusinessException {
		StringBuffer whereStr = new StringBuffer();
		whereStr.append(" pk_bm_class='").append(bmClassEndVO.getPk_bm_class())
		.append("' and pk_org='").append(bmClassEndVO.getPk_org())
		.append("' and cyear='").append(bmClassEndVO.getCyear())
		.append("' and cperiod='").append(bmClassEndVO.getCperiod())
		.append("'");
		return (List<BmdataDspVO>) getBmdataQueryDAO().getBaseDao().retrieveByClause(
				BmdataDspVO.class, whereStr.toString());
	}

	@Override
	@SuppressWarnings("unchecked")
	public List<BmdataDspVO> queryBmdataDsp4Psndoc(BmClassEndVO bmClassEndVO,
			BmLoginContext context) throws BusinessException {
		StringBuffer whereStr = new StringBuffer();
		whereStr.append(" pk_user = '").append(context.getPk_loginUser())
		.append("' and pk_org='").append(bmClassEndVO.getPk_org())
		.append("' and cyear='").append(bmClassEndVO.getCyear())
		.append("' and cperiod='").append(bmClassEndVO.getCperiod())
		.append("'");
		return (List<BmdataDspVO>) getBmdataQueryDAO().getBaseDao().retrieveByClause(
				BmdataDspVO.class, whereStr.toString());
	}

	/**
	 * רΪҳṩ
	 */
	@Override
	public BmDataVO[] queryBmDataVOByPKS(String[] pks) throws BusinessException {
		if(ArrayUtils.isEmpty(pks)){
			return new BmDataVO[0];
		}
		InSQLCreator inSQLCreator = new InSQLCreator();
		try{
			String insql = inSQLCreator.getInSQL(pks);
			String conditon = " bm_data.pk_bm_data in (" + insql +") ";
			BmDataVO[] bmDataVOArrays = getBmdataQueryDAO().queryByCondition( conditon);

			//autor erl 2011-8-19 09:09  ˳
			List<BmDataVO> BmDataVOList = new ArrayList<BmDataVO>();
			Map<String,BmDataVO> BmDataVOMap = new HashMap<String,BmDataVO>();
			for(BmDataVO bmDataVO : bmDataVOArrays){
				BmDataVOMap.put(bmDataVO.getPk_bm_data(), bmDataVO);
			}
			for(String strPK : pks){
				BmDataVOList.add(BmDataVOMap.get(strPK));
			}

			return  BmDataVOList.toArray(new BmDataVO[0]);
		}finally{
			inSQLCreator.clear();
		}

	}
	@Override
	public String[] queryPKSByCondition(BmLoginContext context,
			String condition, String orderSQL) throws BusinessException {
		// TODO Auto-generated method stub
		return getBmdataQueryDAO().queryPKSByCondition(context, condition, orderSQL);
	}
	@Override
	public BmDataVO querySumDataVo(BmLoginContext context, String condition,
			BmClassItemVO[] items) throws BusinessException {
		// TODO Auto-generated method stub
		return getBmdataQueryDAO().querySumDataVo(context, condition, items);
	}

	/**
	 *
	 * @param pk_group
	 * @param cyear
	 * @return
	 * @throws BusinessException
	 */
	@Override
	public AppendableVO[] getCacuItem(String pk_group, String cyear) throws BusinessException {
		return getBmdataBudgetAlarmDao().getCacuItem(pk_group, cyear);
	}

	/**
	 *
	 * @param pk_orgs
	 * @param items
	 * @param accYear
	 * @param accPeriod
	 * @return
	 * @throws BusinessException
	 */
	@Override
	public AppendableVO[] getOrgRealTm(String[] pk_orgs, AppendableVO[] items, String accYear, String accPeriod) throws BusinessException {
		return getBmdataBudgetAlarmDao().getOrgRealTm(pk_orgs,
				items, accYear, accPeriod, BmdataBudgetAlarmDao.CURRPERIOD);
	}

	/**
	 *
	 * @param pk_org
	 * @param pk_depts
	 * @param items
	 * @param accYear
	 * @param accPeriod
	 * @return
	 * @throws BusinessException
	 */
	@Override
	public AppendableVO[] getDeptRealTm(String pk_org, String[] pk_depts, AppendableVO[] items, String accYear, String accPeriod) throws BusinessException {
		return getBmdataBudgetAlarmDao().getDeptRealTm(pk_org,
				pk_depts, items, accYear, accPeriod, BmdataBudgetAlarmDao.CURRPERIOD);
	}
}
