package nc.impl.bm.bmfile;

import nc.bs.bd.baseservice.busilog.BDBusiLogUtil;
import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.common.NCLocator;
import nc.bs.uif2.LockFailedException;
import nc.hr.frame.persistence.BaseDAOManager;
import nc.hr.frame.persistence.IValidatorFactory;
import nc.hr.frame.persistence.SimpleDocServiceTemplate;
import nc.hr.utils.InSQLCreator;
import nc.hr.utils.PubEnv;
import nc.hr.utils.ResHelper;
import nc.hr.utils.StringPiecer;
import nc.impl.bm.bmdata.BmDataLocker;
import nc.impl.bm.end.MonthEndDAO;
import nc.impl.bm.pub.BmQueryUtils;
import nc.itf.bm.bmfile.IBmfileManageService;
import nc.itf.bm.bmfile.IBmfileQueryService;
import nc.itf.bm.bmfile.IHRBmfileConstant;
import nc.itf.hr.wa.IPayfileManageService;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.jdbc.framework.processor.ResultSetProcessor;
import nc.pubitf.resa.costcenter.ICostCenterPubService;
import nc.vo.bm.bmclass.AssignclsVO;
import nc.vo.bm.bmclass.BmClassConstant;
import nc.vo.bm.bmclass.BmClassVO;
import nc.vo.bm.data.BmDataVO;
import nc.vo.bm.end.BmClassEndVO;
import nc.vo.bm.pub.BmLoginContext;
import nc.vo.bm.pub.BmMetaDataConstant;
import nc.vo.bm.pub.BmPowerSqlHelper;
import nc.vo.bm.pub.IHRBMDataResCode;
import nc.vo.hi.pub.CommonValue;
import nc.vo.hi.pub.HICommonValue;
import nc.vo.hr.comp.trn.PsnTrnVO;
import nc.vo.hr.pub.FormatVO;
import nc.vo.jcom.lang.StringUtil;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFLiteralDate;
import nc.vo.uif2.LoginContext;
import nc.vo.util.BDPKLockUtil;
import nc.vo.util.BDVersionValidationUtil;
import nccloud.commons.lang.ArrayUtils;
import nccloud.commons.lang.StringUtils;
import nccloud.pub.utils.HRBDPKLockUtil;

import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * @author duyao
 * @version NCdp205268341 ϲ
 * ѯ½ԱϢʱqueryTrnPsnInfoУ飬½ԱڱڼӵǷѼ룬ʾԱ
 * ʾ ½ԱʱinsertBmDataVOsУ飬ǰԱѾӹ˵
 */
public class BmfileManageServiceImpl implements IBmfileManageService, IBmfileQueryService {
    private BmfileDao dao;

    private final String DOC_NAME = "Bmfile";

    private SimpleDocServiceTemplate serviceTemplate;

    private InSQLCreator inSQLCreator;

    @Override
    public void batchAddPsn(BmDataVO[] vos, BmDataVO[] classInfo, BmLoginContext context) throws BusinessException {

        if (vos != null && vos.length > 0) {
            try {
                // BDPKLockUtil.lockString(vos[0].getPk_org() +
                // vos[0].getCyear() + vos[0].getCperiod());
                BmClassVO[] bmclassVos = this.getBmfileDao().retrieveByClause(BmClassVO.class,
                        "pk_org = '" + context.getPk_org() + "' and cyear='" + vos[0].getCyear() + "' and cperiod='"
                                + vos[0].getCperiod() + "'");
                if (null != bmclassVos) {
                    for (int i = 0; i < bmclassVos.length; i++) {
                        BDPKLockUtil.lockString(bmclassVos[i].getPk_bm_class());
                    }
                }
            } catch (LockFailedException le) {
                throw new BusinessException(ResHelper.getString("60150bmdata", "060150bmdata0002")
                        /* @res "޸ģԺ" */);
            }
            // checkRepeatBmClass(vos, false);
        }
        List<BmDataVO> insertList = new ArrayList<BmDataVO>();

        HashMap<String, BmDataVO[]> bmdatamap = new HashMap<String, BmDataVO[]>();
        /*
         * ͨclassidѯŷ
         */

        AssignclsVO[] assignclsVOs = queryAssignclsVOsByClassVOs(classInfo);
        Map<String, String> map4Assigncls = new HashMap<String, String>();
        if (!ArrayUtils.isEmpty(assignclsVOs)) {
            for (int i = 0; i < assignclsVOs.length; i++) {
                map4Assigncls.put(assignclsVOs[i].getClassid(), assignclsVOs[i].getPk_assigncls());
            }
        }
        String[] clspk = null;
        BaseDAO bdao = getBmfileDao().getBaseDao();
        BmDataVO[] bmDataVOs = this.getBmfileDao().retrieveByClause(BmDataVO.class,
                "pk_org = '" + context.getPk_org() + "' and cyear='" + vos[0].getCyear() + "' and cperiod='"
                        + vos[0].getCperiod() + "'");
        HashMap<String, BmDataVO> bmdatamapHave = new HashMap<String, BmDataVO>();
        if(bmDataVOs!=null&&bmDataVOs.length>0){
            for(BmDataVO bmDataVO : bmDataVOs){
                bmdatamapHave.put(bmDataVO.getPk_psndoc()+bmDataVO.getPk_bm_class(),bmDataVO);
                //Logger.error(bmDataVO.getPk_psndoc()+bmDataVO.getPk_bm_class());
            }
        }
        for (int i = 0; i < classInfo.length; i++) {
            // insertList.clear();
            String pk_bm_class = classInfo[i].getPk_bm_class();
            List<BmDataVO> bmclspsnlist = new ArrayList<BmDataVO>();
            for (int j = 0; j < vos.length; j++) {
                if ("Y".equals(vos[j].getAttributeValue(pk_bm_class))) {
                    //Logger.error(vos[j].getPk_psndoc()+pk_bm_class+2);
                    if(bmdatamapHave.containsKey(vos[j].getPk_psndoc()+pk_bm_class)){
                        continue;
                    }
                    BmDataVO copyVo = (BmDataVO) vos[j].clone();
                    copyVo.setPk_bm_class(pk_bm_class);
                    copyVo.setPk_group(context.getPk_group());
                    copyVo.setPk_org(context.getPk_org());
                    copyVo.setCyear(context.getCyear());
                    copyVo.setCperiod(context.getCperiod());
                    copyVo.setPaylocation(classInfo[i].getPaylocation());
                    copyVo.setDbegindate(classInfo[i].getDbegindate());
                    copyVo.setCaculateflag(UFBoolean.FALSE);
                    copyVo.setCheckflag(UFBoolean.FALSE);
                    copyVo.setAccountstate(IHRBmfileConstant.ACCOUNTSTATE_NORMAL);
                    copyVo.setAccounttype(IHRBmfileConstant.ACCOUNTTYPE_NEW);
                    copyVo.setPk_sourcecls(map4Assigncls.get(classInfo[i].getPk_bm_class()));
                    bmclspsnlist.add(copyVo);
                }
            }
            insertList.addAll(bmclspsnlist);
            bmdatamap.put(pk_bm_class, bmclspsnlist.toArray(new BmDataVO[0]));
            clspk = (String[]) ArrayUtils.add(clspk, pk_bm_class);
            // if (!insertList.isEmpty())
            // {
            // /*
            // * У
            // * */
            // checkRepeatBmClass(insertList.toArray(new BmDataVO[0]), false);
            //
            // bdao.insertVOList(insertList);
            //
            //
            // BmClassVO bmClass = new BmClassVO();
            // bmClass.setPk_bm_class(classInfo[i].getPk_bm_class());
            // // ͬ֯ɱ
            // getBmfileDao().synFiAndCostOrg(insertList.toArray(new
            // BmDataVO[insertList.size()]),bmClass);
            // }
        }
        if (!insertList.isEmpty()) {
            /*
             * У
             */
            checkRepeatBmClass(insertList.toArray(new BmDataVO[0]), false);

            bdao.insertVOList(insertList);
            // ͬ֯ɱ
            getBmfileDao().synFiAndCostOrg(bmdatamap, clspk);
        }
    }

    @Override
    public AssignclsVO[] queryAssignclsVOsByClassVOs(BmDataVO[] classInfo) throws BusinessException {
        return getBmfileDao().queryAssignclsVOsByClassVOs(classInfo);
    }

    @Override
    public void batchDelBmfile(BmDataVO[] vos) throws BusinessException {
        String[] pkBmclasses = null;
        if (ArrayUtils.isNotEmpty(vos)) {
            pkBmclasses = StringPiecer.getStrArrayDistinct(vos, "pk_bm_class");
            try {
				/*BmClassVO[] bmclassVos = this.getBmfileDao().retrieveByClause(BmClassVO.class,
						"pk_org = '" + vos[0].getPk_org() + "' and cyear='" + vos[0].getCyear() + "' and cperiod='"
								+ vos[0].getCperiod() + "'");
				if (null != bmclassVos) {
					for (int i = 0; i < bmclassVos.length; i++) {
						BDPKLockUtil.lockString(bmclassVos[i].getPk_bm_class());
					}
				}*/
                //ֻҪɾ
                for (int i = 0; i < pkBmclasses.length; i++) {
                    BDPKLockUtil.lockString(pkBmclasses[i]);
                }

            } catch (LockFailedException le) {
                throw new BusinessException(ResHelper.getString("60150bmdata", "060150bmdata0002")
                        /* @res "޸ģԺ" */);
            }
        }
        getBmfileDao().getBaseDao().deleteVOArray(vos);
        HRBDPKLockUtil lockUtil = new HRBDPKLockUtil();
        if (ArrayUtils.isNotEmpty(pkBmclasses)) {
            lockUtil.releaseDynamicLock(pkBmclasses);
        }
        new BDBusiLogUtil(BmMetaDataConstant.BM_DATA_MDID).writeBusiLog(BmMetaDataConstant.DELETE, "", vos);
    }

    @Override
    public void delete(BmDataVO vo) throws BusinessException {
        getServiceTemplate().delete(vo);
        new BDBusiLogUtil(BmMetaDataConstant.BM_DATA_MDID).writeBusiLog(BmMetaDataConstant.DELETE, "", vo);
    }

    @Override
    public void deleteBmfileDsp4Psndoc(BmClassEndVO bmClassEndVO, BmLoginContext context) throws BusinessException {
        return;
    }

    @Override
    public void deleteDisplayInfo(BmLoginContext context, String type) throws BusinessException {
        return;
    }

    private String getAddWhere(int trnType, BmLoginContext context) {
        StringBuffer sqlB = new StringBuffer();
        sqlB.append(" and psnjob.pk_group = '").append(context.getPk_group()).append("' ");
        if (CommonValue.TRN_SUB == trnType || CommonValue.TRN_POST_MOD == trnType) {// 籣Ա,Ϊͬһ֯ϵ
            sqlB.append(" and exists ");
            sqlB.append(" (select pk_psndoc from bm_data ");
            sqlB.append(
                    " where bm_data.pk_psndoc = psnjob.pk_psndoc and  bm_data.assgid = psnjob.assgid  and bm_data.pk_psnorg = psnjob.pk_psnorg");
            sqlB.append(" and bm_data.pk_org = '").append(context.getPk_org()).append("' ");
            sqlB.append(" and bm_data.cyear = '").append(context.getCyear()).append("' ");
            sqlB.append(" and bm_data.cperiod = '").append(context.getCperiod()).append("'");
            sqlB.append(" and bm_data.accountstate = '0' ");
            sqlB.append(" and bm_data.checkflag = 'N') ");
        } else if (CommonValue.TRN_ADD == trnType) { // queryTrnPsnInfo
            /*
             * sqlB.append(" and not exists "); sqlB.append(
             * " (select pk_psndoc from bm_data "); sqlB.append(
             * " where bm_data.pk_psndoc = psnjob.pk_psndoc "); sqlB. append(
             * " and bm_data.pk_org = '").append(context.getPk_org()) .append(
             * "' "); sqlB.append(" and bm_data.cyear = '").append(context
             * .getCyear()).append("' "); sqlB.append(" and bm_data.cperiod = '"
             * ) .append(context.getCperiod()).append("') "); sqlB.append(
             * " and psnjob.pk_org  in ("
             * ).append(AOSSQLHelper.getChildrenBUInSQLByHROrgPK
             * (context.getPk_org())).append(") ");
             */

        }
        return sqlB.toString();
    }

    @Override
    public Map<String, Object> getAllPeriod(String pk_org) throws BusinessException {
        return getBmfileDao().getAllPeriod(pk_org);
    }

    @Override
    public Map<String, Object> getAllPeriodForRpt(String whereSql) throws BusinessException {
        return getBmfileDao().getAllPeriodForRpt(whereSql);
    }

    private BmfileDao getBmfileDao() {
        if (dao == null) {
            dao = new BmfileDao();
        }

        return dao;
    }

    @Override
    public BmDataVO[] getPkFinanceOrg(BmDataVO[] array) throws BusinessException {
        return getBmfileDao().getPkFinanceOrg(array);

    }

    private SimpleDocServiceTemplate getServiceTemplate() {
        if (serviceTemplate == null) {
            serviceTemplate = new SimpleDocServiceTemplate(DOC_NAME);
            serviceTemplate.setLocker(new BmDataLocker());
        }

        return serviceTemplate;
    }

    @Override
    public String getSqlForFormular(String pk_bm_class, String itemid, String period, String cyear, String cperiod,
                                    String pk_psndocRef) {
        StringBuffer sqlBuffer = new StringBuffer();
        sqlBuffer.append("select max(data_source." + itemid + ")"); // 1
        sqlBuffer.append("  from bm_data data_source ");
        // guoqtNCdp204998627żнʷĿȡ籣
        sqlBuffer.append(" where (data_source.pk_bm_class in (select  classid from bm_assigncls where pk_sourcecls ='"
                + pk_bm_class + "'  and classid <>'" + pk_bm_class + "') or" + " data_source.pk_bm_class = '"
                + pk_bm_class + "'");
        // guoqt нʿȡ֯籣ݣ֯нA֯籣B֯ǸֱǼŷָ֯B
        // ͨнѡַ伯֣ٲҼַָ֯ĸ
        sqlBuffer.append("   or (data_source.pk_bm_class in ( select  classid from bm_assigncls where pk_sourcecls in  "
                + " (select  pk_sourcecls from bm_assigncls where classid= '" + pk_bm_class + "') ) ) ) ");
        sqlBuffer.append("   and data_source.cyear ='" + cyear + "' and data_source.cperiod = '" + cperiod + "' ");
        sqlBuffer.append("   and data_source.pk_psndoc = " + pk_psndocRef);
        sqlBuffer.append("   and data_source.checkflag = 'Y' ");
        return sqlBuffer.toString();
    }

    @Override
    public BmDataVO insert(BmDataVO vo) throws BusinessException {
        return getServiceTemplate().insert(vo);
    }

    @Override
    public BmDataVO[] insertBmDataVOs(BmDataVO[] vos, BmLoginContext context) throws BusinessException {
        String[] pkBmclasses = null;
        if (ArrayUtils.isNotEmpty(vos)) {
            pkBmclasses = StringPiecer.getStrArrayDistinct(vos, "pk_bm_class");
            try {
				/*BmClassVO[] bmclassVos = this.getBmfileDao().retrieveByClause(BmClassVO.class,
						"pk_org = '" + vos[0].getPk_org() + "' and cyear='" + vos[0].getCyear() + "' and cperiod='"
								+ vos[0].getCperiod() + "'");
				if (null != bmclassVos) {
					for (int i = 0; i < bmclassVos.length; i++) {
						BDPKLockUtil.lockString(bmclassVos[i].getPk_bm_class());
					}
				}*/
                //ֻҪɾ
                for (int i = 0; i < pkBmclasses.length; i++) {
                    BDPKLockUtil.lockString(pkBmclasses[i]);
                }
            } catch (LockFailedException le) {
                throw new BusinessException(ResHelper.getString("60150bmdata", "060150bmdata0002")
                        /* @res "޸ģԺ" */);
            }
            checkRepeatBmClass(vos, false);
            // ȥظ
            vos = removeRepeatBmClass(vos);
        }
        BmDataVO[] bmDataVOs = getBmfileDao().insertVOArrayReturnVOArray(vos);
        HRBDPKLockUtil lockUtil = new HRBDPKLockUtil();
        if (ArrayUtils.isNotEmpty(pkBmclasses)) {
            lockUtil.releaseDynamicLock(pkBmclasses);
        }
        return bmDataVOs;
    }

    // ȥظ
    private BmDataVO[] removeRepeatBmClass(BmDataVO[] vos) throws BusinessException {

        List<BmDataVO> bmDataVOList = new ArrayList<BmDataVO>();
        List<BmDataVO> repeatbmDataVOList = new ArrayList<BmDataVO>();
        for (int i = 0; i < vos.length; i++) {
            // ȡ籣
            BmDataVO[] davos = queryBmDataByPsndoc(vos[i].getPk_group(), vos[i].getPk_org(), vos[i].getPk_psndoc(),
                    vos[i].getCyear(), vos[i].getCperiod());
            if (davos == null) {
                continue;
            } else {
                for (int j = 0; j < davos.length; j++) {
                    if (vos[i].getPk_bm_class().equals((davos[j].getPk_bm_class()))) {
                        // ȡظ籣
                        repeatbmDataVOList.add(vos[i]);
                    }
                }
            }
        }
        for (int i = 0; i < vos.length; i++) {
            if (!repeatbmDataVOList.contains(vos[i])) {
                bmDataVOList.add(vos[i]);
            }
        }
        return bmDataVOList.toArray(new BmDataVO[0]);
    }

    @Override
    public void checkRepeatBmClass(BmDataVO[] vos, boolean isTransferIn) throws BusinessException {
        InSQLCreator isc = new InSQLCreator();
        String[] strFields = BmClassConstant.DATAPSN_COLUMNFILE;
        String tablename = isc.insertValues(BmClassConstant.BM_TEMP_DATAPSNFILE, strFields, strFields, vos);
        /* ֤ǷԱͬһڼǷ֯ӹ */
        if (isTransferIn) {
            BmDataVO[] checkVOs = getBmfileDao().checkRepeatBmClass(vos, tablename);
            if (!ArrayUtils.isEmpty(checkVOs)) {
                StringBuffer message = new StringBuffer();
                message.append(ResHelper.getString("60150bmdata", "060150bmdata0103")
                        /* @res "ڼ£" */);
                for (int i = 0; i < checkVOs.length; i++) {
                    message.append("\n");
                    message.append(MessageFormat.format(ResHelper.getString("60150bmdata", "060150bmdata0102")
                            /* @res "Ա[{0}]֯[{1}]Ѵ[{2}]" */, checkVOs[i].getPsnname(), checkVOs[i].getOrgname(),
                            checkVOs[i].getClassname()));
                }
                throw new BusinessException(message.toString());
            }
        } else {
            /* ֤ǷԱǷ֯ת */
            BmDataVO[] checkVOs = getBmfileDao().checkTransfOutBmClass(vos, tablename);
            if (!ArrayUtils.isEmpty(checkVOs)) {
                StringBuffer message = new StringBuffer();
                for (int i = 0; i < checkVOs.length; i++) {
                    message.append(ResHelper.getString("60150bmdata", "060150bmdata0111", checkVOs[i].getClassname(),
                            checkVOs[i].getCyear() + checkVOs[i].getCperiod(), checkVOs[i].getPsnname())
                            /* @res "{0}{1}ڼ£ѴԱ{2}תݣӣ" */);
                    message.append("\n");
                }
                throw new BusinessException(message.toString());
            }
        }
    }

    @Override
    public BmClassVO[] queryBmClass(BmLoginContext loginContext, boolean isGroup, boolean isCheck)
            throws BusinessException {
        return getBmfileDao().queryBmClass(loginContext, isGroup, isCheck);
    }

    @Override
    public BmClassVO[] queryBmClassForAdd(String pk_org, String pk_psnjob, String cyear, String cperiod,
                                          String pk_group) throws BusinessException {
        return getBmfileDao().queryBmClassForAdd(pk_org, pk_psnjob, cyear, cperiod, pk_group);
    }

    // 20151021 xiejie3 NCdp205514521 ѯ籣ɽݣȨ޿ƣpk_groupѯȨޣ
    @Override
    public BmDataVO[] queryBmDataByPsndoc(String pk_group, String pk_org, String pk_psndoc, String cyear,
                                          String cperiod) throws BusinessException {
        String sql = "select distinct itemkey from bm_classitem  " + "where pk_bm_class in " + "("
                + " select pk_bm_class from bm_data " + " where bm_data.pk_org = '" + pk_org + "' "
                + " and bm_data.pk_psndoc = '" + pk_psndoc + "'  " + " and bm_data.cyear = '" + cyear + "' "
                + " and bm_data.cperiod = '" + cperiod + "' " + ")" + " and cyear = '" + cyear + "' and cperiod = '"
                + cperiod + "' and bm_classitem.category_id = '" + BmClassConstant.DOC_CATEGORY_ID + "' ";

        List<String> listFileds = (List<String>) getBmfileDao().getBaseDao().executeQuery(sql.toString(), null,
                new ColumnListProcessor("itemkey"));
        StringBuffer sbd = new StringBuffer();
        for (int i = 0; i < listFileds.size(); i++) {
            sbd.append("bm_data." + listFileds.get(i) + ",");
        }
        return getBmfileDao().queryBmDataByPsndoc(pk_group, pk_org, pk_psndoc, cyear, cperiod, sbd.toString());
    }

    @Override
    public BmDataVO[] queryBmfile(BmLoginContext loginContext, String condition) throws BusinessException {
        return getBmfileDao().queryBmfile(loginContext, condition, null);
    }

    @Override
    public BmDataVO[] queryBmfile(BmLoginContext loginContext, String[] strPks) throws BusinessException {

        String inCondition = getPsnInsql(strPks);
        return getBmfileDao().queryBmfile(loginContext, inCondition, null);
    }

    /**
     * 籣пתɾ
     *
     * @param loginContext
     * @param condition
     * @return
     * @throws BusinessException
     */
    @Override
    public BmDataVO[] queryBmfile4TransferOut(BmLoginContext loginContext, String condition, String powerSql)
            throws BusinessException {
        return getBmfileDao().queryBmfile4DelAndTransferOut(loginContext, condition, null, powerSql);
    }

    @Override
    public BmDataVO[] queryBmfile4Del(BmLoginContext loginContext, String condition, String powerSql)
            throws BusinessException {
        return getBmfileDao().queryBmfile4DelAndTransferOut(loginContext, condition, IHRBmfileConstant.ACTION_BATCHDEL,
                powerSql);
    }

    @Override
    public BmDataVO[] queryBmfileForTrnIn(BmLoginContext loginContext, String condition) throws BusinessException {
        return getBmfileDao().queryBmfile(loginContext, condition, IHRBmfileConstant.ACTION_TRANSFERIN);
    }

    @Override
    public BmDataVO[] queryBmfileForTrnIn(BmLoginContext loginContext, String[] strPks) throws BusinessException {
        String inCondition = getPsnInsql(strPks);
        return getBmfileDao().queryBmfile(loginContext, inCondition, IHRBmfileConstant.ACTION_TRANSFERIN);
    }

    @Override
    public BmDataVO[] queryBmfileForTrnOutCancel(BmLoginContext loginContext, String condition)
            throws BusinessException {
        return getBmfileDao().queryBmfile(loginContext, condition, IHRBmfileConstant.ACTION_TRNOUTCANCEL);
    }

    @Override
    public BmDataVO[] queryBmfileForTrnOutCancel(BmLoginContext loginContext, String[] strPks)
            throws BusinessException {
        String inCondition = getPsnInsql(strPks);
        return getBmfileDao().queryBmfile(loginContext, inCondition, IHRBmfileConstant.ACTION_TRNOUTCANCEL);
    }

    @Override
    public BmDataVO[] queryBmfileForUnseal(BmLoginContext loginContext, String condition) throws BusinessException {
        return getBmfileDao().queryBmfileForUnseal(loginContext, condition, IHRBmfileConstant.ACTION_UNSEAL);
    }

    @Override
    public BmDataVO[] queryByCondition(BmLoginContext context, String condition, String orderby)
            throws BusinessException {
        return getBmfileDao().queryByCondition(context, condition, orderby);
    }

    @Override
    public BmDataVO[] queryByCondition(LoginContext context, String condition) throws BusinessException {
        BmLoginContext bmLoginContext = (BmLoginContext) context;
        if (bmLoginContext.getPk_org() == null || bmLoginContext.getCyear() == null
                || bmLoginContext.getCperiod() == null) {
            return null;
        }
        String sql = " accountstate = '0' ";
        if (condition != null && condition.indexOf("accountstate") > -1) {
            sql = condition;
        } else if (condition != null) {
            sql = sql + " and " + condition;
        }
        sql = sql + " and pk_org = '" + bmLoginContext.getPk_org() + "' and cyear = '" + bmLoginContext.getCyear()
                + "' and cperiod = '" + bmLoginContext.getCperiod() + "'";
        String powerSql = BmPowerSqlHelper.getRefPowerSql(context.getPk_group(), HICommonValue.RESOUCECODE_6007PSNJOB,
                IHRBMDataResCode.BMDEFAULT, "bm_data");
        if (!StringUtil.isEmptyWithTrim(powerSql)) {
            sql += " and " + powerSql;
        }
        return getServiceTemplate().queryByContextAndCondWithOrder(context, BmDataVO.class, sql,
                new String[]{"pk_psndoc"});
    }

    @Override
    public BmDataVO queryByPk(String pk) throws BusinessException {
        return getServiceTemplate().queryByPk(BmDataVO.class, pk);
    }

    @Override
    public String[] queryDeptsByCostCenter(String pk_costcenter) throws BusinessException {
        boolean isEnable = PubEnv.isModuleStarted(PubEnv.getPk_group(), PubEnv.MODULE_RESA);
        if (isEnable) {
            ICostCenterPubService costCenterPubService = NCLocator.getInstance().lookup(ICostCenterPubService.class);
            return costCenterPubService.queryDeptsByCostCenter(pk_costcenter).toArray(new String[0]);
        } else {
            return null;
        }
    }

    /**
     * רΪҳṩ
     */
    @Override
    public BmDataVO[] queryPayfileVOByPKS(String[] pks) throws BusinessException {
        if (ArrayUtils.isEmpty(pks)) {
            return new BmDataVO[0];
        }
        InSQLCreator inSQLCreator = new InSQLCreator();

        String insql = inSQLCreator.getInSQL(pks);
        String conditon = " bm_data.pk_bm_data in (" + insql + ") ";
        BmDataVO[] bmDataVOArrays = getServiceTemplate().queryByCondition(BmDataVO.class, conditon);

        // autor erl 2011-8-19 09:09 ˳
        List<BmDataVO> BmDataVOList = new ArrayList<BmDataVO>();
        Map<String, BmDataVO> BmDataVOMap = new HashMap<String, BmDataVO>();
        for (BmDataVO bmDataVO : bmDataVOArrays) {
            BmDataVOMap.put(bmDataVO.getPk_bm_data(), bmDataVO);
        }
        for (String strPK : pks) {
            BmDataVOList.add(BmDataVOMap.get(strPK));
        }

        return BmDataVOList.toArray(new BmDataVO[0]);
    }

    @Override
    public String[] queryPKSByCondition(BmLoginContext context, String condition, String orderSQL)
            throws BusinessException {
        // TODO Auto-generated method stub
        return getBmfileDao().queryPKSByCondition(context, condition, orderSQL);
    }

    @Override
    public BmDataVO queryPsnByPsnjob(String pk_psnjob) throws BusinessException {
        return getBmfileDao().queryPsnByPsnjob(pk_psnjob);
    }

    @Override
    public BmDataVO[] queryPsnForAdd(BmLoginContext loginContext, String condition) throws BusinessException {
        return getBmfileDao().queryPsnForAdd(loginContext, condition, true);
    }

    @Override
    public BmDataVO[] queryPsnForAddNCC(BmLoginContext loginContext, Set<String> pk_psnjob) throws BusinessException {
        InSQLCreator insql = new InSQLCreator();
        String inSQL = insql.getInSQL(pk_psnjob.toArray(new String[pk_psnjob.size()]));
        String condition = "pk_psnjob in (" + inSQL + ")";
        return getBmfileDao().queryPsnForAdd(loginContext, condition, true);
    }

    @Override
    public BmDataVO[] queryPsnForAdd(BmLoginContext loginContext, String[] strPks) throws BusinessException {
        String inCondition = getPsnInsql(strPks);
        return getBmfileDao().queryPsnForAdd(loginContext, inCondition, false);
    }
    // @Override
    // public PsnTrnVO[] queryTrnPsnInfo(BmLoginContext context, UFLiteralDate
    // beginDate, UFLiteralDate endDate, int trnType)
    // throws BusinessException
    // {
    // if (IHRBmfileConstant.TRN_TIN == trnType)
    // {
    // return getBmfileDao().queryTrnInBmfile(context);
    // }
    // else if (IHRBmfileConstant.TRN_TOUT == trnType)
    // {
    // return getBmfileDao().queryTrnOutBmfile(context);
    // }
    // IhrtrnQBS hrtrnQBS = NCLocator.getInstance().lookup(IhrtrnQBS.class);
    // return hrtrnQBS.queryTRNPsnInf(context.getPk_org(), beginDate, endDate,
    // trnType, getAddWhere(trnType, context));
    // }

    @Override
    public PsnTrnVO[] queryTrnPsnInfo(BmLoginContext context, UFLiteralDate beginDate, UFLiteralDate endDate,
                                      int trnType) throws BusinessException {
        if (IHRBmfileConstant.TRN_TIN == trnType) {
            return getBmfileDao().queryTrnInBmfile(context);
        } else if (IHRBmfileConstant.TRN_TOUT == trnType) {
            return getBmfileDao().queryTrnOutBmfile(context);
        } else if (CommonValue.TRN_ADD == trnType) {

            // ½Աѯ½ԱڱڼӵǷѼ룬ʾԱʾ
            IPayfileManageService hrtrnQBS = NCLocator.getInstance().lookup(IPayfileManageService.class);// ֿ
            PsnTrnVO[] psnTrnVO = hrtrnQBS.queryTRNPsnInf(context.getPk_org(), beginDate, endDate, trnType,
                    getAddWhere(trnType, context));
            if (psnTrnVO == null) {
                return psnTrnVO;
            }
            return andTrnAddPsnInf(context, psnTrnVO);
        }

        //IhrtrnQBS hrtrnQBS = NCLocator.getInstance().lookup(IhrtrnQBS.class);
        //return hrtrnQBS.queryTRNPsnInf(context.getPk_org(), beginDate, endDate, trnType, getAddWhere(trnType, context));
        // ֿ󽫴ƶн
        IPayfileManageService hrtrnQBS = NCLocator.getInstance().lookup(IPayfileManageService.class);
        return hrtrnQBS.queryTRNPsnInf(context.getPk_org(), beginDate, endDate, trnType, getAddWhere(trnType, context));
    }

    // ½Աѯ½ԱڱڼӵǷѼ룬ʾԱʾ
    private PsnTrnVO[] andTrnAddPsnInf(BmLoginContext context, PsnTrnVO[] psnTrnVO) throws DAOException {

        List<PsnTrnVO> psnTrnVOlist = new ArrayList<PsnTrnVO>();
        for (int i = 0; i < psnTrnVO.length; i++) {
            // ѯ
            BmClassVO[] bmClassVO = getBmfileDao().queryBmClassForAdd(context.getPk_org(), psnTrnVO[i].getPk_psnjob(),
                    context.getCyear(), context.getCperiod(), context.getPk_group());
            if (bmClassVO != null) {
                psnTrnVOlist.add(psnTrnVO[i]);
            }
        }

        return psnTrnVOlist.toArray(new PsnTrnVO[0]);
    }

    /* µĽӿ籣ʾãĿǰʱ */

    public void setValidatorFactory(IValidatorFactory docValidatorFactory) {
        getServiceTemplate().setValidatorFactory(docValidatorFactory);
    }

    public void singleAddPsn(BmDataVO vo, BmDataVO[] classInfo) throws DAOException {
        BmDataVO temp = null;
        List<BmDataVO> insetList = new ArrayList<BmDataVO>();
        for (int i = 0; i < classInfo.length; i++) {
            temp = (BmDataVO) vo.clone();
            temp.setPaylocation(classInfo[i].getPaylocation());
            temp.setDbegindate(classInfo[i].getDbegindate());
            temp.setBmaccountno(classInfo[i].getBmaccountno());
            temp.setAttributeValue("f_14", classInfo[i].getAttributeValue("f_14"));// 
            temp.setAttributeValue("f_15", classInfo[i].getAttributeValue("f_15"));// ڳ
            temp.setAttributeValue("f_16", classInfo[i].getAttributeValue("f_16"));// ۼ
            temp.setAttributeValue("f_17", classInfo[i].getAttributeValue("f_17"));// Ϣۼ
            insetList.add(vo);
        }
        getBmfileDao().getBaseDao().insertVOList(insetList);
    }

    @Override
    public void transferIn(BmDataVO[] vos) throws BusinessException {
        if (vos == null || vos.length == 0) {
            return;
        }
        // ΨһУ
        checkRepeatBmClass(vos, true);
        // õ֣ȥأ
        HashMap<String, List<BmDataVO>> bminfoLists = new HashMap<String, List<BmDataVO>>();
        for (int i = 0; i < vos.length; i++) {
            List<BmDataVO> bminfoList = bminfoLists.get(vos[i].getPk_bm_class());
            if (null == bminfoList) {
                bminfoList = new ArrayList<BmDataVO>();
            }

            bminfoList.add(vos[i]);
            bminfoLists.put(vos[i].getPk_bm_class(), bminfoList);
        }

        String pk_bm_class = FormatVO.formatArrayToString(bminfoLists.keySet().toArray(new String[0]), "'");
        List<BmClassVO> target = getBmfileDao().queryTransferClass(pk_bm_class, vos[0].getPk_org());
        BmClassVO[] source = getServiceTemplate().queryByPks(BmClassVO.class,
                bminfoLists.keySet().toArray(new String[0]));

        if (target == null) {

            throw new BusinessException(ResHelper.getString("60150bmfile", "060150bmfile0047")
                    /* @res "֯δҵӦ" */);
        } else if (target.size() < source.length) {
            StringBuilder msg = new StringBuilder();
            for (int i = 0; i < source.length; i++) {
                int j = 0;
                for (; j < target.size(); j++) {
                    if (null != source[i].getPk_bm_class()
                            && source[i].getPk_bm_class().equals(target.get(j).getPk_bm_class())) {
                        break;
                    }
                }
                if (j >= target.size()) {
                    msg.append(ResHelper.getString("60150bmfile", "060150bmfile0062", source[i].getMultilangName())
                            /* @res "{0}ڼѾ˲ת룡" */).append("\n");
                }
            }
            throw new BusinessException(msg.toString());
        } else if (target.size() == source.length) {
            // ڼΪڼ
            for (int i = 0; i < vos.length; i++) {

                for (int j = 0; j < target.size(); j++) {
                    if (null != vos[i].getPk_bm_class()
                            && vos[i].getPk_bm_class().equals(target.get(j).getPk_bm_class())) {
                        vos[i].setCyear(target.get(j).getCyear());
                        vos[i].setCperiod(target.get(j).getCperiod());
                    }
                }

            }
        } else {
            throw new BusinessException(ResHelper.getString("60150bmfile",
                    "060150bmfile0069")/* @res "쳣" */);
        }
        // fengwei 2012-09-27 תʱҪ¡ת͡
        // String[] updatFileds = new String[]{"accountstate", "pk_org",
        // "pk_transferorg", "pk_bm_class", "accounttype",
        // "paylocation","cyear","cperiod"};
        // xiejie3 籣תʱҪżɽתĿ֯paylocation
        String[] updatFileds = new String[]{"accountstate", "pk_org", "pk_transferorg", "pk_bm_class", "accounttype",
                "cyear", "cperiod"};
        getBmfileDao().getBaseDao().updateVOArray(vos, updatFileds);

        List<BmDataVO> voList = new ArrayList<BmDataVO>();
        BaseDAOManager manager = new BaseDAOManager();
        String sqlPayLocation = "select pk_loctrule from bm_locationrule where pk_group=pk_org and pk_loctrule ="
                + "( select paylocation from bm_data where pk_bm_data='";
        for (int i = 0; i < vos.length; i++) {
            String sqlPayLocation2 = sqlPayLocation + vos[i].getPk_bm_data() + "')";
            if (!manager.isValueExist(sqlPayLocation2)) {
                voList.add(vos[i]);

            }
        }
        String[] updatFileds2 = new String[]{"paylocation"};
        if (voList != null && voList.size() != 0) {
            BmDataVO[] vos2 = (BmDataVO[]) voList.toArray(new BmDataVO[voList.size()]);
            getBmfileDao().getBaseDao().updateVOArray(vos2, updatFileds2);
        }

        MonthEndDAO monthDao = new MonthEndDAO();
        // for(int j = 0;j<target.size();j++){
        // // ԱϢ仯Ϊµ
        // monthDao.updatePsnInfo(target.get(j),
        // bminfoLists.get(target.get(j).getPk_bm_class()).toArray(new
        // BmDataVO[0]));
        // }
        BmClassVO[] bmclsvos = target.toArray(new BmClassVO[0]);
        monthDao.updatePsnInfo(bmclsvos, bminfoLists);
        InSQLCreator inC = new InSQLCreator();
        // try
        // {
        String sql = " select * from bm_data where pk_bm_data in(" + inC.getInSQL(vos, BmDataVO.PK_BM_DATA) + ")";
        vos = getBmfileDao().executeQueryVOs(sql, BmDataVO.class); // ȡøԱ¼

        // }finally
        // {
        // inC.clear();
        // }

        bminfoLists = new HashMap<String, List<BmDataVO>>();
        for (int i = 0; i < vos.length; i++) {
            List<BmDataVO> bminfoList = bminfoLists.get(vos[i].getPk_bm_class());
            if (null == bminfoList) {
                bminfoList = new ArrayList<BmDataVO>();
            }

            bminfoList.add(vos[i]);
            bminfoLists.put(vos[i].getPk_bm_class(), bminfoList);
        }

        String[] bmclspks = null;
        HashMap<String, BmDataVO[]> map = new HashMap<String, BmDataVO[]>();
        for (int j = 0; j < target.size(); j++) {
            String pk = target.get(j).getPk_bm_class();
            map.put(pk, bminfoLists.get(pk).toArray(new BmDataVO[0]));
            bmclspks = (String[]) ArrayUtils.add(bmclspks, pk);
            // // ͬ֯ɱ
            // getBmfileDao().synFiAndCostOrg(bminfoLists.get(target.get(j).getPk_bm_class()).toArray(new
            // BmDataVO[0]),target.get(j));
        }
        // ͬ֯ɱ
        getBmfileDao().synFiAndCostOrg(map, bmclspks);

    }

    @Override
    public void transferOut(BmDataVO[] vos) throws BusinessException {
        if (vos == null || vos.length == 0) {
            return;
        }

        /*
         * //õ֣ȥأ Map<String,String> map = new HashMap<String,String>();
         * Map<String,String> orgMap = new HashMap<String,String>(); for(int
         * i=0;i<vos.length;i++){ map.put(vos[i].getPk_bm_class(), "");
         * orgMap.put(vos[i].getPk_transferorg(), ""); }
         *
         * Iterator orgIt = orgMap.keySet().iterator(); List target = null;
         * while(orgIt.hasNext()){ String pk_transferorg = (String)
         * orgIt.next(); String pk_bm_class =
         * FormatVO.formatArrayToString(map.keySet().toArray(new String[0]),
         * "'"); target = getBmfileDao().queryTransferClass(pk_bm_class,
         * pk_transferorg, vos[0].getCyear(), vos[0].getCperiod()); target =
         * Arrays.asList(map.keySet().toArray(new String[0])); if (target ==
         * null || target.size() != map.size()) { throw new
         * BusinessException(ResHelper.getString("60150bmfile",
         * "060150bmfile0046")
         *
         * @res "Ŀ֯δҵӦ" ); } }
         */
        validateHasTransferClass(vos);
        String[] updatFileds = new String[]{"accountstate", "pk_transferorg"};
        getBmfileDao().getBaseDao().updateVOArray(vos, updatFileds);
    }

    @Override
    public void transferOutCancel(BmDataVO[] vos) throws BusinessException {
        Map<String, List<BmDataVO>> bminfoLists = new HashMap<String, List<BmDataVO>>();
        for (int i = 0; i < vos.length; i++) {
            List<BmDataVO> bminfoList = bminfoLists.get(vos[i].getPk_bm_class());
            if (null == bminfoList) {
                bminfoList = new ArrayList<BmDataVO>();
            }

            bminfoList.add(vos[i]);
            bminfoLists.put(vos[i].getPk_bm_class(), bminfoList);
        }
        BmClassVO[] source = getServiceTemplate().queryByPks(BmClassVO.class,
                bminfoLists.keySet().toArray(new String[0]));
        for (int i = 0; i < vos.length; i++) {

            for (int j = 0; j < source.length; j++) {
                if (null != vos[i].getPk_bm_class() && vos[i].getPk_bm_class().equals(source[j].getPk_bm_class())) {
                    vos[i].setCyear(source[j].getCyear());
                    vos[i].setCperiod(source[j].getCperiod());
                }
            }

        }
        String[] updatFileds = new String[]{"accountstate", "pk_transferorg", "cyear", "cperiod"};
        getBmfileDao().getBaseDao().updateVOArray(vos, updatFileds);
    }

    @Override
    public BmDataVO update(BmDataVO vo) throws BusinessException {
        return getServiceTemplate().update(vo, true);
    }

    @Override
    public void updateAccountstate(BmDataVO[] vos) throws BusinessException {
        String[] updatFileds = new String[]{"accountstate", "vcancelreason"};
        getBmfileDao().getBaseDao().updateVOArray(vos, updatFileds);
    }

    @Override
    public BmDataVO[] updateBmDataVOs(BmDataVO[] vos) throws BusinessException {
        // // fengwei 2021-08-01 ޸ǰּ
        // BDPKLockUtil.lockSuperVO(vos);
        String[] pkBmclasses = null;
        if (ArrayUtils.isNotEmpty(vos)) {
            pkBmclasses = StringPiecer.getStrArrayDistinct(vos, "pk_bm_class");
            try {
/*				BmClassVO[] bmclassVos = this.getBmfileDao().retrieveByClause(BmClassVO.class,
						"pk_org = '" + vos[0].getPk_org() + "' and cyear='" + vos[0].getCyear() + "' and cperiod='"
								+ vos[0].getCperiod() + "'");
				if (null != bmclassVos) {
					for (int i = 0; i < bmclassVos.length; i++) {
						BDPKLockUtil.lockString(bmclassVos[i].getPk_bm_class());
					}
				}*/
                //ֻҪɾ
                for (int i = 0; i < pkBmclasses.length; i++) {
                    BDPKLockUtil.lockString(pkBmclasses[i]);
                }
            } catch (LockFailedException le) {
                throw new BusinessException(ResHelper.getString("60150bmdata", "060150bmdata0002")
                        /* @res "޸ģԺ" */);
            }
        }

        // 汾У飨ʱУ飩
        BDVersionValidationUtil.validateSuperVO(vos);

        // ѯҪµĿ
        StringBuffer sbd = new StringBuffer();
        sbd.append("select distinct itemkey from bm_classitem ");
        sbd.append(" where pk_bm_class in (");

        String[] pkBmClasses = StringPiecer.getStrArrayDistinct(vos, "pk_bm_class");
        int dataslength = pkBmClasses.length;
        for (int i = 0; i < dataslength; i++) {
            if (i == dataslength - 1) {
                sbd.append("'" + pkBmClasses[i] + "'");
            } else {
                sbd.append("'" + pkBmClasses[i] + "',");
            }
        }
        sbd.append(") and cyear = '" + vos[0].getCyear() + "' and cperiod = '" + vos[0].getCperiod()
                + "' and bm_classitem.category_id = '" + BmClassConstant.DOC_CATEGORY_ID + "' ");

        List<String> listFileds = (List<String>) getBmfileDao().getBaseDao().executeQuery(sbd.toString(), null,
                new ColumnListProcessor("itemkey"));
        // dzz İ¼Ҫµֶ Ҫ       20231018 dzz  ֯
        String[] updatFixFileds = new String[]{"glbdef1","glbdef2","glbdef3","glbdef4","bmaccountno", "paylocation", "dbegindate", "pk_financeorg",
                "fiporgvid", "pk_financedept", "fipdeptvid", "pk_liabilityorg", "pk_liabilitydept", "libdeptvid",
                "accountstate"};
        for (int i = 0; i < updatFixFileds.length; i++) {
            listFileds.add(updatFixFileds[i]);
        }

        getBmfileDao().getBaseDao().updateVOArray(vos, listFileds.toArray(new String[0]));
        HRBDPKLockUtil lockUtil = new HRBDPKLockUtil();
        if (ArrayUtils.isNotEmpty(pkBmclasses)) {
            lockUtil.releaseDynamicLock(pkBmclasses);
        }
        return queryBmDataByPsndoc(vos[0].getPk_group(), vos[0].getPk_org(), vos[0].getPk_psndoc(), vos[0].getCyear(),
                vos[0].getCperiod());
    }

    public void validateHasTransferClass(BmDataVO[] vos) throws BusinessException {
        Map<String, List<BmDataVO>> bminfoLists = new HashMap<String, List<BmDataVO>>();
        for (int i = 0; i < vos.length; i++) {
            List<BmDataVO> bminfoList = bminfoLists.get(vos[i].getPk_bm_class());
            if (null == bminfoList) {
                bminfoList = new ArrayList<BmDataVO>();
            }

            bminfoList.add(vos[i]);
            bminfoLists.put(vos[i].getPk_bm_class(), bminfoList);
        }
        String pk_bm_class = FormatVO.formatArrayToString(bminfoLists.keySet().toArray(new String[0]), "'");
        List<BmClassVO> target = getBmfileDao().queryAllTransferClass(pk_bm_class, vos[0].getPk_transferorg());
        List<BmClassVO> source = getBmfileDao().querySourceClass(pk_bm_class);

        if (ArrayUtils.isEmpty(target.toArray())) {
            throw new BusinessException(ResHelper.getString("60150bmfile", "060150bmfile0063")
                    /* @res "Ŀ֯δҵӦ֣" */);
        } else {
            StringBuilder msg = new StringBuilder();
            for (int i = 0; i < source.size(); i++) {
                int j = 0;
                for (; j < target.size(); j++) {
                    if (null != source.get(i).getPk_bm_class()
                            && source.get(i).getPk_bm_class().equals(target.get(j).getPk_bm_class())) {
                        break;
                    }
                }
                if (j >= target.size()) {
                    msg.append(ResHelper.getString("60150bmfile", "060150bmfile0064", source.get(i).getMultilangName())
                            /* @res "Ŀ֯δҵ{0}Ӧ֣" */).append("\n");
                }
            }
            if (!StringUtils.isEmpty(msg.toString())) {
                throw new BusinessException(msg.toString());
            }
        }
    }

    private String getPsnInsql(String[] strPks) throws BusinessException {
        if (inSQLCreator == null) {
            inSQLCreator = new InSQLCreator();
        }
        return "hi_psnjob.pk_psnjob in (" + inSQLCreator.getInSQL(strPks) + ")";
    }

    // 20150831 xiejie3 ϲNCdp205306564Ա䶯籣Ա䶯ת begin
    // shenliangc
    /*
     * 籣䶯Աֱнʵ䶯ԱĲѯ 䶯ԱҳǩչʾͬǱ䶯Աڱ֯һ¼Ϣ
     * Ա֯䲢ҹ¼仯Ч֯仯й¼ǿġ
     * ȻѡԱз棬߼ǸѡݵĹ¼bm_dataƥݣ
     * ʱԱϢ仯Ч¼ᴥ籣Ա¼ͬƣ
     * Ա¼޸Ϊ¹¼ע¹¼
     * ǰһ崫Ա¼ֻǵǰ֯µһ¼ԵȻ鲻ݡ
     *
     * 뵽ĽǣѡԱзʱԱѯݷ޸ģ
     * ֱӸѡеĹ¼ҪȸѡеԱϢѯԱ¼
     * Աһ¼Ϊѯвѯɡ
     *
     * ͬʱע⵽䵫¼仯ûЧҵÿƣĵԱ
     * bm_dataеpk_psnjobûи£Ȼǵǰ¼
     * ˽Ա䶯ԱĹ¼䶯δЧԹ¼Ĺ¼䶯Ч ĲΪѯ籣ѯ
     *
     * shenliangc 2014-04-14
     */
    @Override
    public String[] queryCurrentPkPsnJob(String[] psnDocPks, UFLiteralDate beginLDate, UFLiteralDate endLDate)
            throws BusinessException {
        return this.getBmfileDao().queryCurrentPkPsnJob(psnDocPks, beginLDate, endLDate);
    }

    @Override
    public BmDataVO[] queryBmDatadisplayByPsndoc(String pk_group, String pk_psndoc, String cyear, String cperiod)
            throws BusinessException {
        // TODO Auto-generated method stub
        String sql = "select distinct itemkey from bm_classitem  " + "where pk_bm_class in " + "("
                + " select pk_bm_class from bm_data " + " where  " + "bm_data.checkflag = 'Y' and bm_data.pk_psndoc = '" + pk_psndoc + "'  "
                + " and bm_data.cyear = '" + cyear + "' " + " and bm_data.cperiod = '" + cperiod + "' " + ")"
                + " and hrssdisplay ='Y' and cyear = '" + cyear + "' and cperiod = '" + cperiod
                + "' and bm_classitem.category_id = '" + BmClassConstant.DOC_CATEGORY_ID + "' ";

        List<String> listFileds = (List<String>) getBmfileDao().getBaseDao().executeQuery(sql.toString(), null,
                new ColumnListProcessor("itemkey"));
        StringBuffer sbd = new StringBuffer();
        for (int i = 0; i < listFileds.size(); i++) {
            sbd.append("bm_data." + listFileds.get(i) + ",");
        }
        return getBmfileDao().queryBmDataByPsndoc(pk_group, pk_psndoc, cyear, cperiod, sbd.toString());
    }

    @Override
    public Map<String, Object> getAllPeriodByPKPSNDOC(String pk_psndoc) throws BusinessException {
        // TODO Auto-generated method stub
        return getBmfileDao().getAllPeriodByPKPSNDOC(pk_psndoc);
    }

    @Override
    public BmDataVO[] queryBmDataPaydisplayByPsndoc(String pk_group, String pk_psndoc, String cyear, String cperiod)
            throws BusinessException {
        // TODO Auto-generated method stub
        String sql = "select distinct itemkey from bm_classitem  " + "where pk_bm_class in " + "("
                + " select pk_bm_class from bm_data " + " where  " + "bm_data.checkflag = 'Y' and bm_data.pk_psndoc = '" + pk_psndoc + "'  "
                + " and bm_data.cyear = '" + cyear + "' " + " and bm_data.cperiod = '" + cperiod + "' " + ")"
                + " and hrssdisplay ='Y' and cyear = '" + cyear + "' and cperiod = '" + cperiod
                + "' and bm_classitem.category_id = '" + BmClassConstant.PAY_CATEGORY_ID + "' ";

        List<String> listFileds = (List<String>) getBmfileDao().getBaseDao().executeQuery(sql.toString(), null,
                new ColumnListProcessor("itemkey"));
        StringBuffer sbd = new StringBuffer();
        for (int i = 0; i < listFileds.size(); i++) {
            sbd.append("bm_data." + listFileds.get(i) + ",");
        }
        return getBmfileDao().queryBmDataByPsndoc(pk_group, pk_psndoc, cyear, cperiod, sbd.toString());
    }

    @Override
    public String[] queryPersonByCondition(BmLoginContext context, String condition, String orderSQL)
            throws BusinessException {
        // TODO Auto-generated method stub
        return getBmfileDao().queryPersonByCondition(context, condition, orderSQL);
    }

    @Override
    public BmDataVO[] queryBmDataVOS(String pk_group, String PK_ORG, String pk_psndoc, String cyear, String cperiod, String condition, String orderCondtion)
            throws BusinessException {
        // TODO Auto-generated method stub

        String sql = "SELECT bm_data.*, bm_bmclass.name as classname, bm_bmclass.code as classcode, BM_LOCATIONRULE.name as paylocationname FROM bm_data left JOIN bm_bmclass on bm_data.pk_bm_class = bm_bmclass.pk_bm_class left JOIN BM_LOCATIONRULE ON bm_data.paylocation = BM_LOCATIONRULE.PK_LOCTRULE WHERE bm_data.PK_GROUP='" + pk_group + "' AND bm_data.PK_ORG='" + PK_ORG
                + "' AND bm_data.PK_PSNDOC='" + pk_psndoc + "' AND bm_data.CYEAR='" + cyear + "' AND bm_data.CPERIOD='" + cperiod + "'";
        String extsql = " bm_data.accountstate = '0' ";
        if (condition != null && condition.indexOf("accountstate") > -1) {
            extsql = " bm_data.pk_bm_data in (select pk_bm_data from bm_data where " + condition + ")";
        } else if (condition != null) {
            extsql = extsql + " and bm_data.pk_bm_data in (select pk_bm_data from bm_data where " + condition + ")";
        }
        String powerSql = BmPowerSqlHelper.getRefPowerSql(pk_group, HICommonValue.RESOUCECODE_6007PSNJOB,
                IHRBMDataResCode.BMDEFAULT, "bm_data");
        if (!StringUtil.isEmptyWithTrim(powerSql)) {
            extsql += " and " + powerSql;
        }
        powerSql = BmPowerSqlHelper.getRefPowerSql(pk_group, IHRBMDataResCode.BMCLASS,
                IHRBMDataResCode.BMCLASS, "bm_bmclass");
        if (!StringUtil.isEmptyWithTrim(powerSql)) {
            extsql += " and " + powerSql;
        }
        StringBuffer sqlBuffer = new StringBuffer();

        sqlBuffer.append(" select pk_bm_data from bm_data ");
        sqlBuffer.append(" inner join bm_bmclass on bm_data.pk_bm_class = bm_bmclass.pk_bm_class ");
        sqlBuffer.append(" inner join hi_psnjob on bm_data.pk_psnjob = hi_psnjob.pk_psnjob ");
        sqlBuffer.append(" left join org_dept on hi_psnjob.pk_dept = org_dept.pk_dept  ");
        if (StringUtils.isEmpty(orderCondtion)) {
            orderCondtion += " bm_data.pk_psndoc ";
        } else {
            orderCondtion += " ,bm_data.pk_psndoc ";
        }
        if (!StringUtil.isEmpty(orderCondtion)) {
            if (orderCondtion.contains("bd_psndoc.name")) {
                sqlBuffer.append(" inner join bd_psndoc on bm_data.pk_psndoc = bd_psndoc.pk_psndoc ");
            }
            if (orderCondtion.contains("org_orgs.name")) {
                sqlBuffer.append(" left join org_orgs on hi_psnjob.pk_org = org_orgs.pk_org ");
            }
            if (orderCondtion.contains("bd_psncl.name")) {
                sqlBuffer.append(" left outer join bd_psncl on hi_psnjob.pk_psncl = bd_psncl.pk_psncl ");
            }
            sqlBuffer.append(" where " + sql);
            sqlBuffer.append(" order by ").append(orderCondtion);
            sqlBuffer.append(" ,bm_bmclass.code");
        } else {
            sqlBuffer.append(" where " + sql);
            sqlBuffer.append(" order by bm_bmclass.code,org_dept.code,hi_psnjob.clerkcode ");
        }
        return new BaseDAOManager().executeQueryVOs(sql, BmDataVO.class);
    }

    @Override
    public BmDataVO[] queryPayfileVOsByPKS(String[] pks) throws BusinessException {
        // TODO Auto-generated method stub
        if (ArrayUtils.isEmpty(pks)) {
            return new BmDataVO[0];
        }
        InSQLCreator inSQLCreator = new InSQLCreator();

        String insql = inSQLCreator.getInSQL(pks);

        //BmDataVO[] bmDataVOArrays = getServiceTemplate().queryByCondition(BmDataVO.class, conditon);
        String sql = "SELECT bm_data.*, bm_bmclass.name as classname, bm_bmclass.code as classcode, BM_LOCATIONRULE.name as paylocationname FROM bm_data left JOIN bm_bmclass on bm_data.pk_bm_class = bm_bmclass.pk_bm_class left JOIN BM_LOCATIONRULE ON bm_data.paylocation = BM_LOCATIONRULE.PK_LOCTRULE WHERE bm_data.pk_bm_data in (" + insql + ") ";
        BmDataVO[] bmDataVOArrays = new BaseDAOManager().executeQueryVOs(sql, BmDataVO.class);
        // autor erl 2011-8-19 09:09 ˳
        List<BmDataVO> BmDataVOList = new ArrayList<BmDataVO>();
        Map<String, BmDataVO> BmDataVOMap = new HashMap<String, BmDataVO>();
        for (BmDataVO bmDataVO : bmDataVOArrays) {
            BmDataVOMap.put(bmDataVO.getPk_bm_data(), bmDataVO);
        }
        for (String strPK : pks) {
            BmDataVOList.add(BmDataVOMap.get(strPK));
        }

        return BmDataVOList.toArray(new BmDataVO[0]);
    }

    /**
     * @param pks
     * @param bmLoginContext
     * @param orderSQL
     * @return
     * @throws BusinessException
     */
    @Override
    public BmDataVO[] queryBmDataByPks(String[] pks, BmLoginContext bmLoginContext, String orderSQL) throws BusinessException {
        if (ArrayUtils.isEmpty(pks)) {
            return new BmDataVO[0];
        }
        InSQLCreator inSQLCreator = new InSQLCreator();
        String insql = inSQLCreator.getInSQL(pks);
        String conditon = " where bm_data.pk_bm_data in (" + insql + ") ";
        String sql = "select distinct itemkey from bm_classitem  " + "where pk_bm_class in " + "("
                + " select pk_bm_class from bm_data " + conditon + ")" + " and cyear = '" + bmLoginContext.getCyear() + "' and cperiod = '"
                + bmLoginContext.getCperiod() + "' and bm_classitem.category_id = '" + BmClassConstant.DOC_CATEGORY_ID + "' ";

        List<String> listFileds = (List<String>) getBmfileDao().getBaseDao().executeQuery(sql.toString(), null,
                new ColumnListProcessor("itemkey"));
        StringBuffer sbd = new StringBuffer();
        for (int i = 0; i < listFileds.size(); i++) {
            sbd.append("bm_data." + listFileds.get(i) + ",");
        }
        return getBmfileDao().queryBmDataByPks(insql, bmLoginContext.getPk_group(), orderSQL, sbd.toString());
    }

    /**
     * @param sql
     * @param pkField
     * @param pks
     * @param processor
     * @return
     * @throws BusinessException
     */
    @Override
    public Object executeQuery(String sql, String pkField, String[] pks, ResultSetProcessor processor) throws BusinessException {
        BmQueryUtils utils = new BmQueryUtils();
        return utils.executeQuery(sql, pkField, pks, processor);
    }

    // end
}
