package nc.impl.bm.end;

import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.common.NCLocator;
import nc.bs.logging.Logger;
import nc.bs.uap.oid.OidGenerator;
import nc.hr.bm.log.BmBusilogUtil;
import nc.hr.frame.persistence.AppendBeanArrayProcessor;
import nc.hr.frame.persistence.BaseDAOManager;
import nc.hr.frame.persistence.ILocker;
import nc.hr.frame.persistence.PersistenceDAO;
import nc.hr.frame.persistence.SimpleDocLocker;
import nc.hr.utils.CommonUtils;
import nc.hr.utils.InSQLCreator;
import nc.hr.utils.PubEnv;
import nc.hr.utils.ResHelper;
import nc.hr.utils.SQLHelper;
import nc.itf.bm.bmdata.IBmdataQueryService;
import nc.itf.bm.bmfile.IBmfileQueryService;
import nc.itf.bm.bmfile.IHRBmfileConstant;
import nc.itf.bm.pub.BMDelegator;
import nc.itf.hr.bm.IBmClassManageService;
import nc.itf.hr.bm.IBmClassQueryService;
import nc.itf.hr.frame.IPersistenceUpdate;
import nc.itf.org.ICloseAccModuleID;
import nc.itf.uap.busibean.SysinitAccessor;
import nc.jdbc.framework.SQLParameter;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.jdbc.framework.processor.MapProcessor;
import nc.jdbc.framework.util.DBConsts;
import nc.md.data.access.NCObject;
import nc.md.persist.framework.IMDPersistenceService;
import nc.md.persist.framework.MDPersistenceService;
import nc.pubitf.org.ICloseAccPubServicer;
import nc.pubitf.org.ICloseAccQryPubServicer;
import nc.util.bm.BmCacheUtils;
import nc.vo.bm.bmclass.AssignclsVO;
import nc.vo.bm.bmclass.BmClassConstant;
import nc.vo.bm.bmclass.BmClassItemVO;
import nc.vo.bm.bmclass.BmClassVO;
import nc.vo.bm.bmclass.BmFiorgVO;
import nc.vo.bm.data.BmDataVO;
import nc.vo.bm.data.BmDataroundVO;
import nc.vo.bm.data.BmdataDspVO;
import nc.vo.bm.dataitf.DataIOConstant;
import nc.vo.bm.end.BmClassEndVO;
import nc.vo.bm.end.IMonthEndType;
import nc.vo.bm.item.BmFromEnumVO;
import nc.vo.bm.period.BmPeriodstateVO;
import nc.vo.bm.pub.BmLoginContext;
import nc.vo.bm.pub.BmLoginVO;
import nc.vo.bm.pub.BmParaConstant;
import nc.vo.bm.pub.BmPowerSqlHelper;
import nc.vo.bm.pub.DataVOUtils;
import nc.vo.bm.pub.IHRBMDataResCode;
import nc.vo.hr.append.IAppendableVO;
import nc.vo.hr.datainterface.AggHrIntfaceVO;
import nc.vo.hr.datainterface.FormatItemVO;
import nc.vo.hr.datainterface.HrIntfaceVO;
import nc.vo.hr.datainterface.IfsettopVO;
import nc.vo.hr.pub.YearPeriodSeperatorVO;
import nc.vo.ml.MultiLangUtil;
import nc.vo.org.CloseAccBookVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.VOStatus;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pub.lang.UFLiteralDate;
import nc.vo.trade.sqlutil.IInSqlBatchCallBack;
import nc.vo.trade.sqlutil.InSqlBatchCaller;
import nc.vo.uif2.LoginContext;
import nc.vo.util.BDPKLockUtil;
import nc.vo.util.BDVersionValidationUtil;
import nccloud.commons.lang.ArrayUtils;
import nccloud.commons.lang.StringUtils;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;


/**
 * нĩ
 *
 * @author: suihang
 * @date: 2012-12-17 09:16:21
 * @since: eHR V6.0
 * @߲:
 * @߲:
 * @޸:
 * @޸:
 */
public class MonthEndDAO extends BaseDAOManager implements IMonthEndType {

    public static final String UPDATE = "update";
    private ILocker locker;
    private BmLoginContext context;


    public BmLoginContext getContext() {
        return context;
    }

    public void setContext(BmLoginContext context) {
        this.context = context;
    }

    public ILocker getLocker() {
        if (locker == null) {
            locker = new SimpleDocLocker();
        }

        return locker;
    }

    /**
     * ݲͻȡ
     *
     * @param context
     * @param actionType
     * @return
     * @throws BusinessException
     * @author suihang on 2012-3-16
     */
    protected BmClassEndVO[] getBmClassVOs(LoginContext context,
                                           String actionType) throws BusinessException {

        StringBuffer sqlBuffer = new StringBuffer();
        sqlBuffer.append("    select distinct bm_bmclass.pk_bm_class, "); // 1
        sqlBuffer.append("                     "
                + SQLHelper.getMultiLangNameColumn("org_orgs.name")
                + "  orgname, "); // 2
        sqlBuffer.append("                    bm_bmclass.code, "); // 3
        sqlBuffer.append("                     "
                + SQLHelper.getMultiLangNameColumn("bm_bmclass.name")
                + " name, "); // 2
        sqlBuffer.append("                    bm_bmclass.cyear, "); // 3
        sqlBuffer.append("                    bm_bmclass.cperiod, "); // 4
        sqlBuffer.append("                    bm_bmclass.pk_org, "); // 4
        sqlBuffer.append("                    bm_bmclass.currid, "); // 5
        sqlBuffer.append("                    bm_bmclass.ts "); // 5
        sqlBuffer
                .append("      from bm_bmclass, bm_periodstate, bm_period, org_orgs ");
        sqlBuffer
                .append("     where bm_bmclass.pk_bm_class = bm_periodstate.pk_bm_class ");
        sqlBuffer
                .append("       and bm_periodstate.pk_bm_period = bm_period.pk_bm_period ");
        sqlBuffer.append("       and bm_bmclass.cyear = bm_period.year ");
        sqlBuffer.append("       and bm_bmclass.pk_org = org_orgs.pk_org");
        sqlBuffer.append("       and bm_bmclass.cperiod = bm_period.period ");

        sqlBuffer.append("       and bm_periodstate.accountmark = 'N' ");
        //ʹȨ
        String powerSql = BmPowerSqlHelper.getRefPowerSql(context.getPk_group(), IHRBMDataResCode.BMCLASS, IHRBMDataResCode.BMCLASS,
                "bm_bmclass");
        if (StringUtils.isNotEmpty(powerSql)) {
            sqlBuffer.append(" and " + powerSql);
        }
        if (actionType != null) {
            if (actionType.equals(JZ)) {
//				20151021 xiejie3  ϲNCdp205496395
                // modify by zouj 2015/09/10 ֿ֧ս
//				sqlBuffer.append("       and bm_periodstate.checkflag = 'Y' ");// ڼѾŲδ
                sqlBuffer.append("       and (bm_periodstate.checkflag = 'Y' ");// ڼѾŲδ
                // ǰڼû
                sqlBuffer.append("       or bm_bmclass.pk_bm_class not in  ( select bm_bmclass.pk_bm_class from bm_bmclass inner join bm_data  on ");
                sqlBuffer.append("       bm_bmclass.pk_bm_class=bm_data.pk_bm_class and bm_bmclass.cyear=bm_data.cyear and bm_bmclass.cperiod=bm_data.cperiod)  ) ");


            } else if (actionType.equals(FJ)) {
                // ݵ¼ûʱñ˾Ȩ޵ĿԷʵн --ڼѾʣ һڼδ<BR>
                // ߼ϵ ڼѾʵڼ䣬 ҴڸڼСڼδ Created on 2012-9-4
                sqlBuffer
                        .append("       and bm_periodstate.checkflag = 'N' and bm_bmclass.stopflag='N' ");// ڼδ

                // һڼ
                sqlBuffer
                        .append("       and ((bm_bmclass.cyear || bm_bmclass.cperiod) > (bm_bmclass.startyear || bm_bmclass.startperiod))");
                //20151021 xiejie3  Ҫַʱܽзˡbegin
                sqlBuffer.append(" and not exists ( select 1 from bm_data where  bm_data.pk_bm_class =bm_bmclass.pk_bm_class  ");
                sqlBuffer.append(" and  bm_data.cyear=bm_period.year   ");
                sqlBuffer.append(" and  bm_data.cperiod=bm_period.period   ");
                sqlBuffer.append(" and  bm_data.checkflag ='Y' ) ");
                //end
            }
        }

        sqlBuffer.append("   and bm_bmclass.pk_org = '" + context.getPk_org()
                + "' ");

        sqlBuffer.append("       order by  orgname, bm_bmclass.code");
        return executeQueryVOs(sqlBuffer.toString(), BmClassEndVO.class);
    }

    /**
     * ֻȡĿ
     *
     * @param context
     * @param selectClassEndVOs
     * @return
     * @throws BusinessException
     * @author suihang on 2012-3-16
     */

    protected BmClassEndVO[] getClassItem2Class(LoginContext context,
                                                BmClassEndVO[] selectClassEndVOs) throws BusinessException {
        HashMap<String, ArrayList<BmClassItemVO>> needZeromap = new HashMap<String, ArrayList<BmClassItemVO>>();
        HashMap<String, ArrayList<BmClassItemVO>> unZeromap = new HashMap<String, ArrayList<BmClassItemVO>>();

        InSQLCreator isc = new InSQLCreator();
        String[] fieldname = BmClassConstant.CLASS_COLUMN;
        String temtablename = isc.insertValues(BmClassConstant.BM_TEMP_CLASS,
                fieldname, fieldname, selectClassEndVOs);

        StringBuffer sqlBuffer = new StringBuffer();
        sqlBuffer.append("select bm_item.itemkey, bm_classitem.pk_bm_class,  "
                + SQLHelper.getMultiLangNameColumn("bm_classitem.name") + "  as name"); // 1
        sqlBuffer.append("  from bm_classitem, bm_item , " + temtablename
                + " as temptable");
        sqlBuffer
                .append(" where bm_classitem.pk_bm_item = bm_item.pk_bm_item ");
        sqlBuffer.append(" and bm_classitem.pk_bm_class = temptable.pk_bm_class");
        sqlBuffer.append(" and bm_classitem.cyear = temptable.cyear");
        sqlBuffer.append(" and bm_classitem.cperiod = temptable.cperiod");
        //		sqlBuffer.append("   and bm_item.defaultflag = 'N'");
        //zhoumxc  2014.08.14    ޸ģԴ͵Ŀƣʾ ĩʱѡĿʾĿȷ
//		sqlBuffer.append("  and ( bm_item.defaultflag = 'N' or (bm_item.defaultflag = 'Y' and bm_classitem.ifromflag = "+BmFromEnumVO.USER_INPUT.value()+" ) )" );

        // 
        StringBuffer needZero = new StringBuffer();
        needZero.append(sqlBuffer);
        //shenliangc 20140605 ΪĿĩĬ޸
        //޸ĵĽѡĿĬʾڡ֡ɽĿҳǩѡˡ㡱Ŀ
        needZero.append("  and   (  bm_classitem.clearflag = 'Y')");
//		needZero.append("  and   (  bm_classitem.clearflag = 'Y' or bm_classitem.itemkey in('f_11','f_12','f_13'))");//
        needZero.append(" order by bm_classitem.pk_bm_class");
        BmClassItemVO[] needZeroItemVos = executeQueryVOs(needZero.toString(), BmClassItemVO.class);

        if (needZeroItemVos != null && needZeroItemVos.length > 0) {
            String pk_bm_class = null;
            for (BmClassItemVO vo : needZeroItemVos) {
                vo.setAttributeValue("name" + MultiLangUtil.getCurrentLangSeqSuffix(), vo.getAttributeValue("name").toString());
                pk_bm_class = vo.getPk_bm_class();
                ArrayList<BmClassItemVO> list = needZeromap.get(pk_bm_class);
                if (list == null) {
                    list = new ArrayList<BmClassItemVO>();
                }
                list.add(vo);
                needZeromap.put(pk_bm_class, list);
            }
        }


        // 
        StringBuffer otherBuffer = new StringBuffer();
        otherBuffer.append(sqlBuffer);
        //shenliangc 20140605 ΪĿĩĬ޸
        //޸ĵĽѡĿĬʾڡ֡ɽĿҳǩѡˡ㡱Ŀ
        otherBuffer.append("   and bm_classitem.clearflag = 'N' ");
//		otherBuffer.append("   and bm_classitem.clearflag = 'N'  and bm_classitem.itemkey not in('f_11','f_12','f_13') ");
        otherBuffer.append(" order by bm_classitem.pk_bm_class");
        BmClassItemVO[] unZeroItemVos = executeQueryVOs(otherBuffer.toString(), BmClassItemVO.class);
        if (unZeroItemVos != null && unZeroItemVos.length > 0) {
            String pk_bm_class = null;
            for (BmClassItemVO vo : unZeroItemVos) {
                vo.setAttributeValue("name" + MultiLangUtil.getCurrentLangSeqSuffix(), vo.getAttributeValue("name").toString());
                pk_bm_class = vo.getPk_bm_class();
                ArrayList<BmClassItemVO> list = unZeromap.get(pk_bm_class);
                if (list == null) {
                    list = new ArrayList<BmClassItemVO>();
                }
                list.add(vo);
                unZeromap.put(pk_bm_class, list);
            }
        }


        for (BmClassEndVO bmClassEndVO : selectClassEndVOs) {
            if (null != needZeromap.get(bmClassEndVO.getPk_bm_class())) {
                bmClassEndVO.setZeroClassItemVOs(needZeromap.get(bmClassEndVO.getPk_bm_class()).toArray(new BmClassItemVO[0]));
            }

            if (null != unZeromap.get(bmClassEndVO.getPk_bm_class())) {
                bmClassEndVO.setUnZeroClassItemVOs(unZeromap.get(bmClassEndVO.getPk_bm_class()).toArray(new BmClassItemVO[0]));
            }
        }
        return selectClassEndVOs;
    }

    /**
     * ˡ
     *
     * @param classVOs
     * @throws BusinessException
     * @author suihang on 2012-03-16
     */
    protected void multMonthEnd(LoginContext context, BmClassEndVO[] classVOs, String actionType)
            throws BusinessException {

        //¼Ϣ
        setContext((BmLoginContext) context);

        for (BmClassEndVO bmClassEndVO : classVOs) {

            // нʷ

            new SimpleDocLocker().lock(UPDATE, bmClassEndVO);

            // 汾У飨ʱУ飩
            BDVersionValidationUtil.validateSuperVO(bmClassEndVO);

            if (actionType.equals(JZ)) {
                if (!isMonthEndEnabled(bmClassEndVO)) {
                    throw new BusinessException(bmClassEndVO.getMultilangName()
                            + ResHelper.getString("60150monthend", "060150monthend0020")
                            /*@res "ݷ仯, ʣ"*/);
                }

                // һڼݡ
                BmClassEndVO bmClassEndNextVO = (BmClassEndVO) bmClassEndVO
                        .clone();
                BmPeriodstateVO nextPeriodVO = getNextPeriodVO(bmClassEndVO);
                bmClassEndNextVO.setCyear(nextPeriodVO.getYear());
                bmClassEndNextVO.setCperiod(nextPeriodVO.getPeriod());

                clearBuisinessData(bmClassEndNextVO, false);

                //¼־
                BmBusilogUtil.writeMonthEndBusiLog(bmClassEndVO);
                monthEnd(bmClassEndVO);
            } else if (actionType.equals(FJ)) {
                if (!isMonthEndReverseEnabled(bmClassEndVO)) {
                    throw new BusinessException(bmClassEndVO.getMultilangName()
                            + ResHelper.getString("60150monthend", "060150monthend0021")
                            /*@res "ݷ仯, ʣ"*/);
                }
                //¼־
                BmBusilogUtil.writeMonthEndReverseBusiLog(bmClassEndVO);

                monthEndReverse(bmClassEndVO);
            }
        }
        BmCacheUtils.synCache(BmClassVO.TABLE_NAME);
        BmCacheUtils.synCache(BmClassItemVO.TABLE_NAME);
    }

    /**
     * ˴
     *
     * @param waClassEndVO
     * @throws BusinessException
     */
    private void monthEndReverse(BmClassEndVO bmClassEndVO)
            throws BusinessException {
        clearBuisinessData(bmClassEndVO, true);

    }

    private void clearBuisinessData(BmClassEndVO bmClassEndVO,
                                    boolean processPreperiod) throws BusinessException {
        monthEndReverseSingle(bmClassEndVO, processPreperiod);
    }

    /**
     * @param waLoginVO
     * @return
     * @throws BusinessException
     * @author suihang on 2012-12-16
     */
    private void monthEndReverseSingle(BmClassEndVO bmClassEndVO,
                                       boolean processPreperiod) throws BusinessException {

        //һ
        if (StringUtils.isNotBlank(bmClassEndVO.getPk_bm_class())) {
            BDPKLockUtil.lockString(bmClassEndVO.getPk_bm_class());
        }


        deleteKeyData(bmClassEndVO);

        resetPeriodState(bmClassEndVO);

        // ɾڼ籣ɽʾãͨú͸ˣ
        deleteBmdataDsp(bmClassEndVO);

        if (processPreperiod) {
            updatePrePeriodstate(bmClassEndVO);
            updateCreateCorp(bmClassEndVO);
        }

        //ŷķ˲ͬ
        synchronizeGroupClass4Reverse(bmClassEndVO);
    }


    /**
     * @param bmLoginVO
     * @author zhangg on 2009-12-16
     */
    private void updateCreateCorp(BmClassEndVO bmLoginVO) throws BusinessException {

        //Ƿװ
        boolean isEnable = PubEnv.isModuleStarted(PubEnv.getPk_group(), PubEnv.MODULE_GL);
        //ûаװֱӷ
        if (!isEnable) {
            return;
        }
        // ǷСУ顱
        UFBoolean typevalue = SysinitAccessor.getInstance().getParaBoolean(bmLoginVO.getPk_org(), BmParaConstant.CHECK_BEFORE_CLOSEACCBOOK);

        if (typevalue == null || !typevalue.booleanValue()) {
            return;
        }
        BmPeriodstateVO prePeriodStateVO = getPrePeriodVO(bmLoginVO);
        //ݻڼ䡢֯鿴Ӧĸ֯Ƿ˲Ѿ
        BmFiorgVO[] bmFiorgVO = NCLocator
                .getInstance()
                .lookup(IBmdataQueryService.class)
                .queryBmFiorg(bmLoginVO.getPk_bm_class(),
                        prePeriodStateVO.getYear(),
                        prePeriodStateVO.getPeriod());

        //˲Ѿˣˡ
        if (ArrayUtils.isEmpty(bmFiorgVO)) {
            return;
        }

        //õڼ

        String accyear = prePeriodStateVO.getCaccyear();
        String accperiod = prePeriodStateVO.getCaccperiod();

        String[] pks = new String[bmFiorgVO.length];
        for (int i = 0; i < bmFiorgVO.length; i++) {
            pks[i] = bmFiorgVO[i].getAccountBookId();

        }

        String[] closedAccountBookIds = checkAccountbookClosed(pks, accyear
                + '-' + accperiod);

        if (!ArrayUtils.isEmpty(closedAccountBookIds)) {
            throw new BusinessException(
                    ResHelper.getString("60150monthend",
                            "060150monthend0022")
                    /*@res "Ѿˣܽз"*/);
        }
        try {
            //guoqt
            //һڼĻڼѯһڼĻڼ
            String[] pk_accperiodmonth = getPeriod(accyear, accperiod);
            //ѯһڼĽ
            CloseAccBookVO[] hasPKCabvos = this.queryVOsByCloseOrgPks(pks, pk_accperiodmonth[0], "6015");
            //򷴽ˣû֤ʷڼ䣬
            if (hasPKCabvos != null) {
                for (int i = 0; i < pks.length; i++) {
                    // ˺ҪϢuapĹģ
                    NCLocator.getInstance().lookup(ICloseAccPubServicer.class).reAccount("6015",
                            bmLoginVO.getPk_org(), pks[i], pk_accperiodmonth[0]);
                }
            }
        } catch (Exception e) {
            Logger.error(e.getMessage(), e);
        }
    }

    /**
     * ѯһڼĽ
     *
     * @throws BusinessException
     */
    private CloseAccBookVO[] queryVOsByCloseOrgPks(String[] closeorgpks, final String pk_accperiodmonth
            , final String module) throws BusinessException {
        InSqlBatchCaller caller = new InSqlBatchCaller(closeorgpks);
        List<CloseAccBookVO> voList = new ArrayList<CloseAccBookVO>();
        try {
            voList = (List<CloseAccBookVO>) caller.execute(new IInSqlBatchCallBack() {
                List<CloseAccBookVO> result = new ArrayList<CloseAccBookVO>();

                @Override
                public Object doWithInSql(String inSql) throws BusinessException,
                        SQLException {
                    String condition = " closeorgpks in " + inSql + " and pk_accperiodmonth = '" + pk_accperiodmonth + "' and moduleid = '" + module + "'";
                    Collection<CloseAccBookVO> c = new BaseDAO().retrieveByClause(CloseAccBookVO.class, condition);
                    if (c != null && c.size() > 0) {
                        result.addAll(c);
                    }
                    {
                        return result;
                    }

                }
            });
        } catch (SQLException e) {
            Logger.debug(e.getMessage());
        }
        return voList.toArray(new CloseAccBookVO[voList.size()]);
    }

    /**
     * ˲֯˲Ƿйˣκһ˲ˣ򷵻true ûй˲ŷfalse
     *
     * @param fiorgPKs  ֯pks
     * @param accyear   
     * @param accperiod ڼ
     * @return
     * @throws BusinessException
     */
    private String[] checkAccountbookClosed(String[] accountBookIds,
                                            String period) throws BusinessException {
        return NCLocator
                .getInstance()
                .lookup(ICloseAccQryPubServicer.class)
                .isCloseByAccountBookIdAndModuleId(accountBookIds,
                        ICloseAccModuleID.ALLACCMODULEID, period);

    }

    /**
     * յǰڼݣֹظˣ ظͣãһڼֶݣ
     * ĿΪһڼظʼ״̬ʼ״̬£Ϊգڼ״̬Ϊû
     *
     * @param waParentLoginVO
     * @throws BusinessException
     * @throws BusinessException
     */


    private void deleteKeyData(BmClassEndVO bmLoginVO) throws BusinessException {
        // ɾ wa_dataswa_datawa_classitem
        IPersistenceUpdate persistence = NCLocator.getInstance().lookup(
                IPersistenceUpdate.class);
        HashMap<String, SQLParameter> updateHashMap = new LinkedHashMap<String, SQLParameter>();
        String sqlbm_data;
        if (getBaseDao().getDBType() == DBConsts.HIGHGO) {
            sqlbm_data = "delete from bm_data where bm_data.pk_bm_class = ? and cyear= ? and cperiod = ? and accounttype !='" + IHRBmfileConstant.ACCOUNTTYPE_TI + "'";
        } else {
            sqlbm_data = "delete from bm_data where bm_data.pk_bm_class = ? and cyear= ? and cperiod = ? and accounttype !=" + IHRBmfileConstant.ACCOUNTTYPE_TI;
        }
        updateHashMap.put(sqlbm_data, getCommonParameter(bmLoginVO));

        String sqlbm_classItem = "delete from bm_classitem where  pk_bm_class= ? and cyear=? and cperiod = ? ";
        updateHashMap.put(sqlbm_classItem, getCommonParameter(bmLoginVO));

        String sqlbm_dataioIntface = "delete from hr_dataio_intface where  classid= ? and cyear=? and cperiod = ? ";
        updateHashMap.put(sqlbm_dataioIntface, getCommonParameter(bmLoginVO));


        String sqlbm_dataround = "delete from bm_dataround where  pk_bm_class= ? and cyear=? and cperiod = ? ";
        updateHashMap.put(sqlbm_dataround, getCommonParameter(bmLoginVO));

        persistence.executeSQLs(updateHashMap.keySet().toArray(new String[0]),
                updateHashMap.values().toArray(new SQLParameter[0]));

    }

    /**
     * ޸ڼ״̬ ڼΪδ㣬δ
     *
     * @param waParentLoginVO
     * @throws BusinessException
     * @throws BusinessException
     */

    private void resetPeriodState(BmClassEndVO bmLoginVO)
            throws BusinessException {
        IPersistenceUpdate persistence = NCLocator.getInstance().lookup(
                IPersistenceUpdate.class);

        // ޸ڼ״̬ ڼΪδ
        BmPeriodstateVO periodStateVO = getPeriodVO(bmLoginVO);
        StringBuffer sqlBuffer = new StringBuffer();
        sqlBuffer.append("update bm_periodstate "); //
        sqlBuffer.append("   set recacuflag = 'N', "); //
        sqlBuffer.append("       accountmark  = 'N', "); //
        sqlBuffer.append("       checkflag    = 'N', "); //
        sqlBuffer.append("       enableflag  = 'N' "); //
        sqlBuffer.append(" where pk_periodstate = ? "); //

        SQLParameter parameter = new SQLParameter();
        parameter.addParam(periodStateVO.getPk_periodstate());

        persistence.executeSQLs(new String[]{sqlBuffer.toString()},
                new SQLParameter[]{parameter});


    }

    /**
     * ޸һڼ״̬Ϊδ
     *
     * @param waParentLoginVO
     * @throws BusinessException
     * @throws BusinessException
     */
    private void updatePrePeriodstate(BmClassEndVO waLoginVO)
            throws BusinessException {
        // ޸ڼһڼļ״̬
        IPersistenceUpdate persistence = NCLocator.getInstance().lookup(
                IPersistenceUpdate.class);

        BmPeriodstateVO prePeriodStateVO = getPrePeriodVO(waLoginVO);

        HashMap<String, SQLParameter> updateHashMap = new LinkedHashMap<String, SQLParameter>();
        if (prePeriodStateVO != null) {

            StringBuffer sqlBuffer = new StringBuffer();
            sqlBuffer.append("update bm_periodstate  "); //
            sqlBuffer.append("   set  accountmark  = 'N' "); // 5
            sqlBuffer
                    .append(" where pk_periodstate in(select bm_periodstate.pk_periodstate ");
            sqlBuffer.append("						from bm_bmclass,bm_periodstate,bm_period ");
            sqlBuffer.append("						where bm_bmclass.pk_bm_class = ?");
            sqlBuffer
                    .append("							and bm_periodstate.pk_bm_class = bm_bmclass.pk_bm_class ");
            sqlBuffer
                    .append("							and bm_periodstate.pk_bm_period = bm_period.pk_bm_period ");
            sqlBuffer.append("							and bm_period.year = ? ");
            sqlBuffer.append("							and bm_period.period = ? ) ");
            SQLParameter parameter = new SQLParameter();
            parameter.addParam(prePeriodStateVO.getPk_bm_class());
            parameter.addParam(prePeriodStateVO.getYear());
            parameter.addParam(prePeriodStateVO.getPeriod());
            updateHashMap.put(sqlBuffer.toString(), parameter);

            // ޸нҵȡҵڼ, Ƿʹ־
            sqlBuffer = new StringBuffer();
            sqlBuffer
                    .append("update bm_bmclass set bm_bmclass.cyear = ?, bm_bmclass.cperiod = ? where bm_bmclass.pk_bm_class = ? "); // 1
            parameter = new SQLParameter();
            parameter.addParam(prePeriodStateVO.getYear());
            parameter.addParam(prePeriodStateVO.getPeriod());
            parameter.addParam(prePeriodStateVO.getPk_bm_class());
            updateHashMap.put(sqlBuffer.toString(), parameter);
        }
        persistence.executeSQLs(updateHashMap.keySet().toArray(new String[0]),
                updateHashMap.values().toArray(new SQLParameter[0]));

    }

    /**
     * 
     *
     * @param waLoginVO
     * @return
     * @throws BusinessException
     * @author suihang on 2012-12-16
     */
    private void monthEnd(BmClassEndVO bmLoginVO)
            throws BusinessException {

        monthEndSingle(bmLoginVO);
    }

    private void monthEndSingle(BmClassEndVO bmLoginVO)
            throws BusinessException {

        //һ
        if (StringUtils.isNotBlank(bmLoginVO.getPk_bm_class())) {
            BDPKLockUtil.lockString(bmLoginVO.getPk_bm_class());
        }

        // һڼwa_data
        createNextPeriodDatas(bmLoginVO, bmLoginVO);

        // һڼwa_classitem
        createNextPeriodItems(bmLoginVO, bmLoginVO);

        //һڼλʽ
        createNextPeriodRountType(bmLoginVO);

        // һڼݽӿ
        createNextDataIO(bmLoginVO);

        // нڼ
        dealWithPeriodState(bmLoginVO);

        // ԱϢ仯
        updatePsnInfo(bmLoginVO);

        // ǼŷķŷҲĩ
        synchronizeGroupClass(bmLoginVO);

        // ĩ
        // updateCreateCorp(waLoginVO);

        // һڼ籣ɽʾãͨú͸ˣ
        createNextBmdataDsp(bmLoginVO);
        //guoqt УǷ
        boolean isEnable = PubEnv.isModuleStarted(PubEnv.getPk_group(), PubEnv.MODULE_GL);
        // 20151102 xiejie3   ҵ  begin
        // ǷСУ顱
        UFBoolean typevalue = SysinitAccessor.getInstance().getParaBoolean(bmLoginVO.getPk_org(), BmParaConstant.CHECK_BEFORE_CLOSEACCBOOK);
        //end
        //ûãֱӷ
        if (isEnable && typevalue != null && typevalue.booleanValue()) {
            try {
                //guoqt
                //õǰڼ
                BmPeriodstateVO thisperiodStateVO = getPeriodVO(bmLoginVO);
                //ݵǰڼһڼ
                String[] pk_accperiodmonth = getPeriod(thisperiodStateVO.getCaccyear(), thisperiodStateVO.getCaccperiod());
                //֡ڼѯ˵Ĳ֯Ӧ˲
                BmFiorgVO[] bmFiorgVO = NCLocator.getInstance().lookup(IBmdataQueryService.class).queryBmFiorg(bmLoginVO.getPk_bm_class(),
                        thisperiodStateVO.getYear(), thisperiodStateVO.getPeriod());
                if (!ArrayUtils.isEmpty(bmFiorgVO)) {
                    String[] pks = new String[bmFiorgVO.length];
                    for (int i = 0; i < bmFiorgVO.length; i++) {
                        pks[i] = bmFiorgVO[i].getAccountBookId();
                    }
                    for (int i = 0; i < pks.length; i++) {
                        // ˺ҪϢuapĹģ
                        NCLocator.getInstance().lookup(ICloseAccPubServicer.class).account("6015",
                                bmLoginVO.getPk_org(), pks[i], pk_accperiodmonth[0]);
                    }
                }
            } catch (Exception e) {
                Logger.error(e.getMessage(), e);
                throw new BusinessException(ResHelper.getString("60150monthend", "060150monthend0031")
                        /*@res "ģ쳣Ժԣ"*/);
//		20151102  xiejie3  Ҫ쳣׵ǰ̨ begin			
                //throw e;
            }
        }
    }

    /**
     * ݵǰڼһڼ
     *
     * @throws DAOException
     */
    public String[] getPeriod(String accyear, String accperiod) throws DAOException {
        String sql = " select apm.pk_accperiodmonth from bd_accperiodmonth apm,"
                + "bd_accperiod ap,bd_accperiodscheme scheme where apm.pk_accperiod=ap.pk_accperiod  "
                + " and scheme.pk_accperiodscheme=ap.pk_accperiodscheme and apm.yearmth = ? and scheme.code='0001' ";
        String[] re = new String[1];
        SQLParameter parameter = new SQLParameter();
        parameter.addParam(accyear + "-" + accperiod);
        re = (String[]) this.getBaseDao().executeQuery(sql, parameter,
                new ColumnProcessor() {
                    @Override
                    public Object handleResultSet(ResultSet rs)
                            throws SQLException {
                        String[] re = new String[1];
                        if (rs.next()) {
                            re[0] = rs.getString(1);
                        }
                        return re;
                    }
                });

        return re;
    }

    /**
     * @param waClassEndVO
     * @throws BusinessException
     */
    private void createNextPeriodRountType(BmClassEndVO waClassEndVO) throws BusinessException {

        StringBuffer sqlBuffer = new StringBuffer();
        sqlBuffer.append("select bm_dataround.round_type, "); // 1
        sqlBuffer.append("       bm_dataround.notes, "); // 2
        sqlBuffer.append("       bm_dataround.to_next, "); // 3
        sqlBuffer.append("       bm_dataround.pk_org, "); // 4
        sqlBuffer.append("       bm_dataround.pk_group, "); // 4
        sqlBuffer.append("       next_classitem.cyear, "); // 4
        sqlBuffer.append("       next_classitem.cperiod, "); // 4
        sqlBuffer.append("       next_classitem.pk_classitem, "); // 6
        sqlBuffer.append("       next_classitem.pk_bm_class, "); // 6
        sqlBuffer.append("       bm_detailrule.pk_loctrule "); // 6
        sqlBuffer.append("  from bm_dataround, ");
        sqlBuffer.append("       bm_detailrule, ");
        sqlBuffer.append("       bm_classitem, ");
        sqlBuffer.append("       bm_classitem next_classitem ");
        sqlBuffer.append(" where next_classitem.pk_bm_item = bm_classitem.pk_bm_item ");
        sqlBuffer.append("   and next_classitem.pk_bm_class = bm_classitem.pk_bm_class ");
        sqlBuffer.append("   and bm_classitem.pk_classitem = bm_dataround.pk_classitem ");
        sqlBuffer.append("   and bm_dataround.to_next = 'Y' ");
        sqlBuffer.append("   and bm_dataround.pk_bm_class = ? ");
        sqlBuffer.append("   and bm_dataround.cyear = ? ");
        sqlBuffer.append("   and bm_dataround.cperiod = ?  and bm_dataround.dr=0 and bm_dataround.pk_loctrule=bm_detailrule.pk_loctrule ");
        sqlBuffer.append("   and bm_classitem.pk_bm_class = ? ");
        sqlBuffer.append("   and bm_classitem.cyear = ? ");
        sqlBuffer.append("   and bm_classitem.cperiod = ? ");
        sqlBuffer.append("   AND (bm_detailrule.pk_bm_class = ? " +
                "or bm_detailrule.pk_bm_class in (select pk_sourcecls from bm_assigncls where classid=?)) ");
        sqlBuffer.append("   and bm_detailrule.endperiod>= ? ");
        sqlBuffer.append("   and bm_detailrule.startperiod<= ? ");
        sqlBuffer.append("   and next_classitem.pk_bm_class = ? ");
        sqlBuffer.append("   and next_classitem.cyear = ? ");
        sqlBuffer.append("   and next_classitem.cperiod = ? ");

        BmPeriodstateVO periodStateVO = getNextPeriodVO(waClassEndVO);

        SQLParameter parameter = new SQLParameter();
        parameter.addParam(waClassEndVO.getPk_bm_class());
        parameter.addParam(waClassEndVO.getCyear());
        parameter.addParam(waClassEndVO.getCperiod());
        parameter.addParam(waClassEndVO.getPk_bm_class());
        parameter.addParam(waClassEndVO.getCyear());
        parameter.addParam(waClassEndVO.getCperiod());
        parameter.addParam(waClassEndVO.getPk_bm_class());
        parameter.addParam(waClassEndVO.getPk_bm_class());
        parameter.addParam(periodStateVO.getYear() + periodStateVO.getPeriod());
        parameter.addParam(periodStateVO.getYear() + periodStateVO.getPeriod());
        parameter.addParam(waClassEndVO.getPk_bm_class());
        parameter.addParam(periodStateVO.getYear());
        parameter.addParam(periodStateVO.getPeriod());

        BmDataroundVO[] dataSVOs = executeQueryVOs(sqlBuffer.toString(), parameter, BmDataroundVO.class);

        if (dataSVOs != null) {
            getBaseDao().insertVOArray(dataSVOs);
        }
    }


    private void createNextPeriodDatas(BmClassEndVO sourceLoginVO,
                                       BmClassEndVO destLoginVO) throws BusinessException {
        // wa_data, dataz, dataf, tax
        // Wa_dataõеıнVO
        BmPeriodstateVO nextPeriodStateVO = getNextPeriodVO(destLoginVO);
        SQLParameter parameter = getCommonParameter(sourceLoginVO);

        StringBuffer sql1 = new StringBuffer();
        sql1.append("select * from bm_data a where pk_bm_class=? and cyear=? and cperiod =? and accountstate in ('0','1')");

        BmDataVO[] dataVOs1 = executeQueryVOs(
                sql1.toString(),
                parameter, BmDataVO.class);


        StringBuffer sql = new StringBuffer();
        sql.append("select * from bm_data a where pk_bm_class=? and cyear=? and cperiod =? and accountstate in ('0','1')");
        sql.append(" and not exists(select 1 from bm_data b where b.pk_bm_class in (select classid from bm_assigncls where pk_sourcecls = ");
        sql.append(" (	select pk_sourcecls from bm_assigncls where classid = a.pk_bm_class)) and b.pk_psndoc = a.pk_psndoc and cyear=? and cperiod =?)");
        parameter.addParam(nextPeriodStateVO.getYear());
        parameter.addParam(nextPeriodStateVO.getPeriod());

        //shenliangc 20140625Ϊۻ˾ǷJVеɽĿڽ˺Ī޸ġ
        BmDataVO[] dataVOs = executeQueryVOsForCreateNextPeriodDatas(
                sql.toString(),
                parameter, BmDataVO.class);
//		20151021 xiejie3  ϲNCdp205496395
        // modify by zouj 2015/09/10 ֿ֧ս
//		if (dataVOs1 == null) {
//			throw new BusinessException(ResHelper.getString("60150monthend","060150monthend0023",sourceLoginVO.getMultilangName())
//					/*@res "Ϊ:{0},ûԱ, ܹս."*/);
//		}
//		end

        if (dataVOs == null) {
            return;
        }

        //תĿ
        BmClassItemVO[] transferItemVOs = getTransferItems(sourceLoginVO);

        //ҪϵͳĿ
        BmClassItemVO[] clearSysitemVOs = queryClearSysitemVOs(sourceLoginVO);

        // Ԥγ Ϊ
        String strOids[] = OidGenerator.getInstance().nextOid(
                OidGenerator.GROUP_PK_CORP, dataVOs.length);

        for (int i = 0; i < dataVOs.length; i++) {
            BmDataVO dataVO = dataVOs[i];
            dataVO.setPk_bm_data(strOids[i]);
            // ת .Ŀ귽Ǹת

            transferValue(dataVO, transferItemVOs);

            // Ŀ,ηннʷĿҪա
            BmClassItemVO[] zeroItem = sourceLoginVO.getZeroClassItemVOs();

            // ûԶĿ
            if (zeroItem != null) {
                for (BmClassItemVO bmClassItemVO : zeroItem) {
                    Object value = DataVOUtils.isDigitsAttribute(bmClassItemVO
                            .getItemkey()) ? UFDouble.ZERO_DBL : null;
                    dataVO.setAttributeValue(bmClassItemVO.getItemkey(), value);
                }
            }
            // ϵͳĿ
            dataVO = clearSysitemValue(dataVO, sourceLoginVO, clearSysitemVOs);

            // ڼ
            dataVO.setCyear(nextPeriodStateVO.getYear());
            dataVO.setCperiod(nextPeriodStateVO.getPeriod());

            // нʷpk
            dataVO.setPk_bm_class(destLoginVO.getPk_bm_class());
            // ״̬
            dataVO.setCheckflag(UFBoolean.FALSE);
            dataVO.setCaculateflag(UFBoolean.FALSE);
        }

        //Ψһ
        IBmfileQueryService service = NCLocator.getInstance().lookup(IBmfileQueryService.class);
        // service.checkRepeatBmClass(dataVOs, false);

        // γ¸µ
        getBaseDao().insertVOArrayWithPK(dataVOs);

    }

    /**
     * shenliangc 20140625Ϊۻ˾ǷJVеɽĿڽ˺Īӡ
     * <p>
     * BaseDAOManagerexecuteQueryVOs()еBaseDAOexecuteQuery()ʱnew BeanListProcessor(voClass)
     * ôProcessorUtilstoBeanListInner()װΪVOб
     * ˽BmDataVO extends SuperVO implements IAppendableVOĴһǱ⣺
     * ֵΪnullֶβᱻVOappValueHashMapУappValueHashMapоͻȱʧӦkey-valueԡ
     * ҵBaseDAOеinsertVOArrayWithPK(dataVOs)dataVOs[0]ƴװsqlڲݣ
     * ʱdataVOs[0]ȱʧ˲ֶΣЩֶξͲsqlУЩֵֶΪnull
     * <p>
     * רڲѯڼݵdataVOsֻΪʹúʵĽ
     * BmDataVO extends SuperVO implements IAppendableVO
     * ˷صdataVOsappValueHashMapbm_dataУеֵ޹ء
     * Ӷֶ֤εֵ԰Ҫһڼ䡣
     *
     * @param sql
     * @param parameter
     * @param voClass
     * @return <T> T[]
     * @throws BusinessException
     */
    public <T> T[] executeQueryVOsForCreateNextPeriodDatas(String sql, SQLParameter parameter, Class<T> voClass) throws BusinessException {
        T[] array = (T[]) getBaseDao().executeQuery(sql, parameter, new AppendBeanArrayProcessor((Class<? extends IAppendableVO>) voClass));
        if (ArrayUtils.isEmpty(array)) {
            return null;
        }
        return array;
    }

    private void createNextPeriodItems(BmClassVO sourceLoginVO,
                                       BmClassVO destLoginVO) throws BusinessException {

        // һڼнĿ
        BmClassItemVO[] nextPeriodItemVOs = null;
        // Ǳ鿴ԭһڼǷ°汾Ŀ
        // ǷǷ
        BmPeriodstateVO nextPeriodStateVO = getNextPeriodVO(destLoginVO);

        AssignclsVO assignclsVO = new AssignclsVO();
        assignclsVO.setClassid(sourceLoginVO.getPk_bm_class());
        assignclsVO = retrieveSingle(assignclsVO);
        if (assignclsVO != null) {// Ƿ
            String pk_wa_class = assignclsVO.getPk_sourcecls();
            String cyear = nextPeriodStateVO.getYear();
            String cperiod = nextPeriodStateVO.getPeriod();

            BmClassVO groupclassVO = new BmLoginVO();
            groupclassVO.setPk_bm_class(pk_wa_class);
            groupclassVO.setCyear(cyear);
            groupclassVO.setCperiod(cperiod);
            // õ¶ӦڼнĿ
            BmClassItemVO[] groupClassItemVOs = getGroupClassItems(groupclassVO);
            // õ˾нĿ
            String condition = " pk_bm_class = '"
                    + sourceLoginVO.getPk_bm_class() + "'and cyear = '"
                    + sourceLoginVO.getCyear() + "' and cperiod = '"
                    + sourceLoginVO.getCperiod() + "'";
            BmClassItemVO[] corpClassItemVOs = retrieveByClause(
                    BmClassItemVO.class, condition);
            // һڼнĿ
            nextPeriodItemVOs = getNextPeriodItems(groupClassItemVOs,
                    corpClassItemVOs);
        } else {
            // õ˾нĿ
            String condition = " pk_bm_class = '"
                    + sourceLoginVO.getPk_bm_class() + "'and cyear = '"
                    + sourceLoginVO.getCyear() + "' and cperiod = '"
                    + sourceLoginVO.getCperiod() + "'";
            nextPeriodItemVOs = retrieveByClause(BmClassItemVO.class, condition);
        }
        // һڵĿڼ
        if (!ArrayUtils.isEmpty(nextPeriodItemVOs)) {
            for (BmClassItemVO bmClassItemVO : nextPeriodItemVOs) {
                bmClassItemVO.setPk_bm_class(destLoginVO.getPk_bm_class());
                bmClassItemVO.setCyear(nextPeriodStateVO.getYear());
                bmClassItemVO.setCperiod(nextPeriodStateVO.getPeriod());
                bmClassItemVO.setPk_org(destLoginVO.getPk_org());
            }
            getBaseDao().insertVOArray(nextPeriodItemVOs);

            String condition = " pk_bm_class = '"
                    + sourceLoginVO.getPk_bm_class() + "'and cyear = '"
                    + nextPeriodStateVO.getYear() + "' and cperiod = '"
                    + nextPeriodStateVO.getPeriod() + "'";
            nextPeriodItemVOs = retrieveByClause(BmClassItemVO.class, condition);
            Map<String, BmClassItemVO> classItemMap = new HashMap<>();
            for (BmClassItemVO bmClassItemVO : nextPeriodItemVOs) {
                classItemMap.put(bmClassItemVO.getItemkey(), bmClassItemVO);
            }
            for (BmClassItemVO bmClassItemVO : nextPeriodItemVOs) {
                if (StringUtils.isNotBlank(bmClassItemVO.getDestitemcol())) {
                    bmClassItemVO.setDestitempk(classItemMap.get(bmClassItemVO.getDestitemcol()).getPk_classitem());
                }
            }
            getBaseDao().updateVOArray(nextPeriodItemVOs);
        }
        if (assignclsVO != null) {// Ƿ
            BmClassVO vo = (BmClassVO) destLoginVO.clone();
            vo.setCyear(nextPeriodStateVO.getYear());
            vo.setCperiod(nextPeriodStateVO.getPeriod());
            NCLocator.getInstance().lookup(IBmClassManageService.class).updateItemCaculateSeu(vo);
        }
    }

    /**
     * һڼݽӿ
     *
     * @param waLoginVO
     * @throws BusinessException
     */
    private void createNextDataIO(BmClassEndVO waClassEndVO) throws BusinessException {
        BmPeriodstateVO nextPeriodStateVO = getNextPeriodVO(waClassEndVO);
        StringBuffer sqlBuffer = new StringBuffer();
        sqlBuffer.append(" select * from hr_dataio_intface where ");
        sqlBuffer.append(" classid = ? and ");
        sqlBuffer.append("  cyear = ? and ");
        sqlBuffer.append("  cperiod = ? ");
        SQLParameter parameter = getCommonParameter(waClassEndVO);
        HrIntfaceVO[] intfaceVos = executeQueryVOs(sqlBuffer.toString(), parameter, HrIntfaceVO.class);
        if (!ArrayUtils.isEmpty(intfaceVos)) {
            InSQLCreator inC = new InSQLCreator();
            try {
                sqlBuffer = new StringBuffer();
                sqlBuffer.append(" select * from hr_dataintface_b where ifid in (").append(inC.getInSQL(intfaceVos, HrIntfaceVO.PK_DATAIO_INTFACE)).append(")");
                FormatItemVO[] formatItems = executeQueryVOs(sqlBuffer.toString(), FormatItemVO.class);
                HashMap<Object, FormatItemVO[]> formatItemsMap = (HashMap<Object, FormatItemVO[]>) CommonUtils.group2ArrayByField(FormatItemVO.IFID, formatItems);
                sqlBuffer = new StringBuffer();
                sqlBuffer.append(" select * from " + DataIOConstant.HR_IFSETTOP + " where ifid in (").append(inC.getInSQL(intfaceVos, HrIntfaceVO.PK_DATAIO_INTFACE)).append(")");
                IfsettopVO[] ifsetTops = executeQueryVOs(sqlBuffer.toString(), IfsettopVO.class);
                HashMap<Object, IfsettopVO[]> ifsetTopsMap = (HashMap<Object, IfsettopVO[]>) CommonUtils.group2ArrayByField(FormatItemVO.IFID, ifsetTops);

                List<AggHrIntfaceVO> aggVOList = new ArrayList<AggHrIntfaceVO>();
                for (int i = 0; i < intfaceVos.length; i++) {
                    AggHrIntfaceVO aggVO = new AggHrIntfaceVO();
                    intfaceVos[i].setCyear(nextPeriodStateVO.getYear());
                    intfaceVos[i].setCperiod(nextPeriodStateVO.getPeriod());
                    FormatItemVO[] childrenItemVO = formatItemsMap.get(intfaceVos[i].getPk_dataio_intface());
                    IfsettopVO[] childrenIstopVO = null;
                    if (ifsetTopsMap != null) {
                        childrenIstopVO = ifsetTopsMap.get(intfaceVos[i].getPk_dataio_intface());
                    }
                    intfaceVos[i].setPk_dataio_intface(null);
                    intfaceVos[i].setStatus(VOStatus.NEW);
                    aggVO.setParentVO(intfaceVos[i]);
                    if (!ArrayUtils.isEmpty(childrenItemVO)) {
                        for (int j = 0; j < childrenItemVO.length; j++) {
                            childrenItemVO[j].setIfid(null);
                            childrenItemVO[j].setPk_dataintface_b(null);
                            childrenItemVO[j].setStatus(VOStatus.NEW);
                        }
                        aggVO.setTableVO("hr_dataintface_b", childrenItemVO);
                    }
                    if (!ArrayUtils.isEmpty(childrenIstopVO)) {
                        for (int j = 0; j < childrenIstopVO.length; j++) {
                            childrenIstopVO[j].setIfid(null);
                            childrenIstopVO[j].setPk_hr_ifsettop(null);
                            childrenIstopVO[j].setStatus(VOStatus.NEW);
                        }
                        aggVO.setTableVO("hr_ifsettop", childrenIstopVO);
                    }
                    aggVOList.add(aggVO);
                }
                AggHrIntfaceVO[] aggHrIntfaceVOs = aggVOList.toArray(new AggHrIntfaceVO[0]);
                IMDPersistenceService service = MDPersistenceService.lookupPersistenceService();
                NCObject[] ncObjs = new NCObject[aggHrIntfaceVOs.length];
                for (int i = 0; i < aggHrIntfaceVOs.length; i++) {
                    ncObjs[i] = NCObject.newInstance(aggHrIntfaceVOs[i]);
                }
                service.saveBill(ncObjs);
            } finally {
                inC.clear();
            }
        }
    }


    /**
     * нڼн
     *
     * @param waLoginVO
     * @throws BusinessException
     * @author suihang on 2012-12-16
     */
    private void dealWithPeriodState(BmClassVO waLoginVO)
            throws BusinessException {

        // ޸ڼڼļ״̬
        BmPeriodstateVO periodStateVO = getPeriodVO(waLoginVO);
        StringBuffer sqlBuffer = new StringBuffer();
        sqlBuffer.append("update bm_periodstate  "); //
        sqlBuffer.append("   set accountmark  = 'Y' "); // , enableflag = 'Y'
        sqlBuffer.append(" where pk_periodstate = ? "); // 11

        SQLParameter parameter = new SQLParameter();
        parameter.addParam(periodStateVO.getPk_periodstate());
        getBaseDao().executeUpdate(sqlBuffer.toString(), parameter);

        // ޸нҵȡҵڼ
        BmPeriodstateVO nextPeriodStateVO = getNextPeriodVO(waLoginVO);

        sqlBuffer = new StringBuffer();
        sqlBuffer.append("update bm_periodstate  "); //
        sqlBuffer.append("   set  enableflag = 'Y' "); //
        sqlBuffer.append(" where pk_periodstate = ? "); // 11

        parameter = new SQLParameter();
        parameter.addParam(nextPeriodStateVO.getPk_periodstate());
        getBaseDao().executeUpdate(sqlBuffer.toString(), parameter);
        // ޸нʷڼ
        sqlBuffer = new StringBuffer();
        sqlBuffer
                .append("update bm_bmclass set bm_bmclass.cyear = ?, bm_bmclass.cperiod = ? where bm_bmclass.pk_bm_class = ? "); // 1
        parameter = new SQLParameter();
        parameter.addParam(nextPeriodStateVO.getYear());
        parameter.addParam(nextPeriodStateVO.getPeriod());
        parameter.addParam(nextPeriodStateVO.getPk_bm_class());
        getBaseDao().executeUpdate(sqlBuffer.toString(), parameter);
    }

    /***************************************************************************
     * ר籣ԱתʱãĩԱ¼sql
     * <br>Created on 2016-1-5 14:23:58<br>
     * @return
     * @author zhousze
     ***************************************************************************/
    private String getUpdatePsnjobSql1() {

        //еԱpk_psndocͳһ³ɸڼµĹ¼,  orclesqlserverͳһһ
        String sql = "update bm_data set bm_data.pk_psnjob = (select max(hi_psnjob.pk_psnjob) "
                + "from hi_psnjob where hi_psnjob.pk_psndoc = bm_data.pk_psndoc "
                // ͬһԱ
                + "and bm_data.pk_psnorg = hi_psnjob.pk_psnorg "
                // ڼѯ¼
                + " and hi_psnjob.begindate<=?"
                + " and (hi_psnjob.enddate>=? or hi_psnjob.enddate is null)"
                + " and hi_psnjob.ismainjob = 'Y'  ) "
                + "where bm_data.pk_bm_class=? and bm_data.cyear = ? and bm_data.cperiod = ?   "
                + "and exists ( select 1 "
                + "from hi_psnjob where hi_psnjob.pk_psndoc = bm_data.pk_psndoc "
                // ͬһԱ
                + "and bm_data.pk_psnorg = hi_psnjob.pk_psnorg "
                // ڼѯ¼
                + " and hi_psnjob.begindate<=?"
                + " and (hi_psnjob.enddate>=? or hi_psnjob.enddate is null)"
                + " and hi_psnjob.ismainjob = 'Y'   ) ";
        return sql;
    }

    /***************************************************************************
     * Ա¼sql
     * <br>Created on 2012-10-31 10:45:17<br>
     * @return
     * @author daicy
     ***************************************************************************/
    private String getUpdatePsnjobSql() {

        //еԱpk_psndocͳһ³ɸڼµĹ¼,  orclesqlserverͳһһ
        String sql = "update bm_data set (bm_data.pk_psnjob,bm_data.glbdef1,bm_data.glbdef2) = (select max(hi_psnjob.pk_psnjob),max(hi_psnjob.jobglbdef6),max(hi_psnjob.jobglbdef5) "
                + "from hi_psnjob where hi_psnjob.pk_psndoc = bm_data.pk_psndoc "
                // ͬһԱ
                + "and bm_data.pk_psnorg = hi_psnjob.pk_psnorg "
                // ڼѯ¼
                + " and hi_psnjob.begindate<=?"
                + " and (hi_psnjob.enddate>=? or hi_psnjob.enddate is null)"
                + " and hi_psnjob.ismainjob = 'Y' "

                // 2015-12-31 NCdp205567827 zhousze ĩʱݣMAXȥԱȻ⣬ɵ֮ǰĹ¼
                // СĴǳСrecordnum begin
                + " and recordnum = ( select min(recordnum) from hi_psnjob where hi_psnjob.pk_psndoc = bm_data.pk_psndoc "
                + " and hi_psnjob.assgid = bm_data.assgid and bm_data.pk_psnorg = hi_psnjob.pk_psnorg and hi_psnjob.begindate<=? "
                + " and (hi_psnjob.enddate>=? or hi_psnjob.enddate is null) and hi_psnjob.ismainjob = 'Y' ) "
                + " ) "

                + "where bm_data.pk_bm_class=? and bm_data.cyear = ? and bm_data.cperiod = ?   "
                + "and exists ( select 1 "
                + "from hi_psnjob where hi_psnjob.pk_psndoc = bm_data.pk_psndoc "
                // ͬһԱ
                + "and bm_data.pk_psnorg = hi_psnjob.pk_psnorg "
                // ڼѯ¼
                + " and hi_psnjob.begindate<=?"
                + " and (hi_psnjob.enddate>=? or hi_psnjob.enddate is null)"
                + " and hi_psnjob.ismainjob = 'Y'   ) ";
        return sql;
    }

    /**
     * ֯ϵԱ,Ӧɾ.
     * <p>
     * ĩʱ±䶯¸ڼԱ
     *
     * @param waLoginVO
     * @author suihang on 2012-12-16
     */
    private void updatePsnInfo(BmClassEndVO waLoginVO)
            throws BusinessException {

        /**
         * ͬһԱ,ֹͬ(ְ,ְ),ͬһ֯ϵ,ְ¼Ϊµְ¼
         * ְĲΪְͬһʱֻһְж
         *
         * ͬһԱ,ֹͬ(ְ,ְ),µĹ¼䶯, ,ûͨ䶯Աֶ.
         */

        BmPeriodstateVO nextPeriodStateVO = getNextPeriodVO(waLoginVO);

        updatePsnInfo(waLoginVO, nextPeriodStateVO);

    }

    /***************************************************************************
     * ԱתʱҪΪµĹ¼
     * <br>Created on 2012-10-31 10:36:38<br>
     * @param bmClassVO
     * @throws BusinessException
     * @author daicy
     ***************************************************************************/
    private void updatePsnInfo(BmClassVO bmClassVO, BmPeriodstateVO periodStateVO) throws BusinessException {

        /**
         * ͬһԱ,ֹͬ(ְ,ְ),ͬһ֯ϵ,ְ¼Ϊµְ¼
         * ְĲΪְͬһʱֻһְж
         *
         * ͬһԱ,ֹͬ(ְ,ְ),µĹ¼䶯, ,ûͨ䶯Աֶ.
         */

        SQLParameter param = new SQLParameter();
		/*		param.addParam(waLoginVO.getPk_bm_class());
		param.addParam(nextPeriodStateVO.getYear());
		param.addParam(nextPeriodStateVO.getPeriod());*/

        InSQLCreator inC = new InSQLCreator();

        String sql = getUpdatePsnjobSql();

        // 2015-08-31 zhousze ϲshenliangc NCdp205374598 н籣ӦԱźԱ begin
//		param = new SQLParameter();
//		param.addParam(periodStateVO.getCenddate());
//		param.addParam(periodStateVO.getCstartdate());
//		param.addParam(bmClassVO.getPk_bm_class());
//		param.addParam(periodStateVO.getYear());
//		param.addParam(periodStateVO.getPeriod());
//		param.addParam(periodStateVO.getCenddate());
//		param.addParam(periodStateVO.getCstartdate());
//		getBaseDao().executeUpdate(sql, param);

        BmPeriodstateVO nextPeriodStateVO = getNextPeriodVO(bmClassVO);

        param = new SQLParameter();
        //guoqt ݲֹ仯ڣ0ʾ仯˵ڼʱԱȡڼµĹ¼
        //31ʾ仯˵ڼʱȡ¸ڼµĹ¼Ϊ15˵ڼʱ¼ȡڼ1ŵ15µĹ¼
        Integer paramValue = SysinitAccessor.getInstance().getParaInt(bmClassVO.getPk_org(), BmParaConstant.CHANGE_DATE);
        UFLiteralDate enddate = nextPeriodStateVO.getCstartdate().getDateAfter(paramValue - 1);
        if (enddate.after(nextPeriodStateVO.getCenddate())) {
            enddate = nextPeriodStateVO.getCenddate();
        }
        //guoqtڼ
        BmPeriodstateVO prePeriodStateVO = getPeriodVO(bmClassVO);
        param.addParam(enddate);
        //guoqtĩһ䶯NCdp205255067
        param.addParam(prePeriodStateVO.getCstartdate());

        // 2015-12-31 NCdp205567827 zhousze ĩʱݣMAXȥԱȻ⣬ɵ֮ǰĹ¼
        // СĴǳСrecordnum begin
        param.addParam(enddate);
        param.addParam(prePeriodStateVO.getCstartdate());

        param.addParam(bmClassVO.getPk_bm_class());
        param.addParam(nextPeriodStateVO.getYear());
        param.addParam(nextPeriodStateVO.getPeriod());
        param.addParam(nextPeriodStateVO.getCenddate());
        //guoqt ڼ䷶ΧǴӱڼ俪ʼڿʼ
        param.addParam(prePeriodStateVO.getCstartdate());

        getBaseDao().executeUpdate(sql, param);
        // 2015-08-31 zhousze ϲshenliangc NCdp205374598 н籣ӦԱźԱ end

        // 汾
        if (getBaseDao().getDBType() == nc.vo.hr.tools.dbtool.util.db.DBUtil.SQLSERVER) {

            sql = "update bm_data "
                    + "set workorg = org_orgs.pk_org , workorgvid = org_orgs.pk_vid, "
                    + "workdept = org_dept.pk_dept , workdeptvid = org_dept.pk_vid "
                    + "from hi_psnjob,org_orgs,org_dept "
                    + "where bm_data.pk_psnjob = hi_psnjob.pk_psnjob "
                    + "and hi_psnjob.pk_org = org_orgs.pk_org "
                    + "and hi_psnjob.pk_dept = org_dept.pk_dept "
                    + "and bm_data.pk_bm_class = ? " + "and bm_data.cyear = ? "
                    + "and bm_data.cperiod = ? ";

        } else {
            sql = "UPDATE bm_data " + " SET workorg = (SELECT org_orgs.pk_org "
                    + "				FROM hi_psnjob,org_orgs "
                    + "				WHERE bm_data.pk_psnjob = hi_psnjob.pk_psnjob "
                    + "					AND hi_psnjob.pk_org = org_orgs.pk_org " + "	) "
                    + "	, workorgvid = (SELECT org_orgs.pk_vid "
                    + "					FROM hi_psnjob,org_orgs "
                    + "					WHERE bm_data.pk_psnjob = hi_psnjob.pk_psnjob "
                    + "						AND hi_psnjob.pk_org = org_orgs.pk_org " + "	) "
                    + "	, workdept = (	SELECT org_dept.pk_dept "
                    + "					FROM hi_psnjob,org_dept "
                    + "					WHERE bm_data.pk_psnjob = hi_psnjob.pk_psnjob "
                    + "						AND hi_psnjob.pk_dept = org_dept.pk_dept " + "	) "
                    + "	, workdeptvid = (	SELECT org_dept.pk_vid "
                    + "						FROM hi_psnjob,org_dept "
                    + "						WHERE bm_data.pk_psnjob = hi_psnjob.pk_psnjob "
                    + "							AND hi_psnjob.pk_dept = org_dept.pk_dept "
                    + "	) " + " WHERE bm_data.pk_bm_class = ? "
                    + "	AND bm_data.cyear = ? " + "	AND bm_data.cperiod = ? ";
        }

        param.clearParams();
        param.addParam(bmClassVO.getPk_bm_class());
        param.addParam(periodStateVO.getYear());
        param.addParam(periodStateVO.getPeriod());
        getBaseDao().executeUpdate(sql, param);
    }

    /***************************************************************************
     * ԱתʱҪΪµĹ¼
     * <br>Created on 2012-11-1 4:03:44<br>
     * @param bmClassVO
     * @param vos
     * @throws BusinessException
     * @author daicy
     ***************************************************************************/
    public void updatePsnInfo(BmClassVO[] bmClassVOs, HashMap<String, List<BmDataVO>> vosmap)
            throws BusinessException {

        /**
         * ͬһԱ,ֹͬ(ְ,ְ),ͬһ֯ϵ,ְ¼Ϊµְ¼
         * ְĲΪְͬһʱֻһְж
         *
         * ͬһԱ,ֹͬ(ְ,ְ),µĹ¼䶯, ,ûͨ䶯Աֶ.
         */

        //		BmPeriodstateVO nowPeriodStateVO = getPeriodVO(bmClassVOs);
        HashMap<String, BmPeriodstateVO> bmpstatemap = getPeriodVO(bmClassVOs);
        updatePsnInfo(bmClassVOs, vosmap, bmpstatemap);

    }


    /***************************************************************************
     * ԱתʱҪΪµĹ¼
     * <br>Created on 2012-10-31 10:36:38<br>
     * @param bmClassVO
     * @throws BusinessException
     * @author daicy
     ***************************************************************************/
    private void updatePsnInfo(BmClassVO[] bmClassVOs, HashMap<String, List<BmDataVO>> vosmap, HashMap<String, BmPeriodstateVO> periodStateVOmap) throws BusinessException {

        /**
         * ͬһԱ,ֹͬ(ְ,ְ),ͬһ֯ϵ,ְ¼Ϊµְ¼
         * ְĲΪְͬһʱֻһְж
         *
         * ͬһԱ,ֹͬ(ְ,ְ),µĹ¼䶯, ,ûͨ䶯Աֶ.
         */

        //		SQLParameter param = new SQLParameter();
		/*		param.addParam(waLoginVO.getPk_bm_class());
		param.addParam(nextPeriodStateVO.getYear());
		param.addParam(nextPeriodStateVO.getPeriod());*/

        InSQLCreator inC = new InSQLCreator();
        String[] sqls = null;
        String[] datasqls = null;
        SQLParameter[] params = null;
        SQLParameter[] params2 = null;
        String tsql = getUpdatePsnjobSql1();
        String datasql = null;
        //汾
        if (getBaseDao().getDBType() == nc.vo.hr.tools.dbtool.util.db.DBUtil.SQLSERVER) {

            datasql = "update bm_data "
                    + "set workorg = org_orgs.pk_org , workorgvid = org_orgs.pk_vid, "
                    + "workdept = org_dept.pk_dept , workdeptvid = org_dept.pk_vid "
                    + "from hi_psnjob,org_orgs,org_dept "
                    + "where bm_data.pk_psnjob = hi_psnjob.pk_psnjob "
                    + "and hi_psnjob.pk_org = org_orgs.pk_org "
                    + "and hi_psnjob.pk_dept = org_dept.pk_dept "
                    + "and bm_data.pk_bm_class = ? " + "and bm_data.cyear = ? "
                    + "and bm_data.cperiod = ? ";

        } else {
            datasql = "UPDATE bm_data "
                    + " SET workorg = (SELECT org_orgs.pk_org "
                    + "				FROM hi_psnjob,org_orgs "
                    + "				WHERE bm_data.pk_psnjob = hi_psnjob.pk_psnjob "
                    + "					AND hi_psnjob.pk_org = org_orgs.pk_org " + "	) "
                    + "	, workorgvid = (SELECT org_orgs.pk_vid "
                    + "					FROM hi_psnjob,org_orgs "
                    + "					WHERE bm_data.pk_psnjob = hi_psnjob.pk_psnjob "
                    + "						AND hi_psnjob.pk_org = org_orgs.pk_org " + "	) "
                    + "	, workdept = (	SELECT org_dept.pk_dept "
                    + "					FROM hi_psnjob,org_dept "
                    + "					WHERE bm_data.pk_psnjob = hi_psnjob.pk_psnjob "
                    + "						AND hi_psnjob.pk_dept = org_dept.pk_dept " + "	) "
                    + "	, workdeptvid = (	SELECT org_dept.pk_vid "
                    + "						FROM hi_psnjob,org_dept "
                    + "						WHERE bm_data.pk_psnjob = hi_psnjob.pk_psnjob "
                    + "							AND hi_psnjob.pk_dept = org_dept.pk_dept "
                    + "	) "
                    + " WHERE bm_data.pk_bm_class = ? "
                    + "	AND bm_data.cyear = ? "
                    + "	AND bm_data.cperiod = ? ";
        }
        for (BmClassVO bmclsvo : bmClassVOs) {
            String pk_bm_class = bmclsvo.getPk_bm_class();
            List<BmDataVO> listvos = vosmap.get(pk_bm_class);
            BmDataVO[] vos = listvos.toArray(new BmDataVO[0]);
            BmPeriodstateVO periodStateVO = periodStateVOmap.get(pk_bm_class);

            StringBuffer sqlb = new StringBuffer();
            sqlb.append(tsql);
            StringBuffer sqlb2 = new StringBuffer();
            sqlb2.append(datasql);
            //еԱpk_psndocͳһ³ɸڼµĹ¼,  orclesqlserverͳһһ
            if (null != vos && vos.length > 0 && null != vos[0].getPk_psndoc()) {
                String psninsql = " and bm_data.pk_psndoc in(" + inC.getInSQL(vos, BmDataVO.PK_PSNDOC) + ")";
                sqlb.append(psninsql);
                sqlb2.append(psninsql);
            }
            sqls = (String[]) ArrayUtils.add(sqls, sqlb.toString());
            datasqls = (String[]) ArrayUtils.add(datasqls, sqlb2.toString());

            SQLParameter param = new SQLParameter();
            param.addParam(periodStateVO.getCenddate());
            param.addParam(periodStateVO.getCstartdate());
            param.addParam(pk_bm_class);
            param.addParam(periodStateVO.getYear());
            param.addParam(periodStateVO.getPeriod());
            param.addParam(periodStateVO.getCenddate());
            param.addParam(periodStateVO.getCstartdate());
            params = (SQLParameter[]) ArrayUtils.add(params, param);

            SQLParameter param2 = new SQLParameter();
            param2.addParam(pk_bm_class);
            param2.addParam(periodStateVO.getYear());
            param2.addParam(periodStateVO.getPeriod());
            params2 = (SQLParameter[]) ArrayUtils.add(params2, param2);
        }

        PersistenceDAO pdao = new PersistenceDAO();
        pdao.executeSQLs(sqls, params);
        pdao.executeSQLs(datasqls, params2);

    }

    private void synchronizeGroupClass(BmClassEndVO waLoginVO)
            throws BusinessException {
        // Ȳ鿴Ƿŷķ
        IBmClassQueryService bmClass = NCLocator.getInstance().lookup(
                IBmClassQueryService.class);
        BmClassVO vo = bmClass.queryGroupClassByOrgClass(waLoginVO
                .getPk_bm_class());
        if (vo == null) {
            return;
        }

        // ǣ򿴼ŵķ뵱ǰӷǲͬһڼ
        if (needMonthEndGroupClass(waLoginVO, vo)) {
            // ,ŵķҪĩ
            monthEndGroupClassvo(vo);
        }
    }

    /**
     * ŷĩ
     *
     * @throws BusinessException
     */
    private void monthEndGroupClassvo(BmClassVO waLoginVO)
            throws BusinessException {

        // һڼwa_classitem
        createNextPeriodItems(waLoginVO, waLoginVO);

        // нڼ
        dealWithPeriodState(waLoginVO);

    }

    /**
     * УǷԽ
     *
     * @param waGlobalVO
     * @return
     * @throws BusinessException
     * @author suihang
     */
    private boolean isMonthEndEnabled(BmClassVO bmClassVO)
            throws BusinessException {
        BmPeriodstateVO periodStateVO = getPeriodVO(bmClassVO);
        if (periodStateVO != null
                && !periodStateVO.getAccountmark().booleanValue()
//				20151021 xiejie3  ϲNCdp205496395		
            // modify by zouj 2015/09/10 ֿ֧ս
//				&& periodStateVO.getCheckflag().booleanValue()
//				end
        ) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * --ڼѾʣ һڼδ<BR>
     * ߼ϵ ڼѾʵڼ䣬 ҴڸڼСڼδ
     *
     * @param waGlobalVO
     * @return
     * @throws BusinessException
     * @author suihang
     */
    private boolean isMonthEndReverseEnabled(BmClassVO waClassVO)
            throws BusinessException {
        // ֶǶΣзΪδ
        // Ƕηн鿴ҵһηнǷѾ
        // if(waClassVO.getMutipleflag().booleanValue()){
        // ҵڼһηнǷ˵
        BmPeriodstateVO statevo = new BmPeriodstateVO();
        statevo.setYear(waClassVO.getCyear());
        statevo.setPeriod(waClassVO.getCperiod());
        BmLoginVO waLoginVO = new BmLoginVO();
        waLoginVO.setPk_bm_class(waClassVO.getPk_bm_class());
        waLoginVO.setPk_group(waClassVO.getPk_group());
        waLoginVO.setPk_org(waClassVO.getPk_org());
        waLoginVO.setPeriodVO(statevo);
        return !(isExistCheckData(waLoginVO));
    }

    /**
     * жϸǷѾ˵
     *
     * @param waLoginVO
     * @return
     * @throws DAOException
     * @author suihang on 2012-8-10
     */
    private boolean isExistCheckData(BmLoginVO waLoginVO) throws DAOException {
        StringBuffer sqlBuffer = new StringBuffer();
        sqlBuffer.append("select bm_data.pk_bm_data "); // 1
        sqlBuffer.append("  from bm_data ");
        sqlBuffer.append(" where bm_data.checkflag = 'Y' ");
        sqlBuffer.append("   and bm_data.pk_bm_data =? ");
        sqlBuffer.append("   and bm_data.cyear = ? ");
        sqlBuffer.append("   and bm_data.cperiod = ? ");


        SQLParameter parameter = new SQLParameter();
        parameter.addParam(waLoginVO.getPk_bm_class());
        parameter.addParam(waLoginVO.getPeriodVO().getYear());
        parameter.addParam(waLoginVO.getPeriodVO().getPeriod());
        return isValueExist(sqlBuffer.toString(), parameter);
    }

    private boolean needMonthEndGroupClass(BmClassVO orgvo, BmClassVO groupvo) {
        String orgPeriod = orgvo.getCyear() + orgvo.getCperiod();

        String groupPeriod = groupvo.getCyear() + groupvo.getCperiod();

        // ǰ֯нڼ>= ŵĵǰнڼ
        if (orgPeriod.compareTo(groupPeriod) >= 0) {
            return true;
        } else {
            return false;
        }

    }

    private BmClassItemVO[] getTransferItems(BmClassEndVO bmLoginVO)
            throws DAOException {
        StringBuffer sqlBuffer = new StringBuffer();
        sqlBuffer
                .append("select bm_classitem.itemkey, bm_classitem.destitemcol "); // 1
        sqlBuffer.append("  from bm_classitem ");
        sqlBuffer.append(" where bm_classitem.pk_bm_class = ? ");
        sqlBuffer.append("   and bm_classitem.cyear = ? ");
        sqlBuffer.append("   and bm_classitem.cperiod = ? ");
        //		sqlBuffer.append("   and bm_classitem.istransfer = 'Y' ");
        sqlBuffer.append("   and bm_classitem.destitemcol <> '~' ");

        return executeQueryVOs(sqlBuffer.toString(),
                getCommonParameter(bmLoginVO), BmClassItemVO.class);
    }

    /**
     * @param dataVO
     * @param transferItemVOs
     * @author suihang on 2012-7-15
     */
    private void transferValue(BmDataVO dataVO, BmClassItemVO[] transferItemVOs) {
        if (transferItemVOs == null || dataVO == null) {
            return;
        }
        Map<String, Object> oldeValueMap = new HashMap<String, Object>();
        for (BmClassItemVO waClassItemVO : transferItemVOs) {

            String fromItemKey = waClassItemVO.getItemkey();
            String toItemKey = waClassItemVO.getDestitemcol();

            Object oldValue = dataVO.getAttributeValue(toItemKey);
            oldeValueMap.put(toItemKey, oldValue);

            if (oldeValueMap.get(fromItemKey) != null) {
                dataVO.setAttributeValue(toItemKey,
                        oldeValueMap.get(fromItemKey));
            } else {
                dataVO.setAttributeValue(toItemKey,
                        dataVO.getAttributeValue(fromItemKey));
            }
        }
    }

    /**
     * ߼ϵ ڸڼСڼ䣬 һڼ Created on 2012-9-3
     *
     * @param waGlobalVO
     * @return
     * @throws BusinessException
     * @author suihang
     */
    private BmPeriodstateVO getNextPeriodVO(BmClassVO bmClassEndVO)
            throws BusinessException {

        BmPeriodstateVO periodVO = null;

        StringBuffer sqlB = new StringBuffer();
        sqlB.append("select min(year || period) yearperiod "); // 1
        sqlB.append("  from bm_periodstate ");
        sqlB.append(" inner join bm_period on (bm_periodstate.pk_bm_period = ");
        sqlB.append("                         bm_period.pk_bm_period) ");
        sqlB.append(" where pk_bm_class = '" + bmClassEndVO.getPk_bm_class()
                + "' ");
        sqlB.append("   and (year || period) > '" + bmClassEndVO.getCyear()
                + bmClassEndVO.getCperiod() + "' ");

        YearPeriodSeperatorVO seperator = executeQueryVO(sqlB.toString(),
                YearPeriodSeperatorVO.class);

        if (seperator != null && seperator.getYear() != null) {
            BmClassVO classVO = new BmClassVO();
            classVO.setPk_bm_class(bmClassEndVO.getPk_bm_class());
            classVO.setCyear(seperator.getYear());
            classVO.setCperiod(seperator.getPeriod());
            periodVO = getPeriodVO(classVO);
        } else {
            throw new BusinessException(ResHelper.getString("60150monthend", "060150monthend0025", bmClassEndVO.getName())
                    /*@res "ûеõ[{0}]һڼ䣡˲"*/);
        }
        return periodVO;
    }

    /**
     * Сڸڼڼ䡪Ѿõڼ䣬ûйϵһڼ䡣
     *
     * @param waGlobalVO
     * @return
     * @throws BusinessException 2012-12-4 11:27:27
     * @author zhoucx
     */
    private BmPeriodstateVO getPrePeriodVO(BmClassVO bmClassEndVO)
            throws BusinessException {

        BmPeriodstateVO periodVO = null;
        StringBuffer sqlB = new StringBuffer();
        sqlB.append("select max(year || period) yearperiod "); // 1
        sqlB.append("  from bm_periodstate ");
        sqlB.append(" inner join bm_period on (bm_periodstate.pk_bm_period = ");
        sqlB.append("                         bm_period.pk_bm_period) ");
        sqlB.append(" where bm_periodstate.enableflag='Y' and pk_bm_class = '"
                + bmClassEndVO.getPk_bm_class() + "' ");
        sqlB.append("   and (year || period) < '" + bmClassEndVO.getCyear()
                + bmClassEndVO.getCperiod() + "' ");

        YearPeriodSeperatorVO seperator = executeQueryVO(sqlB.toString(),
                YearPeriodSeperatorVO.class);

        if (seperator != null && seperator.getYear() != null
                && seperator.getPeriod() != null) {
            BmClassVO newvo = (BmClassVO) bmClassEndVO.clone();
            newvo.setCyear(seperator.getYear());
            newvo.setCperiod(seperator.getPeriod());
            periodVO = getPeriodVO(newvo);
        } else {
            throw new BusinessException(ResHelper.getString("60150monthend", "060150monthend0027")
                    /*@res "ûеõֵһڼ"*/);
        }
        return periodVO;
    }

    /**
     * ߼ϵ Сڸڼڼ䣬 Ǽ°汾ڼ Created on 2012-9-3
     *
     * @param waGlobalVO
     * @return
     * @throws BusinessException
     * @author suihang
     */
    private YearPeriodSeperatorVO getGroupPeriod(BmClassVO groupclassVO)
            throws BusinessException {

        StringBuffer sqlBuffer = new StringBuffer();
        sqlBuffer
                .append("select max(bm_classitem.cyear || bm_classitem.cperiod) yearperiod "); // 1
        sqlBuffer.append("  from bm_classitem ");
        sqlBuffer.append(" where bm_classitem.pk_bm_class = ? ");
        sqlBuffer
                .append("   and (bm_classitem.cyear || bm_classitem.cperiod) <= ? ");

        SQLParameter parameter = new SQLParameter();
        parameter.addParam(groupclassVO.getPk_bm_class());
        parameter.addParam(groupclassVO.getCyear() + groupclassVO.getCperiod());

        return executeQueryVO(sqlBuffer.toString(), parameter,
                YearPeriodSeperatorVO.class);
    }

    /**
     * @param groupClassItemVOs
     * @param corpClassItemVOs
     * @return
     * @throws DAOException
     * @author suihang on 2012-12-22
     */
    private BmClassItemVO[] getNextPeriodItems(
            BmClassItemVO[] groupClassItemVOs, BmClassItemVO[] corpClassItemVOs)
            throws BusinessException, DAOException {
        HashMap<String, BmClassItemVO> classitemHashMap = new HashMap<String, BmClassItemVO>();
        // ŵĿŵmap
        if (ArrayUtils.isEmpty(groupClassItemVOs) || ArrayUtils.isEmpty(corpClassItemVOs)) {
            return corpClassItemVOs;
        }
        for (BmClassItemVO waClassItemVO : corpClassItemVOs) {
            classitemHashMap.put(waClassItemVO.getPk_bm_item(), waClassItemVO);
        }
        for (BmClassItemVO bmClassItemVO : groupClassItemVOs) {
            if (!classitemHashMap.containsKey(bmClassItemVO.getPk_bm_item())) {
                bmClassItemVO.setPk_classitem(null);
                classitemHashMap.put(bmClassItemVO.getPk_bm_item(),
                        bmClassItemVO);
            }
        }
        return classitemHashMap.values().toArray(new BmClassItemVO[0]);
    }
	/*private BmClassItemVO[] getNextPeriodItems2 (
			BmClassItemVO[] groupClassItemVOs, BmClassItemVO[] corpClassItemVOs)
			throws BusinessException, DAOException {
		HashMap<String, BmClassItemVO> classitemHashMap = new HashMap<String, BmClassItemVO>();
		// ŵĿŵmap
		if(ArrayUtils.isEmpty(groupClassItemVOs)||ArrayUtils.isEmpty(corpClassItemVOs)){
			return corpClassItemVOs;
		}
		for (BmClassItemVO waClassItemVO : groupClassItemVOs) {
			classitemHashMap.put(waClassItemVO.getPk_bm_item(), waClassItemVO);
		}

		//ݼǷ޸ԴԴݡǷ֯Ϊ׼Ķ֯Ϊ׼
		// һĿƣ ȡ˾
		for (BmClassItemVO waClassItemVO : corpClassItemVOs) {
			BmClassItemVO groupClassItemVO = classitemHashMap.get(waClassItemVO
					.getPk_bm_item());

			if (groupClassItemVO != null) {

				//
				groupClassItemVO.setName(waClassItemVO.getName());
				groupClassItemVO.setName2(waClassItemVO.getName2());
				groupClassItemVO.setName3(waClassItemVO.getName3());
				groupClassItemVO.setName4(waClassItemVO.getName4());
				groupClassItemVO.setName5(waClassItemVO.getName5());
				groupClassItemVO.setName6(waClassItemVO.getName6());

				//
				groupClassItemVO.setClearflag(waClassItemVO.getClearflag());

				//½ת
				groupClassItemVO.setDestitemcol(waClassItemVO.getDestitemcol());
				groupClassItemVO.setDestitempk(waClassItemVO.getDestitempk());
				//ʾ
				groupClassItemVO.setHrssdisplay(waClassItemVO
						.getHrssdisplay());
				//͡ݳȡ Сλ֯Ϊ׼
				groupClassItemVO.setIitemtype(waClassItemVO.getIitemtype());
				groupClassItemVO.setIfldwidth(waClassItemVO.getIfldwidth());
				groupClassItemVO.setIflddecimal(waClassItemVO.getIflddecimal());
				// shiping 2021-07-15 λʽ֯Ϊ׼
				groupClassItemVO.setRound_type(waClassItemVO.getRound_type());

				UFBoolean modifyflag = groupClassItemVO.getModifyflag();
				if (modifyflag != null && modifyflag.booleanValue()) {
					// ޸Դ
					groupClassItemVO.setIfromflag(waClassItemVO.getIfromflag());
					groupClassItemVO.setVformula(waClassItemVO.getVformula());
					groupClassItemVO.setVformulastr(waClassItemVO.getVformulastr());
				}

			}
		}
		// Ƿ˾ԼĿ
		//		BmClassVO groupClassVO = retrieveByPK(BmClassVO.class,
		//				groupClassItemVOs[0].getPk_bm_class());
		// Ϊ˾ԼĿ
		// groupClassVO.get.getAddflag().booleanValue();
		boolean isCorpAddable = true;
		if (isCorpAddable) {
			for (BmClassItemVO waClassItemVO : corpClassItemVOs) {
				if (!classitemHashMap
						.containsKey(waClassItemVO.getPk_bm_item())) {
					classitemHashMap.put(waClassItemVO.getPk_bm_item(),
							waClassItemVO);
				}
			}
		}
		return classitemHashMap.values().toArray(new BmClassItemVO[0]);
	}*/

    /**
     * @param groupclassVO
     * @return
     * @throws BusinessException
     * @throws DAOException
     * @author suihang on 2012-12-22
     */
    private BmClassItemVO[] getGroupClassItems(BmClassVO groupclassVO)
            throws BusinessException, DAOException {
        YearPeriodSeperatorVO periodSeperatorVO = getGroupPeriod(groupclassVO);
        if (periodSeperatorVO == null) {
            throw new BusinessException(ResHelper.getString("60150monthend", "060150monthend0028")
                    /*@res "ûҵŰ汾"*/);
        }

        String condition = " pk_bm_class = '" + groupclassVO.getPk_bm_class()
                + "'and cyear = '" + periodSeperatorVO.getYear()
                + "' and cperiod = '" + periodSeperatorVO.getPeriod() + "'";

        return retrieveByClause(BmClassItemVO.class, condition);
    }

    private BmPeriodstateVO getPeriodVO(BmClassVO bmClassVO)
            throws DAOException {
        StringBuffer sqlBuffer = new StringBuffer();
        sqlBuffer.append(getPeriodViewTable()); // 1

        sqlBuffer.append(" where pk_bm_class = ? ");
        sqlBuffer.append("   and year = ? ");
        sqlBuffer.append("   and period = ? ");
        SQLParameter parameter = new SQLParameter();
        parameter.addParam(bmClassVO.getPk_bm_class());
        parameter.addParam(bmClassVO.getCyear());
        parameter.addParam(bmClassVO.getCperiod());

        return executeQueryVO(sqlBuffer.toString(), parameter,
                BmPeriodstateVO.class);
    }


    private HashMap<String, BmPeriodstateVO> getPeriodVO(BmClassVO[] bmClassVOs)
            throws DAOException {
        InSQLCreator isc = new InSQLCreator();
        String[] fields = BmClassConstant.CLASS_COLUMN;
        String table = BmClassConstant.BM_TEMP_CLASS;
        try {
            table = isc.insertValues(table, fields, fields, bmClassVOs);
        } catch (BusinessException e) {
            throw new DAOException(e.getMessage());
        }

        StringBuffer sqlBuffer = new StringBuffer();
        sqlBuffer.append(getPeriodViewTable()); // 1
        sqlBuffer.append(" inner join ");
        sqlBuffer.append(table);
        sqlBuffer.append(" on (bm_periodstate.pk_bm_class = ");
        sqlBuffer.append(table);
        sqlBuffer.append(".pk_bm_class and bm_period.year = ");
        sqlBuffer.append(table);
        sqlBuffer.append(".cyear and bm_period.period = ");
        sqlBuffer.append(table);
        sqlBuffer.append(".cperiod ) order by bm_periodstate.pk_bm_class");

        HashMap<String, BmPeriodstateVO> vomap = new HashMap<String, BmPeriodstateVO>();
        BmPeriodstateVO[] bmpstatevos = executeQueryVOs(sqlBuffer.toString(), BmPeriodstateVO.class);
        for (BmPeriodstateVO vo : bmpstatevos) {
            vomap.put(vo.getPk_bm_class(), vo);
        }

        return vomap;

    }

    private BmDataVO clearSysitemValue(BmDataVO dataVO, BmClassEndVO sourceLoginVO, BmClassItemVO[] clearSysitemVOs) throws DAOException {

        if (ArrayUtils.isEmpty(clearSysitemVOs)) {
            return dataVO;
        }
        for (int i = 0; i < clearSysitemVOs.length; i++) {
            dataVO.setAttributeValue(clearSysitemVOs[i].getItemkey(), UFDouble.ZERO_DBL);
        }
        return dataVO;

    }


    /**
     * ѯеķֹϵͳĿ
     *
     * @return
     * @throws DAOException
     */

    private BmClassItemVO[] queryClearSysitemVOs(BmClassEndVO sourceLoginVO) throws DAOException {

        StringBuffer sqlBuffer = new StringBuffer();
        sqlBuffer.append(" select bm_item.itemkey "); // 1
        sqlBuffer.append("  from bm_classitem, bm_item ");
        sqlBuffer
                .append(" where bm_classitem.pk_bm_item = bm_item.pk_bm_item ");
        sqlBuffer.append("   and bm_classitem.pk_bm_class = ? ");
        sqlBuffer.append("   and bm_classitem.cyear = ? ");
        sqlBuffer.append("   and bm_classitem.cperiod = ? ");
        sqlBuffer.append("  and (bm_item.defaultflag = 'Y' and bm_classitem.ifromflag <> " + BmFromEnumVO.USER_INPUT.value() + " ) ");


        SQLParameter parameter = getCommonParameter(sourceLoginVO);
        // 
        return executeQueryVOs(sqlBuffer.toString(), parameter, BmClassItemVO.class);

    }

    private String getPeriodViewTable() {
        StringBuffer sqlBuffer = new StringBuffer();
        sqlBuffer.append("select bm_periodstate.pk_periodstate, "); // 1
        sqlBuffer.append("       bm_periodstate.pk_bm_period, "); // 2
        sqlBuffer.append("       bm_periodstate.pk_bm_class, "); // 3
        sqlBuffer.append("       bm_periodstate.recacuflag, "); // 4
        sqlBuffer.append("       bm_periodstate.accountmark, "); // 5
        sqlBuffer.append("       bm_periodstate.checkflag, "); // 6
        sqlBuffer.append("       bm_periodstate.operatorid, "); // 7
        sqlBuffer.append("       bm_periodstate.pk_org, "); // 9
        sqlBuffer.append("       bm_periodstate.enableflag, "); // 10
        sqlBuffer.append("       bm_period.pk_periodscheme, "); // 17
        sqlBuffer.append("       bm_period.year, "); // 18
        sqlBuffer.append("       bm_period.period, "); // 19
        sqlBuffer.append("       bm_period.cstartdate, "); // 22
        sqlBuffer.append("       bm_period.cenddate, "); // 23
        sqlBuffer.append("       bm_period.caccyear, "); // 24
        sqlBuffer.append("       bm_period.caccperiod, "); // 25
        sqlBuffer.append("       bm_periodstate.ts "); // 26
        sqlBuffer.append("  from bm_periodstate ");
        sqlBuffer
                .append(" inner join bm_period on (bm_periodstate.pk_bm_period = ");
        sqlBuffer.append("                         bm_period.pk_bm_period ) ");
        return sqlBuffer.toString();

    }

    /**
     * pk_wa_class year, period
     *
     * @param waLoginVO
     * @return
     * @author suihang on 2012-12-2
     */
    private SQLParameter getCommonParameter(BmClassEndVO bmLoginVO) {
        SQLParameter parameter = new SQLParameter();
        parameter.addParam(bmLoginVO.getPk_bm_class());
        parameter.addParam(bmLoginVO.getCyear());
        parameter.addParam(bmLoginVO.getCperiod());
        return parameter;
    }


    /**
     * һڼ籣ɽʾ
     *
     * @param bmLoginVO
     */
    private void createNextBmdataDsp(BmClassEndVO bmClassEndVO) throws BusinessException {
        //ѯַʽʾ
        List<BmdataDspVO> list4Class = BMDelegator.getBmdataQueryService().queryBmdataDsp4Class(bmClassEndVO);
        BmPeriodstateVO nextPeriodStateVO = null;
        if (list4Class != null && list4Class.size() > 0) {
            nextPeriodStateVO = getNextPeriodVO(bmClassEndVO);
            bmClassEndVO.setCyear(nextPeriodStateVO.getYear());
            bmClassEndVO.setCperiod(nextPeriodStateVO.getPeriod());
            BMDelegator.getBmdataManageService().createNextBmdataDsp(bmClassEndVO, list4Class);
        }
        //ѯԱʽʾ
        List<BmdataDspVO> list4Psndoc = BMDelegator.getBmdataQueryService().queryBmdataDsp4Psndoc(bmClassEndVO, getContext());
        if (list4Psndoc != null && list4Psndoc.size() > 0) {
            if (nextPeriodStateVO == null) {
                nextPeriodStateVO = getNextPeriodVO(bmClassEndVO);
            }
            bmClassEndVO.setCyear(nextPeriodStateVO.getYear());
            bmClassEndVO.setCperiod(nextPeriodStateVO.getPeriod());
            // ɾһڼаԱʾ
            BMDelegator.getBmdataManageService().deleteBmdataDsp4Psndoc(bmClassEndVO, getContext());
            // һڼʾ
            BMDelegator.getBmdataManageService().createNextBmdataDsp(bmClassEndVO, list4Psndoc);
        }
    }


    /**
     * ȥڼ籣ɽʾ
     *
     * @param bmClassEndVO
     */
    private void deleteBmdataDsp(BmClassEndVO bmClassEndVO) throws BusinessException {
        //ɾַʽʾ
        BMDelegator.getBmdataManageService().deleteBmdataDsp4Class(bmClassEndVO);
    }

    public boolean checkPsnAbnormalStatus(BmClassEndVO[] classVOs) throws BusinessException {
        StringBuffer sqlBuffer = new StringBuffer();
        if (!ArrayUtils.isEmpty(classVOs)) {
            String[] pks = new String[classVOs.length];
            for (int i = 0; i < pks.length; i++) {
                pks[i] = classVOs[i].getPk_bm_class();
            }
            String cyear = classVOs[0].getCyear();
            String cperiod = classVOs[0].getCperiod();
            InSQLCreator inSQLCreator = new InSQLCreator();
            String bmClassPks = "";
            try {
                bmClassPks = inSQLCreator.getInSQL(pks);
                sqlBuffer.append("select 1 from bm_data ");
                sqlBuffer.append(" where bm_data.pk_bm_class in ( " + bmClassPks + " ) ");
                sqlBuffer.append("   and bm_data.cyear = " + cyear);
                sqlBuffer.append("   and bm_data.cperiod = " + cperiod);
                sqlBuffer.append("   and bm_data.accountstate in (1,2,3)");
                return isValueExist(sqlBuffer.toString());
            } finally {
                inSQLCreator.clear();
            }
        }
        return false;
    }

    private void synchronizeGroupClass4Reverse(BmClassEndVO waLoginVO)
            throws BusinessException {
        // Ȳ鿴Ƿŷķ
        IBmClassQueryService bmClass = NCLocator.getInstance().lookup(
                IBmClassQueryService.class);
        BmClassVO vo = bmClass.queryGroupClassByOrgClass(waLoginVO.getPk_bm_class());
        if (vo == null) {
            return;
        }
        String sql = "select max(year||period) maxperiod from bm_periodstate inner join bm_period on bm_periodstate.pk_bm_period = bm_period.pk_bm_period" +
                " where pk_bm_class in (select classid from bm_assigncls where pk_sourcecls = '" + vo.getPk_bm_class() + "') and bm_periodstate.enableflag = 'Y'";
        Map<String, String> map = (Map<String, String>) getBaseDao().executeQuery(sql, new MapProcessor());
        String maxperiod = map.get("maxperiod");
        if ((vo.getCyear() + vo.getCperiod()).compareTo(maxperiod) > 0) {
            //			BmClassEndVO groupvo = new BmClassEndVO();
            //			groupvo.setPk_org(vo.getPk_org());
            //			groupvo.setPk_bm_class(vo.getPk_bm_class());
            //			groupvo.setCyear(vo.getCyear());
            //			groupvo.setCperiod(vo.getCperiod());
            //			monthEndReverse(groupvo);

            String pk_bm_class = vo.getPk_bm_class();
            /*ŷķ*/
            //ɾ籣Ŀ
            sql = "delete from bm_classitem where pk_bm_class = '" + pk_bm_class + "'" +
                    " and cyear = '" + vo.getCyear() + "' and cperiod = '" + vo.getCperiod() + "'";
            getBaseDao().executeUpdate(sql);
            //޸ڼ״̬
            sql = "update bm_periodstate set enableflag='N' where pk_periodstate in " +
                    "(select pk_periodstate from  bm_periodstate inner join bm_period" +
                    " on bm_periodstate.pk_bm_period = bm_period.pk_bm_period" +
                    " where pk_bm_class = '" + pk_bm_class + "' and year = '" + vo.getCyear() + "' and period = '" + vo.getCperiod() + "')";
            getBaseDao().executeUpdate(sql);
            //޸CLASSVOӦCYEARCPERIOD
            sql = "update bm_bmclass set " +
                    "bm_bmclass.cyear = '" + maxperiod.substring(0, 4) + "', " +
                    "bm_bmclass.cperiod = '" + maxperiod.substring(4, 6) + "' " +
                    "where PK_bm_CLASS='" + pk_bm_class + "'";
            getBaseDao().executeUpdate(sql);

        }
    }

}