package nc.impl.bm.listener;

import nc.bs.businessevent.BusinessEvent;
import nc.bs.businessevent.IBusinessEvent;
import nc.bs.businessevent.IBusinessListener;
import nc.bs.businessevent.IEventType;
import nc.bs.dao.BaseDAO;
import nc.itf.uap.busibean.SysinitAccessor;
import nc.util.bm.BmCacheUtils;
import nc.vo.bm.pub.BmParaConstant;
import nc.vo.hi.psndoc.PsnJobVO;
import nc.vo.hi.pub.HICommonValue;
import nc.vo.hi.pub.HiBatchEventValueObject;
import nc.vo.hi.pub.HiEventValueObject;
import nc.vo.hi.pub.IHiEventType;
import nc.vo.pub.BusinessException;

import nccloud.commons.lang.StringUtils;

/**
 * нӦ±䶯¼
 */
public class BmfileBusinessListener implements IBusinessListener{

	private BmfileListenerDao dao;

	private PsnJobVO psnJobAfter;

	private PsnJobVO psnjobBefore;

	private String pk_org;

	private int changeDate = 0;

	private final String IMODELCODE = "6007";

	public BmfileListenerDao getDao() {
		if (dao == null) {
			return new BmfileListenerDao();
		}
		return dao;
	}

	@Override
	public void doAction(IBusinessEvent event) throws BusinessException {
		BusinessEvent be = (BusinessEvent) event;
		Object obj = be.getObject();
		if(obj == null){
			return;
		}
		//ҵ仯Ĺ¼תԱ仯ǰͱ仯ͬ
		String sourceID = event.getSourceID();
		HiEventValueObject eventObj = null;
		HiBatchEventValueObject batchObj = null;
		if(obj instanceof HiBatchEventValueObject){
			batchObj = (HiBatchEventValueObject)obj;
			for (int i = 0; i < batchObj.getPsnjobs_before().length; i++) {
				eventObj = new HiEventValueObject();
				eventObj.setPsnjob_after(batchObj.getPsnjobs_after()[i]);
				eventObj.setPsnjob_before(batchObj.getPsnjobs_before()[i]);
				doSingle(sourceID,be,eventObj);
			}
		}else{
			doSingle(sourceID,be,obj);
		}
	}

	private void doSingle(String sourceID,BusinessEvent be,Object obj ) throws BusinessException{
		//ҵ仯Ĺ¼תԱ仯ǰͱ仯ͬ

		//ԱϢ仯
		if(!BmCacheUtils.isModuleStarted(IMODELCODE)&&HICommonValue.MD_ID_PSNDOC.equals(sourceID)){
			doInitParam(obj);
			handlePsnInfoChange(be);
			return;
		}
		//¼仯
		if(HICommonValue.PSNJOBSOURCEID.equals(sourceID)) {
			doInitParam(obj);
			handlePsnjobChange(be);
			return;
		}
	}

	private void doInitParam(Object obj) throws BusinessException {
		psnJobAfter = ((HiEventValueObject)obj).getPsnjob_after();
		psnjobBefore = ((HiEventValueObject)obj).getPsnjob_before();

		if (psnJobAfter != null && !StringUtils.isBlank(psnJobAfter.getPk_org())) {
			pk_org = psnJobAfter.getPk_org();
		} else if (psnjobBefore != null && !StringUtils.isBlank(psnjobBefore.getPk_org())) {
			pk_org = psnjobBefore.getPk_org();
		}
		//Ӧڣ0Ӧ,1-31ΪӦ	
		Integer paramValue = SysinitAccessor.getInstance().getParaInt(pk_org,BmParaConstant.CHANGE_DATE);
		if (paramValue != null) {
			changeDate = paramValue.intValue();
		}
	}

	/**
	 * ԱϢ仯
	 * 
	 * @param event BusinessEvent
	 * @throws BusinessException
	 */
	private void handlePsnInfoChange(BusinessEvent event) throws BusinessException{
		String eventType = event.getEventType();
		//ԱϢ(HR0):нʵδԱΪµĹ¼ɾʱHIʷְ¼
		if(IHiEventType.SAVE_EMPLOYEE_AFTER.equals(eventType)) {
			getDao().checkPsnChange(psnJobAfter);

			getDao().updateBmDataByPsnDoc(psnJobAfter, changeDate);

			return;
		}
		//ԱϢɾǰ(HR0):ɾǰУ:ֻҪԱнʵдھͲɾ
		if(IHiEventType.DELETE_EMPLOYEE_BEFORE.equals(eventType)) {
			getDao().checkPsnUsed(psnjobBefore);
			return;
		}
	}

	/**
	 * ¼Ϣ仯
	 * 
	 * @param event BusinessEvent
	 * @throws BusinessException
	 */
	private void handlePsnjobChange(BusinessEvent event) throws BusinessException {
		String eventType = event.getEventType();
		//¼:нʵδԱΪµĹ¼
		if(IEventType.TYPE_INSERT_AFTER.equals(eventType)) {
			getDao().updateBmDataByPsnJob(psnjobBefore, psnJobAfter, changeDate);
			return;
		}
		if(IEventType.TYPE_UPDATE_AFTER.equals(eventType)) {
			BaseDAO d = new BaseDAO();
			// 20231018 dzz 籣 ֯ ǰ job_pk_org pk_dept  bm_glbdef3֯   bm_glbdef4 β  һ Ҫµ   һ¾Ͳ
			String sql = " UPDATE bm_data b  SET b.GLBDEF3 = '" + psnJobAfter.getPk_org() + "' ,b.GLBDEF4 = '" + psnJobAfter.getPk_dept() + "' WHERE b.PK_BM_DATA IN ( " +
					" SELECT bd.PK_BM_DATA FROM BM_DATA bd JOIN BD_PSNJOB job on job.PK_PSNJOB = bd.PK_PSNJOB " +
					" WHERE bd.checkflag = 'N' AND bd.GLBDEF3 = job.PK_ORG  AND bd.GLBDEF4 = job.PK_DEPT AND bd.PK_PSNJOB = '" + psnjobBefore.getPk_psnjob() + "') ";
			d.executeUpdate(sql);
			// 20230731 dzz psnjob ֯ Ҳнʵ
			 sql = " update bm_data set glbdef1 = '"+psnJobAfter.getAttributeValue("jobglbdef6")+"',glbdef2 = '"+ psnJobAfter.getAttributeValue("jobglbdef5")+"' where pk_psnjob = '"+psnjobBefore.getPk_psnjob()+"' and checkflag = 'N'";
			d.executeUpdate(sql);
			getDao().updateBmDataMulVer(psnJobAfter.getPk_psnjob(), null);
			return;
		}
		//ɾǰУ:ֻҪ¼нʵУѾ˵ݣͲɾ
		//δ˵Ҫ޸µĹ¼
		if(IEventType.TYPE_DELETE_BEFORE.equals(eventType)) {
			getDao().checkPsnJobUsed(psnjobBefore);
			//δ˵Ҫи
			getDao().updateBmDataByPsnJob(psnjobBefore, psnJobAfter);
			return;
		}

	}


}
