package nc.impl.bm.listener;

import nc.bs.dao.DAOException;
import nc.bs.framework.common.NCLocator;
import nc.bs.logging.Logger;
import nc.hr.frame.persistence.BaseDAOManager;
import nc.hr.utils.InSQLCreator;
import nc.hr.utils.ResHelper;
import nc.itf.hr.wa.IWaBmfileQueryService;
import nc.jdbc.framework.SQLParameter;
import nc.jdbc.framework.processor.MapProcessor;
import nc.vo.hi.psndoc.PsnJobVO;
import nc.vo.hr.pub.WaBmFileOrgVO;
import nc.vo.hr.tools.pub.GeneralVO;
import nc.vo.pub.BusinessException;
import nccloud.commons.lang.StringUtils;

import java.util.ArrayList;
import java.util.HashMap;

/**
 * нӦ±䶯DAO
 */
public class BmfileListenerDao extends BaseDAOManager {

    private String getFilterSql(PsnJobVO psnjobBefore, PsnJobVO psnJobAfter,
                                int changeDate) throws BusinessException {
        String sql = "  select pk_bm_data,cyear,cperiod from  bm_data "
                + "  where   bm_data.checkflag = 'N'";
//		if (psnjobBefore != null) {
//			sql += " and pk_psnjob = '" + psnjobBefore.getPk_psnjob() + "'";
//		} else {
//		20151223 xiejie3  NCdp205564197 ޸ĲӦ仯е䣬Ȼ޸Ĳ仯е䣬ԱϢûб仯
//		ԭ򣺵䶯ԱҵΪ0ʱ籣Ա¼籣һ¼ job1ʱ¼job1job2
//			ʱٰѲĳ31Ա¼job3´ ¼ Ϊ job2job3ʱjob2ȥ籣ȥƥˣƥ䲻
//		ͨ¼ȥ籣ݣԱѯصδ˵籣ȻٺҵбȽǷҪ
        sql += " and pk_psndoc = '" + psnJobAfter.getPk_psndoc() + "'";
//			end
//		}
        GeneralVO[] generalVOs = executeQueryVOs(sql, GeneralVO.class);

        String cchangeDay = "" + changeDate;
        String cchangeDate = "";
        if (changeDate < 10) {
            cchangeDay = "0" + changeDate;
        }
        ArrayList<String> dataPkList = new ArrayList<String>();
        for (GeneralVO generalVO : generalVOs) {
            cchangeDate = generalVO.getAttributeValue("cyear").toString() + "-"
                    + generalVO.getAttributeValue("cperiod").toString() + "-"
                    + cchangeDay;

            if (cchangeDate.compareTo(psnJobAfter.getBegindate().toString()) >= 0) {
                dataPkList.add(generalVO.getAttributeValue("pk_bm_data")
                        .toString());
            }
        }
        String filterSql = "";
        if (dataPkList.isEmpty()) {
            return filterSql;
        }
        InSQLCreator inC = new InSQLCreator();
        try {
            filterSql = " and pk_bm_data in ("
                    + inC.getInSQL(dataPkList.toArray(new String[0])) + ")";

        } catch (BusinessException e) {
            throw new DAOException(e);
        }
        return filterSql;
    }

    /**
     * нʵҪָڹ
     *
     * @param psnjobBefore PsnJobVO
     * @param psnJobAfter  PsnJobVO
     * @throws BusinessException
     */
    public void updateBmDataByPsnJob(PsnJobVO psnjobBefore,
                                     PsnJobVO psnJobAfter, int changeDate) throws BusinessException {
        if (psnJobAfter == null) {
            return;
        }
        String filterSql = getFilterSql(psnjobBefore, psnJobAfter, changeDate);
        if (StringUtils.isEmpty(filterSql)) {
            return;
        }
        //String sql = "";

        // 20231018 dzz 籣 ֯ ǰ job_pk_org pk_dept  bm_glbdef3֯   bm_glbdef4 β  һ Ҫµ   һ¾Ͳ
        String sql = " UPDATE bm_data b  SET b.GLBDEF3 = '" + psnJobAfter.getPk_org() + "' ,b.GLBDEF4 = '" + psnJobAfter.getPk_dept() + "' WHERE b.pk_bm_data IN ( " +
                " SELECT bd.pk_bm_data FROM bm_data bd JOIN BD_PSNJOB job on job.PK_PSNJOB = bd.PK_PSNJOB " +
                " WHERE bd.checkflag = 'N' AND bd.GLBDEF3 = job.PK_ORG  AND bd.GLBDEF4 = job.PK_DEPT AND bd.PK_PSNJOB = '" + psnjobBefore.getPk_psnjob() + "') ";
        getBaseDao().executeUpdate(sql);


         sql = " update bm_data set pk_psnjob = '"
//		20151223 xiejie3  NCdp205564197 ޸ĲӦ仯е䣬Ȼ޸Ĳ仯е䣬ԱϢûб仯
//		ԭ򣺵䶯ԱҵΪ0ʱ籣Ա¼籣һ¼ job1ʱ¼job1job2
//			ʱٰѲĳ31Ա¼job3´ ¼ Ϊ job2job3ʱjob2ȥ籣ȥƥˣƥ䲻
//		ͨ¼ȥ籣ݣԱѯصδ˵籣ȻٺҵбȽǷҪ
//					+ psnJobAfter.getPk_psnjob() + "' where pk_psnjob = '"
//					+ psnjobBefore.getPk_psnjob() + "' and checkflag = 'N'";

                + psnJobAfter.getPk_psnjob() + "',glbdef1 = '" + psnJobAfter.getAttributeValue("jobglbdef6") + "',glbdef2 = '" + psnJobAfter.getAttributeValue("jobglbdef6")
                + "' where  checkflag = 'N' ";
//			end
        sql += filterSql;
        getBaseDao().executeUpdate(sql);
        updateBmDataMulVer(psnJobAfter.getPk_psnjob(), filterSql);

    }

    /**
     * нʵ
     *
     * @param psnjobBefore PsnJobVO
     * @param psnJobAfter  PsnJobVO
     * @throws BusinessException
     */
    public void updateBmDataByPsnJob(PsnJobVO psnjobBefore, PsnJobVO psnJobAfter) throws BusinessException {
        if (psnJobAfter == null) {
            return;
        }
        // 20231018 dzz 籣 ֯ ǰ job_pk_org pk_dept  bm_glbdef3֯   bm_glbdef4 β  һ Ҫµ   һ¾Ͳ
        String sql = " UPDATE bm_data b  SET b.GLBDEF3 = '" + psnJobAfter.getPk_org() + "' ,b.GLBDEF4 = '" + psnJobAfter.getPk_dept() + "' WHERE b.pk_bm_data IN ( " +
                " SELECT bd.pk_bm_data FROM bm_data bd JOIN BD_PSNJOB job on job.PK_PSNJOB = bd.PK_PSNJOB " +
                " WHERE bd.checkflag = 'N' AND bd.GLBDEF3 = job.PK_ORG  AND bd.GLBDEF4 = job.PK_DEPT AND bd.PK_PSNJOB = '" + psnjobBefore.getPk_psnjob() + "') ";
        getBaseDao().executeUpdate(sql);

         sql = " update bm_data set pk_psnjob = '" + psnJobAfter.getPk_psnjob() + "',glbdef1 = '" + psnJobAfter.getAttributeValue("jobglbdef6") + "',glbdef2 = '" + psnJobAfter.getAttributeValue("jobglbdef6")
                + "' where pk_psnjob = '" + psnjobBefore.getPk_psnjob() + "' and checkflag = 'N'";

        getBaseDao().executeUpdate(sql);
        updateBmDataMulVer(psnJobAfter.getPk_psnjob(), null);
    }

    /**
     * нʵ
     *
     * @param psnjobBefore PsnJobVO
     * @param psnJobAfter  PsnJobVO
     * @throws BusinessException
     */
    public void updateBmDataByPsnDoc(PsnJobVO psnJobAfter, int changeDate)
            throws BusinessException {
        String filterSql = getFilterSql(null, psnJobAfter, changeDate);
        if (StringUtils.isEmpty(filterSql)
                && changeDate < psnJobAfter.getBegindate().getDay()) {
            return;
        }
        // 20231018 dzz 籣 ֯ ǰ job_pk_org pk_dept  bm_glbdef3֯   bm_glbdef4 β  һ Ҫµ   һ¾Ͳ
        String sql = " UPDATE bm_data b  SET b.GLBDEF3 = '" + psnJobAfter.getPk_org() + "' ,b.GLBDEF4 = '" + psnJobAfter.getPk_dept() + "' WHERE b.pk_bm_data IN ( " +
                " SELECT bd.pk_bm_data FROM bm_data bd JOIN BD_PSNJOB job on job.PK_PSNJOB = bd.PK_PSNJOB " +
                " WHERE bd.checkflag = 'N' AND bd.GLBDEF3 = job.PK_ORG  AND bd.GLBDEF4 = job.PK_DEPT AND bd.PK_PSNJOB = '" + psnJobAfter.getPk_psnjob() + "') ";
        getBaseDao().executeUpdate(sql);
         sql = "update bm_data set pk_psnjob = '" + psnJobAfter.getPk_psnjob()+ "',glbdef1 = '" + psnJobAfter.getAttributeValue("jobglbdef6") + "',glbdef2 = '" + psnJobAfter.getAttributeValue("jobglbdef6") + "' where pk_psndoc = '" + psnJobAfter.getPk_psndoc() + "' and checkflag = 'N'";
        sql += filterSql;
        getBaseDao().executeUpdate(sql);
        updateBmDataMulVer(psnJobAfter.getPk_psnjob(), filterSql);
    }

    /**
     * ¶汾Ϣ
     *
     * @param pk_psnjob
     * @throws DAOException 20220322ղƷ¹滮Աְ¼仯ʱδ˵籣Ĳְɱ֯ŶҪı
     */
    public void updateBmDataMulVer(String pk_psnjob, String filterSql)
            throws DAOException {
        WaBmFileOrgVO payOrgVO = new WaBmFileOrgVO();
        String pk_financeorg = null;
        String pk_financedept = null;
        String fiporgvid = null;
        String fipdeptvid = null;
        String pk_costcenter = null;
        try {
            // 2015-10-23 zhousze жϸVOǷΪ begin
            //20151212 shenliangc Աְ¼ûжӦ֯нʵ±
            payOrgVO = NCLocator.getInstance().lookup(IWaBmfileQueryService.class).getPkFinanceOrg(pk_psnjob);
            if (payOrgVO != null) {
                pk_financeorg = payOrgVO.getPk_financeorg();
                pk_financedept = payOrgVO.getPk_financedept();
                fiporgvid = payOrgVO.getFiporgvid();
                fipdeptvid = payOrgVO.getFipdeptvid();
                StringBuffer sbd = new StringBuffer();
                sbd.append(" select resa_costcenter.pk_costcenter pk_costcenter from resa_costcenter, resa_ccdepts ");
                sbd.append(" where resa_costcenter.pk_costcenter = resa_ccdepts.pk_costcenter and resa_ccdepts.pk_dept in ");
                sbd.append(" (SELECT org_dept.pk_dept FROM hi_psnjob,org_dept,bm_data WHERE ");
                sbd.append(" bm_data.pk_psnjob = hi_psnjob.pk_psnjob AND hi_psnjob.pk_dept = org_dept.pk_dept");
                sbd.append(" and bm_data.checkflag = 'N' and bm_data.pk_psnjob = '" + pk_psnjob + "' )");
                sbd.append(" and resa_costcenter.enablestate = '2'");
                HashMap<String, String> map4lo = (HashMap<String, String>) getBaseDao().executeQuery(sbd.toString(), new MapProcessor());
                if (map4lo != null && map4lo.size() > 0) {
                    pk_costcenter = map4lo.get("pk_costcenter");
                }
            }
            // end
        } catch (BusinessException e) {
            Logger.error(e.getMessage(), e);
        }
        String sqlfi = (pk_financeorg != null ? " , pk_financeorg = '" + pk_financeorg + "'" : " , pk_financeorg = null ")
                + (pk_financedept != null ? " , pk_financedept = '" + pk_financedept + "'" : " , pk_financedept = null ")
                + (fiporgvid != null ? " , fiporgvid = '" + fiporgvid + "'" : " , fiporgvid = null ")
                + (fipdeptvid != null ? " , fipdeptvid = '" + fipdeptvid + "'" : " , fipdeptvid = null ");
        String sql = "UPDATE bm_data "
                + " SET workorg = (SELECT org_orgs.pk_org "
                + "				FROM hi_psnjob,org_orgs "
                + "				WHERE bm_data.pk_psnjob = hi_psnjob.pk_psnjob "
                + "					AND hi_psnjob.pk_org = org_orgs.pk_org " + "	) "
                + "	, workorgvid = (SELECT org_orgs.pk_vid "
                + "					FROM hi_psnjob,org_orgs "
                + "					WHERE bm_data.pk_psnjob = hi_psnjob.pk_psnjob "
                + "						AND hi_psnjob.pk_org = org_orgs.pk_org " + "	) "
                + "	, workdept = (	SELECT org_dept.pk_dept "
                + "					FROM hi_psnjob,org_dept "
                + "					WHERE bm_data.pk_psnjob = hi_psnjob.pk_psnjob "
                + "						AND hi_psnjob.pk_dept = org_dept.pk_dept " + "	) "
                + "	, workdeptvid = (	SELECT org_dept.pk_vid "
                + "						FROM hi_psnjob,org_dept "
                + "						WHERE bm_data.pk_psnjob = hi_psnjob.pk_psnjob "
                + "							AND hi_psnjob.pk_dept = org_dept.pk_dept "
                + "	) "
                + sqlfi;

        if (StringUtils.isNotBlank(pk_costcenter)) {
            sql += ", pk_liabilityorg = '" + pk_costcenter + "'"
                    + "	, pk_liabilitydept = (SELECT org_dept.pk_dept FROM hi_psnjob,org_dept WHERE "
                    + "                     bm_data.pk_psnjob = hi_psnjob.pk_psnjob AND hi_psnjob.pk_dept = org_dept.pk_dept )"
                    + "	, libdeptvid = (SELECT org_dept.pk_vid FROM hi_psnjob,org_dept WHERE bm_data.pk_psnjob = hi_psnjob.pk_psnjob AND "
                    + "						hi_psnjob.pk_dept = org_dept.pk_dept ) ";
        } else {
            sql += ", pk_liabilityorg = null"
                    + "	, pk_liabilitydept = null "
                    + "	, libdeptvid = null ";
        }
        sql += " WHERE bm_data.checkflag = 'N' and pk_psnjob = ?";
        if (!StringUtils.isEmpty(filterSql)) {
            sql += filterSql;
        }
        SQLParameter param = new SQLParameter();
        param.addParam(pk_psnjob);
        getBaseDao().executeUpdate(sql, param);
    }

    /**
     * 鹤¼Ƿ
     *
     * @param psnjobBefore PsnJobVO
     * @throws BusinessException
     */
    public void checkPsnJobUsed(PsnJobVO psnjobBefore) throws BusinessException {
        String sql = " select pk_psndoc from bm_data where pk_psnjob = '" + psnjobBefore.getPk_psnjob() + "' and  checkflag = 'Y' ";
        if (isValueExist(sql)) {
            throw new BusinessException(ResHelper.getString("60150bmdata", "060150bmdata0078")
                    /*@res "ѱãɾ"*/);
        }
    }

    /**
     * ԱϢǷ
     *
     * @param psnjobBefore PsnJobVO
     * @throws BusinessException
     */
    public void checkPsnUsed(PsnJobVO psnjobBefore) throws BusinessException {
        String sql = "select pk_psndoc from bm_data where pk_psndoc = '" + psnjobBefore.getPk_psndoc() + "'";
        if (isValueExist(sql)) {
            throw new BusinessException(ResHelper.getString("60150bmdata", "060150bmdata0078")
                    /*@res "ѱãɾ"*/);
        }
    }

    /**
     * 鹤¼Ƿ
     *
     * @param psnJobAfter PsnJobVO
     * @throws BusinessException
     */
    public void checkPsnChange(PsnJobVO psnJobAfter) throws BusinessException {
        String sql = "select pk_psndoc from bm_data where pk_psndoc = '" + psnJobAfter.getPk_psndoc() + "' and  pk_psnjob not in(select pk_psnjob from hi_psnjob where pk_psndoc = '" + psnJobAfter.getPk_psndoc() + "')";
        if (isValueExist(sql)) {
            throw new BusinessException(ResHelper.getString("60150bmdata", "060150bmdata0078")
                    /*@res "ѱãɾ"*/);
        }
    }
}