package nc.itf.hr.bm;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import nc.bs.framework.common.NCLocator;
import nc.bs.logging.Logger;
import nc.hr.utils.ResHelper;
import nc.vo.bm.bmclass.BmClassItemVO;
import nc.vo.bm.file.BmBaseDspVO;
import nc.vo.bm.item.BmItemVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFBoolean;

import nccloud.commons.lang.ArrayUtils;
import nccloud.commons.lang.StringUtils;


public class BmBaseDspUtil<E extends BmBaseDspVO> {
	/*ʽ*/
	public static final String PERSONALDSP = "1";
	public static final String COMMONDSP = "0";
	
	public static final String PSNCODE = "psncode" ;/*Ա*/
	public static final String CLERKCODE = "clerkcode" ;/*Ա*/
	public static final String PSNNAME = "psnname" ;/**/
	public static final String PLSNAME = "plsname" ;/*Ա*/
	public static final String ORGNAME = "orgname" ;/*ְ֯*/
	public static final String DEPTNAME = "deptname" ;/*ڲ*/
	public static final String POSTNAME = "postname" ;/*ڸλ*/
	public static final String CLASSCODE = "classcode" ;/*ֱ*/
	public static final String BMCLASSNAME = "classname" ;/**/
	public static final String CACULATEFLAG = "caculateflag" ;/*־*/
	public static final String CHECKFLAG = "checkflag" ;/*˱־*/
	public static final String CYEAR = "cyear" ;/**/
	public static final String CPERIOD = "cperiod" ;/*ڼ*/
	public static final String FINANCEORGNAME="financeorgname";/*֯*/
	public static final String FINANCEDEPTNAME="financedeptname";/**/
	public static final String LOCATIONNAME = "locationname" ;/*ɽ*/
	public static final String GLBDEF1 = "glbdef1" ;/*ERP֯*/
	public static final String GLBDEF2 = "glbdef2" ;/*ERP*/
//	20151112  xiejie3  NCdp205540298 бʾãĬϵʾ˳ӦԱ롢ԱšԱְְ֯šְλ֯šֱ롢ơɽء־ȡڼ估ɽĿϵǰ˳
	//нʵĬʾֶμ˳
	public final static String[] defaultShowColKey = new String[]{
		PSNCODE/*Ա*/,
		CLERKCODE/*Ա*/,
		PSNNAME/**/,
		PLSNAME/*Ա*/,
		ORGNAME/*ְ֯*/,
		DEPTNAME/*ڲ*/,
		POSTNAME/*ڸλ*/,
//		FINANCEORGNAME/*֯*/,
//		FINANCEDEPTNAME/**/,
		CLASSCODE/*ֱ*/,
		BMCLASSNAME/**/,
		LOCATIONNAME/*ɽ*/,
		CACULATEFLAG/*־*/,
		CHECKFLAG/*˱־*/,
		CYEAR/**/,
		CPERIOD/*ڼ*/,
		GLBDEF1,
		GLBDEF2

	};
//	end	
	protected static Map<String,String> initShowNameMap(){
		Map<String,String> nameMap = new HashMap<String, String>();
		nameMap.put(PSNCODE, ResHelper.getString("commonres", "UC000-0000147")/*@res "Ա */);
		nameMap.put(CLERKCODE, ResHelper.getString("60150bmdata","160150bmdata0002")/*@res "Ա"*/);
		nameMap.put(PSNNAME, ResHelper.getString("60150bmdata","160150bmdata0003")/*@res ""*/);
		nameMap.put(PLSNAME, ResHelper.getString("60150bmdata","160150bmdata0004")/*@res "Ա"*/);
		nameMap.put(ORGNAME, ResHelper.getString("60150bmdata","160150bmdata0005")/*@res "ְ֯"*/);
		nameMap.put(DEPTNAME, ResHelper.getString("60150bmdata","160150bmdata0006")/*@res "ڲ"*/);
		nameMap.put(POSTNAME, ResHelper.getString("60150bmdata","160150bmdata0007")/*@res "ڸλ"*/);
		nameMap.put(CLASSCODE, ResHelper.getString("60150bmdata","160150bmdata0008")/*@res "ֱ"*/);
		nameMap.put(BMCLASSNAME, ResHelper.getString("60150bmdata","160150bmdata0009")/*@res ""*/);
		nameMap.put(CACULATEFLAG, ResHelper.getString("60150bmdata","160150bmdata0010")/*@res "־"*/);
		nameMap.put(CHECKFLAG, ResHelper.getString("60150bmdata","160150bmdata0011")/*@res "˱־"*/);
		nameMap.put(CYEAR, ResHelper.getString("60150bmdata","160150bmdata0012")/*@res ""*/);
		nameMap.put(CPERIOD, ResHelper.getString("60150bmdata","160150bmdata0013")/*@res "ڼ"*/);
//		nameMap.put(FINANCEORGNAME, ResHelper.getString("60150bmdata","160150bmdata0015")/*@res "֯"*/);
//		nameMap.put(FINANCEDEPTNAME, ResHelper.getString("60150bmdata","160150bmdata0016")/*@res ""*/);
		nameMap.put(LOCATIONNAME, ResHelper.getString("60150bmdata","160150bmdata0017")/*@res "ɽ"*/);
		nameMap.put(GLBDEF1, "ERP֯");
		nameMap.put(GLBDEF2, "ERP");
		return nameMap;
	}
	
	private Class className;
	
	
	
	public Class getClassName() {
		return className;
	}

	public void setClassName(Class className) {
		this.className = className;
	}

	/**
	 * getColMap()ѯĽתList<BmdataDspVO>
	 * 
	 * @param colMap
	 * @return
	 */
	public List<E> queryDefaultDsp() {
		List<E> dspList = new ArrayList<E>();
		Map<String,String> showNameMap = initShowNameMap();
		for(int i=0;i<defaultShowColKey.length;i++){
			E vo = newObject();
			vo.setItem_key(defaultShowColKey[i]);
			vo.setItemName(showNameMap.get(defaultShowColKey[i]));
			vo.setBshow(UFBoolean.TRUE);
			vo.setIsBmItem(UFBoolean.FALSE);
			dspList.add((E) vo);
			
		}
		return dspList;
	}
	
	private  E newObject(){
		E vo = null;
		try {
			vo = (E) className.newInstance();
		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			Logger.error(e.getMessage(),e);
		} catch (IllegalAccessException e) {
			Logger.error(e.getMessage(), e);
		}
		return vo;
	}
	
	private  E convertBmItemVO(BmClassItemVO itemVO){
		E dspVO = newObject();
		dspVO.setItem_key(itemVO.getItemkey());
		dspVO.setItemName(itemVO.getMultilangName());
		//ʾӦȨã޸нĿȨ޺޸ġ
		dspVO.setBshow(UFBoolean.TRUE);
		dspVO.setIsBmItem(UFBoolean.TRUE);
		return (E) dspVO;
	}
	
	/**
	 * ѽɽĿתʾĿ
	 * @param itemArray
	 * @return
	 */
	public  List<E> convertBmItemVO(BmClassItemVO[] itemArray){
		List<E> dspList = new ArrayList<E>();
		if(!ArrayUtils.isEmpty(itemArray)){
			for(int i=0;i<itemArray.length;i++){
				dspList.add(convertBmItemVO(itemArray[i]));
			}
		}
		return dspList;
	}
	
	/**
	 * нʷʾãҳʾĶ
	 * @param dspList
	 * @return
	 */
	public  List<E> setBmfileDisplayName(List<E> dspList) {
		IBmItemQueryService bmItemQueryService = NCLocator.getInstance().lookup(IBmItemQueryService.class);
		Map<String,String> showNameMap = initShowNameMap();
		for (int i = 0; i < dspList.size(); i++) {
			E dspVO = dspList.get(i);
			if(dspVO.getIsBmItem().booleanValue()){
				try {
					BmItemVO[] itemVOs = bmItemQueryService.queryByOrg(dspVO.getPk_group(), dspVO.getPk_org(), " itemkey='"+dspVO.getItem_key()+"'");
					if (itemVOs != null&&itemVOs.length>0) {
						if (StringUtils.isNotEmpty(itemVOs[0].getMultilangName())) {
							dspList.get(i).setItemName(itemVOs[0].getMultilangName());
						}else{
							dspList.get(i).setItemName(itemVOs[0].getName());
						}
					}
				}catch (BusinessException e) {
					Logger.error(e.getMessage());
				}
			}else{
				dspList.get(i).setItemName(showNameMap.get(dspList.get(i).getItem_key()));
			}
		}
		return dspList;
	}
//	NCdp205541842   xiejie3   ԱʾĿظЧ. 
//	д˴˷
	/**
	 * ʾ˳֮󣬷¼ӵĿҪ
	 * @param dspList
	 * @param itemArray
	 */
//	public  void addNewlyDsiplayItem3(List<E> dspList,
//			BmClassItemVO[] itemArray) {
//		if (ArrayUtils.isEmpty(itemArray) || dspList == null) {
//			return;
//		}
//		Map<String, String> dspItemMap = new HashMap<String, String>();
//		for (E dspVO : dspList) {
//			if (dspVO.getIsBmItem().booleanValue()) {
//				dspItemMap.put(dspVO.getItem_key(), dspVO.getItem_key());
//			}
//		}
//		for (int i = 0; i < itemArray.length; i++) {
//			if(!dspItemMap.containsKey(itemArray[i].getItemkey())){
//				dspList.add(convertBmItemVO(itemArray[i]));
//			}
//		}
//	}
//	end
	/**
	 * ʾ˳֮󣬷¼ӵĿҪ
	 * ʾ˳֮󣬷ɾĿҪɾڲȷǷȨ޲ѯĿ٣Դ˴йˡ
	 * @param dspList
	 * @param itemArray
	 */
	
//	NCdp205541842   xiejie3   ԱʾĿظЧ. 
	public  void addNewlyDsiplayItem(List<E> dspList,
			BmClassItemVO[] itemArray) {
		if (ArrayUtils.isEmpty(itemArray) || dspList == null) {
			return;
		}
//		xiejie3  ɾʾĿҲҪɾˡ
		Map<String, BmClassItemVO> itemMap = new HashMap<String, BmClassItemVO>();
		for(BmClassItemVO   item: itemArray){
			itemMap.put(item.getItemkey(), item);
		}
		List<E> deleteList=new ArrayList<E>();
		for(E dspVO : dspList ){
			if (dspVO.getIsBmItem().booleanValue()) {
				if(!itemMap.containsKey(dspVO.getItem_key())){
					deleteList.add(dspVO);
				}
			}
		}
		dspList.removeAll(deleteList);
		
		Map<String, String> dspItemMap = new HashMap<String, String>();
		for (E dspVO : dspList) {
			if (dspVO.getIsBmItem().booleanValue()) {
				dspItemMap.put(dspVO.getItem_key(), dspVO.getItem_key());
			}
		}
		for (int i = 0; i < itemArray.length; i++) {
			if(!dspItemMap.containsKey(itemArray[i].getItemkey())){
				dspList.add(convertBmItemVO(itemArray[i]));
			}
		}
	}
	
//	end
	
	
	
}
